// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rosee_msg:msg/GraspingPrimitiveAggregated.idl
// generated code does not contain a copyright notice
#include "rosee_msg/msg/detail/grasping_primitive_aggregated__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `action_name`
// Member `selectable_names`
#include "rosidl_runtime_c/string_functions.h"

bool
rosee_msg__msg__GraspingPrimitiveAggregated__init(rosee_msg__msg__GraspingPrimitiveAggregated * msg)
{
  if (!msg) {
    return false;
  }
  // action_name
  if (!rosidl_runtime_c__String__init(&msg->action_name)) {
    rosee_msg__msg__GraspingPrimitiveAggregated__fini(msg);
    return false;
  }
  // primitive_type
  // selectable_names
  if (!rosidl_runtime_c__String__Sequence__init(&msg->selectable_names, 0)) {
    rosee_msg__msg__GraspingPrimitiveAggregated__fini(msg);
    return false;
  }
  // max_selectable
  return true;
}

void
rosee_msg__msg__GraspingPrimitiveAggregated__fini(rosee_msg__msg__GraspingPrimitiveAggregated * msg)
{
  if (!msg) {
    return;
  }
  // action_name
  rosidl_runtime_c__String__fini(&msg->action_name);
  // primitive_type
  // selectable_names
  rosidl_runtime_c__String__Sequence__fini(&msg->selectable_names);
  // max_selectable
}

bool
rosee_msg__msg__GraspingPrimitiveAggregated__are_equal(const rosee_msg__msg__GraspingPrimitiveAggregated * lhs, const rosee_msg__msg__GraspingPrimitiveAggregated * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // action_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->action_name), &(rhs->action_name)))
  {
    return false;
  }
  // primitive_type
  if (lhs->primitive_type != rhs->primitive_type) {
    return false;
  }
  // selectable_names
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->selectable_names), &(rhs->selectable_names)))
  {
    return false;
  }
  // max_selectable
  if (lhs->max_selectable != rhs->max_selectable) {
    return false;
  }
  return true;
}

bool
rosee_msg__msg__GraspingPrimitiveAggregated__copy(
  const rosee_msg__msg__GraspingPrimitiveAggregated * input,
  rosee_msg__msg__GraspingPrimitiveAggregated * output)
{
  if (!input || !output) {
    return false;
  }
  // action_name
  if (!rosidl_runtime_c__String__copy(
      &(input->action_name), &(output->action_name)))
  {
    return false;
  }
  // primitive_type
  output->primitive_type = input->primitive_type;
  // selectable_names
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->selectable_names), &(output->selectable_names)))
  {
    return false;
  }
  // max_selectable
  output->max_selectable = input->max_selectable;
  return true;
}

rosee_msg__msg__GraspingPrimitiveAggregated *
rosee_msg__msg__GraspingPrimitiveAggregated__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__msg__GraspingPrimitiveAggregated * msg = (rosee_msg__msg__GraspingPrimitiveAggregated *)allocator.allocate(sizeof(rosee_msg__msg__GraspingPrimitiveAggregated), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosee_msg__msg__GraspingPrimitiveAggregated));
  bool success = rosee_msg__msg__GraspingPrimitiveAggregated__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosee_msg__msg__GraspingPrimitiveAggregated__destroy(rosee_msg__msg__GraspingPrimitiveAggregated * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosee_msg__msg__GraspingPrimitiveAggregated__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosee_msg__msg__GraspingPrimitiveAggregated__Sequence__init(rosee_msg__msg__GraspingPrimitiveAggregated__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__msg__GraspingPrimitiveAggregated * data = NULL;

  if (size) {
    data = (rosee_msg__msg__GraspingPrimitiveAggregated *)allocator.zero_allocate(size, sizeof(rosee_msg__msg__GraspingPrimitiveAggregated), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosee_msg__msg__GraspingPrimitiveAggregated__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosee_msg__msg__GraspingPrimitiveAggregated__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosee_msg__msg__GraspingPrimitiveAggregated__Sequence__fini(rosee_msg__msg__GraspingPrimitiveAggregated__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosee_msg__msg__GraspingPrimitiveAggregated__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosee_msg__msg__GraspingPrimitiveAggregated__Sequence *
rosee_msg__msg__GraspingPrimitiveAggregated__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__msg__GraspingPrimitiveAggregated__Sequence * array = (rosee_msg__msg__GraspingPrimitiveAggregated__Sequence *)allocator.allocate(sizeof(rosee_msg__msg__GraspingPrimitiveAggregated__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosee_msg__msg__GraspingPrimitiveAggregated__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosee_msg__msg__GraspingPrimitiveAggregated__Sequence__destroy(rosee_msg__msg__GraspingPrimitiveAggregated__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosee_msg__msg__GraspingPrimitiveAggregated__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosee_msg__msg__GraspingPrimitiveAggregated__Sequence__are_equal(const rosee_msg__msg__GraspingPrimitiveAggregated__Sequence * lhs, const rosee_msg__msg__GraspingPrimitiveAggregated__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosee_msg__msg__GraspingPrimitiveAggregated__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosee_msg__msg__GraspingPrimitiveAggregated__Sequence__copy(
  const rosee_msg__msg__GraspingPrimitiveAggregated__Sequence * input,
  rosee_msg__msg__GraspingPrimitiveAggregated__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosee_msg__msg__GraspingPrimitiveAggregated);
    rosee_msg__msg__GraspingPrimitiveAggregated * data =
      (rosee_msg__msg__GraspingPrimitiveAggregated *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosee_msg__msg__GraspingPrimitiveAggregated__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosee_msg__msg__GraspingPrimitiveAggregated__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosee_msg__msg__GraspingPrimitiveAggregated__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
