// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rosee_msg:msg/GraspingPrimitiveAggregated.idl
// generated code does not contain a copyright notice

#ifndef ROSEE_MSG__MSG__DETAIL__GRASPING_PRIMITIVE_AGGREGATED__STRUCT_HPP_
#define ROSEE_MSG__MSG__DETAIL__GRASPING_PRIMITIVE_AGGREGATED__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__rosee_msg__msg__GraspingPrimitiveAggregated __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__msg__GraspingPrimitiveAggregated __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GraspingPrimitiveAggregated_
{
  using Type = GraspingPrimitiveAggregated_<ContainerAllocator>;

  explicit GraspingPrimitiveAggregated_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->action_name = "";
      this->primitive_type = 0;
      this->max_selectable = 0;
    }
  }

  explicit GraspingPrimitiveAggregated_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : action_name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->action_name = "";
      this->primitive_type = 0;
      this->max_selectable = 0;
    }
  }

  // field types and members
  using _action_name_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _action_name_type action_name;
  using _primitive_type_type =
    uint8_t;
  _primitive_type_type primitive_type;
  using _selectable_names_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _selectable_names_type selectable_names;
  using _max_selectable_type =
    uint8_t;
  _max_selectable_type max_selectable;

  // setters for named parameter idiom
  Type & set__action_name(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->action_name = _arg;
    return *this;
  }
  Type & set__primitive_type(
    const uint8_t & _arg)
  {
    this->primitive_type = _arg;
    return *this;
  }
  Type & set__selectable_names(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->selectable_names = _arg;
    return *this;
  }
  Type & set__max_selectable(
    const uint8_t & _arg)
  {
    this->max_selectable = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t PRIMITIVE_PINCHSTRONG =
    0u;
  static constexpr uint8_t PRIMITIVE_PINCHWEAK =
    1u;
  static constexpr uint8_t PRIMITIVE_MULTIPLEPINCHSTRONG =
    2u;
  static constexpr uint8_t PRIMITIVE_TRIG =
    3u;
  static constexpr uint8_t PRIMITIVE_TIPFLEX =
    4u;
  static constexpr uint8_t PRIMITIVE_FINGFLEX =
    5u;
  static constexpr uint8_t PRIMITIVE_SINGLEJOINTMULTIPLETIPS =
    6u;
  static constexpr uint8_t PRIMITIVE_NONE =
    7u;

  // pointer types
  using RawPtr =
    rosee_msg::msg::GraspingPrimitiveAggregated_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::msg::GraspingPrimitiveAggregated_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::msg::GraspingPrimitiveAggregated_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::msg::GraspingPrimitiveAggregated_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::msg::GraspingPrimitiveAggregated_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::msg::GraspingPrimitiveAggregated_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::msg::GraspingPrimitiveAggregated_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::msg::GraspingPrimitiveAggregated_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::msg::GraspingPrimitiveAggregated_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::msg::GraspingPrimitiveAggregated_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__msg__GraspingPrimitiveAggregated
    std::shared_ptr<rosee_msg::msg::GraspingPrimitiveAggregated_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__msg__GraspingPrimitiveAggregated
    std::shared_ptr<rosee_msg::msg::GraspingPrimitiveAggregated_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GraspingPrimitiveAggregated_ & other) const
  {
    if (this->action_name != other.action_name) {
      return false;
    }
    if (this->primitive_type != other.primitive_type) {
      return false;
    }
    if (this->selectable_names != other.selectable_names) {
      return false;
    }
    if (this->max_selectable != other.max_selectable) {
      return false;
    }
    return true;
  }
  bool operator!=(const GraspingPrimitiveAggregated_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GraspingPrimitiveAggregated_

// alias to use template instance with default allocator
using GraspingPrimitiveAggregated =
  rosee_msg::msg::GraspingPrimitiveAggregated_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t GraspingPrimitiveAggregated_<ContainerAllocator>::PRIMITIVE_PINCHSTRONG;
template<typename ContainerAllocator>
constexpr uint8_t GraspingPrimitiveAggregated_<ContainerAllocator>::PRIMITIVE_PINCHWEAK;
template<typename ContainerAllocator>
constexpr uint8_t GraspingPrimitiveAggregated_<ContainerAllocator>::PRIMITIVE_MULTIPLEPINCHSTRONG;
template<typename ContainerAllocator>
constexpr uint8_t GraspingPrimitiveAggregated_<ContainerAllocator>::PRIMITIVE_TRIG;
template<typename ContainerAllocator>
constexpr uint8_t GraspingPrimitiveAggregated_<ContainerAllocator>::PRIMITIVE_TIPFLEX;
template<typename ContainerAllocator>
constexpr uint8_t GraspingPrimitiveAggregated_<ContainerAllocator>::PRIMITIVE_FINGFLEX;
template<typename ContainerAllocator>
constexpr uint8_t GraspingPrimitiveAggregated_<ContainerAllocator>::PRIMITIVE_SINGLEJOINTMULTIPLETIPS;
template<typename ContainerAllocator>
constexpr uint8_t GraspingPrimitiveAggregated_<ContainerAllocator>::PRIMITIVE_NONE;

}  // namespace msg

}  // namespace rosee_msg

#endif  // ROSEE_MSG__MSG__DETAIL__GRASPING_PRIMITIVE_AGGREGATED__STRUCT_HPP_
