// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rosee_msg:msg/MotorPhalangePressure.idl
// generated code does not contain a copyright notice

#ifndef ROSEE_MSG__MSG__DETAIL__MOTOR_PHALANGE_PRESSURE__STRUCT_HPP_
#define ROSEE_MSG__MSG__DETAIL__MOTOR_PHALANGE_PRESSURE__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__rosee_msg__msg__MotorPhalangePressure __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__msg__MotorPhalangePressure __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MotorPhalangePressure_
{
  using Type = MotorPhalangePressure_<ContainerAllocator>;

  explicit MotorPhalangePressure_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit MotorPhalangePressure_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _name_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _name_type name;
  using _pressure_finger1_type =
    std::vector<double, typename ContainerAllocator::template rebind<double>::other>;
  _pressure_finger1_type pressure_finger1;
  using _pressure_finger2_type =
    std::vector<double, typename ContainerAllocator::template rebind<double>::other>;
  _pressure_finger2_type pressure_finger2;
  using _pressure_finger3_type =
    std::vector<double, typename ContainerAllocator::template rebind<double>::other>;
  _pressure_finger3_type pressure_finger3;
  using _pressure_thumb_type =
    std::vector<double, typename ContainerAllocator::template rebind<double>::other>;
  _pressure_thumb_type pressure_thumb;

  // setters for named parameter idiom
  Type & set__name(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__pressure_finger1(
    const std::vector<double, typename ContainerAllocator::template rebind<double>::other> & _arg)
  {
    this->pressure_finger1 = _arg;
    return *this;
  }
  Type & set__pressure_finger2(
    const std::vector<double, typename ContainerAllocator::template rebind<double>::other> & _arg)
  {
    this->pressure_finger2 = _arg;
    return *this;
  }
  Type & set__pressure_finger3(
    const std::vector<double, typename ContainerAllocator::template rebind<double>::other> & _arg)
  {
    this->pressure_finger3 = _arg;
    return *this;
  }
  Type & set__pressure_thumb(
    const std::vector<double, typename ContainerAllocator::template rebind<double>::other> & _arg)
  {
    this->pressure_thumb = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosee_msg::msg::MotorPhalangePressure_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::msg::MotorPhalangePressure_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::msg::MotorPhalangePressure_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::msg::MotorPhalangePressure_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::msg::MotorPhalangePressure_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::msg::MotorPhalangePressure_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::msg::MotorPhalangePressure_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::msg::MotorPhalangePressure_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::msg::MotorPhalangePressure_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::msg::MotorPhalangePressure_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__msg__MotorPhalangePressure
    std::shared_ptr<rosee_msg::msg::MotorPhalangePressure_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__msg__MotorPhalangePressure
    std::shared_ptr<rosee_msg::msg::MotorPhalangePressure_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MotorPhalangePressure_ & other) const
  {
    if (this->name != other.name) {
      return false;
    }
    if (this->pressure_finger1 != other.pressure_finger1) {
      return false;
    }
    if (this->pressure_finger2 != other.pressure_finger2) {
      return false;
    }
    if (this->pressure_finger3 != other.pressure_finger3) {
      return false;
    }
    if (this->pressure_thumb != other.pressure_thumb) {
      return false;
    }
    return true;
  }
  bool operator!=(const MotorPhalangePressure_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MotorPhalangePressure_

// alias to use template instance with default allocator
using MotorPhalangePressure =
  rosee_msg::msg::MotorPhalangePressure_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rosee_msg

#endif  // ROSEE_MSG__MSG__DETAIL__MOTOR_PHALANGE_PRESSURE__STRUCT_HPP_
