// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rosee_msg:msg/MotorPosition.idl
// generated code does not contain a copyright notice
#include "rosee_msg/msg/detail/motor_position__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `name`
#include "rosidl_runtime_c/string_functions.h"
// Member `position`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
rosee_msg__msg__MotorPosition__init(rosee_msg__msg__MotorPosition * msg)
{
  if (!msg) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__Sequence__init(&msg->name, 0)) {
    rosee_msg__msg__MotorPosition__fini(msg);
    return false;
  }
  // position
  if (!rosidl_runtime_c__double__Sequence__init(&msg->position, 0)) {
    rosee_msg__msg__MotorPosition__fini(msg);
    return false;
  }
  return true;
}

void
rosee_msg__msg__MotorPosition__fini(rosee_msg__msg__MotorPosition * msg)
{
  if (!msg) {
    return;
  }
  // name
  rosidl_runtime_c__String__Sequence__fini(&msg->name);
  // position
  rosidl_runtime_c__double__Sequence__fini(&msg->position);
}

bool
rosee_msg__msg__MotorPosition__are_equal(const rosee_msg__msg__MotorPosition * lhs, const rosee_msg__msg__MotorPosition * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // position
  if (!rosidl_runtime_c__double__Sequence__are_equal(
      &(lhs->position), &(rhs->position)))
  {
    return false;
  }
  return true;
}

bool
rosee_msg__msg__MotorPosition__copy(
  const rosee_msg__msg__MotorPosition * input,
  rosee_msg__msg__MotorPosition * output)
{
  if (!input || !output) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // position
  if (!rosidl_runtime_c__double__Sequence__copy(
      &(input->position), &(output->position)))
  {
    return false;
  }
  return true;
}

rosee_msg__msg__MotorPosition *
rosee_msg__msg__MotorPosition__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__msg__MotorPosition * msg = (rosee_msg__msg__MotorPosition *)allocator.allocate(sizeof(rosee_msg__msg__MotorPosition), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosee_msg__msg__MotorPosition));
  bool success = rosee_msg__msg__MotorPosition__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosee_msg__msg__MotorPosition__destroy(rosee_msg__msg__MotorPosition * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosee_msg__msg__MotorPosition__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosee_msg__msg__MotorPosition__Sequence__init(rosee_msg__msg__MotorPosition__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__msg__MotorPosition * data = NULL;

  if (size) {
    data = (rosee_msg__msg__MotorPosition *)allocator.zero_allocate(size, sizeof(rosee_msg__msg__MotorPosition), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosee_msg__msg__MotorPosition__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosee_msg__msg__MotorPosition__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosee_msg__msg__MotorPosition__Sequence__fini(rosee_msg__msg__MotorPosition__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosee_msg__msg__MotorPosition__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosee_msg__msg__MotorPosition__Sequence *
rosee_msg__msg__MotorPosition__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__msg__MotorPosition__Sequence * array = (rosee_msg__msg__MotorPosition__Sequence *)allocator.allocate(sizeof(rosee_msg__msg__MotorPosition__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosee_msg__msg__MotorPosition__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosee_msg__msg__MotorPosition__Sequence__destroy(rosee_msg__msg__MotorPosition__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosee_msg__msg__MotorPosition__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosee_msg__msg__MotorPosition__Sequence__are_equal(const rosee_msg__msg__MotorPosition__Sequence * lhs, const rosee_msg__msg__MotorPosition__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosee_msg__msg__MotorPosition__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosee_msg__msg__MotorPosition__Sequence__copy(
  const rosee_msg__msg__MotorPosition__Sequence * input,
  rosee_msg__msg__MotorPosition__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosee_msg__msg__MotorPosition);
    rosee_msg__msg__MotorPosition * data =
      (rosee_msg__msg__MotorPosition *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosee_msg__msg__MotorPosition__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosee_msg__msg__MotorPosition__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosee_msg__msg__MotorPosition__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
