// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from rosee_msg:msg/ObjectModelMsg.idl
// generated code does not contain a copyright notice

#ifndef ROSEE_MSG__MSG__DETAIL__OBJECT_MODEL_MSG__FUNCTIONS_H_
#define ROSEE_MSG__MSG__DETAIL__OBJECT_MODEL_MSG__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "rosee_msg/msg/rosidl_generator_c__visibility_control.h"

#include "rosee_msg/msg/detail/object_model_msg__struct.h"

/// Initialize msg/ObjectModelMsg message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rosee_msg__msg__ObjectModelMsg
 * )) before or use
 * rosee_msg__msg__ObjectModelMsg__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
bool
rosee_msg__msg__ObjectModelMsg__init(rosee_msg__msg__ObjectModelMsg * msg);

/// Finalize msg/ObjectModelMsg message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
void
rosee_msg__msg__ObjectModelMsg__fini(rosee_msg__msg__ObjectModelMsg * msg);

/// Create msg/ObjectModelMsg message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rosee_msg__msg__ObjectModelMsg__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
rosee_msg__msg__ObjectModelMsg *
rosee_msg__msg__ObjectModelMsg__create();

/// Destroy msg/ObjectModelMsg message.
/**
 * It calls
 * rosee_msg__msg__ObjectModelMsg__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
void
rosee_msg__msg__ObjectModelMsg__destroy(rosee_msg__msg__ObjectModelMsg * msg);

/// Check for msg/ObjectModelMsg message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
bool
rosee_msg__msg__ObjectModelMsg__are_equal(const rosee_msg__msg__ObjectModelMsg * lhs, const rosee_msg__msg__ObjectModelMsg * rhs);

/// Copy a msg/ObjectModelMsg message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
bool
rosee_msg__msg__ObjectModelMsg__copy(
  const rosee_msg__msg__ObjectModelMsg * input,
  rosee_msg__msg__ObjectModelMsg * output);

/// Initialize array of msg/ObjectModelMsg messages.
/**
 * It allocates the memory for the number of elements and calls
 * rosee_msg__msg__ObjectModelMsg__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
bool
rosee_msg__msg__ObjectModelMsg__Sequence__init(rosee_msg__msg__ObjectModelMsg__Sequence * array, size_t size);

/// Finalize array of msg/ObjectModelMsg messages.
/**
 * It calls
 * rosee_msg__msg__ObjectModelMsg__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
void
rosee_msg__msg__ObjectModelMsg__Sequence__fini(rosee_msg__msg__ObjectModelMsg__Sequence * array);

/// Create array of msg/ObjectModelMsg messages.
/**
 * It allocates the memory for the array and calls
 * rosee_msg__msg__ObjectModelMsg__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
rosee_msg__msg__ObjectModelMsg__Sequence *
rosee_msg__msg__ObjectModelMsg__Sequence__create(size_t size);

/// Destroy array of msg/ObjectModelMsg messages.
/**
 * It calls
 * rosee_msg__msg__ObjectModelMsg__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
void
rosee_msg__msg__ObjectModelMsg__Sequence__destroy(rosee_msg__msg__ObjectModelMsg__Sequence * array);

/// Check for msg/ObjectModelMsg message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
bool
rosee_msg__msg__ObjectModelMsg__Sequence__are_equal(const rosee_msg__msg__ObjectModelMsg__Sequence * lhs, const rosee_msg__msg__ObjectModelMsg__Sequence * rhs);

/// Copy an array of msg/ObjectModelMsg messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
bool
rosee_msg__msg__ObjectModelMsg__Sequence__copy(
  const rosee_msg__msg__ObjectModelMsg__Sequence * input,
  rosee_msg__msg__ObjectModelMsg__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // ROSEE_MSG__MSG__DETAIL__OBJECT_MODEL_MSG__FUNCTIONS_H_
