// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rosee_msg:msg/ROSEEActionControl.idl
// generated code does not contain a copyright notice

#ifndef ROSEE_MSG__MSG__DETAIL__ROSEE_ACTION_CONTROL__STRUCT_H_
#define ROSEE_MSG__MSG__DETAIL__ROSEE_ACTION_CONTROL__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'PRIMITIVE'.
enum
{
  rosee_msg__msg__ROSEEActionControl__PRIMITIVE = 0
};

/// Constant 'GENERIC'.
enum
{
  rosee_msg__msg__ROSEEActionControl__GENERIC = 1
};

/// Constant 'COMPOSED'.
enum
{
  rosee_msg__msg__ROSEEActionControl__COMPOSED = 2
};

/// Constant 'TIMED'.
enum
{
  rosee_msg__msg__ROSEEActionControl__TIMED = 3
};

/// Constant 'NONE'.
enum
{
  rosee_msg__msg__ROSEEActionControl__NONE = 4
};

/// Constant 'PRIMITIVE_PINCHSTRONG'.
enum
{
  rosee_msg__msg__ROSEEActionControl__PRIMITIVE_PINCHSTRONG = 0
};

/// Constant 'PRIMITIVE_PINCHWEAK'.
enum
{
  rosee_msg__msg__ROSEEActionControl__PRIMITIVE_PINCHWEAK = 1
};

/// Constant 'PRIMITIVE_MULTIPLEPINCHSTRONG'.
enum
{
  rosee_msg__msg__ROSEEActionControl__PRIMITIVE_MULTIPLEPINCHSTRONG = 2
};

/// Constant 'PRIMITIVE_TRIG'.
enum
{
  rosee_msg__msg__ROSEEActionControl__PRIMITIVE_TRIG = 3
};

/// Constant 'PRIMITIVE_TIPFLEX'.
enum
{
  rosee_msg__msg__ROSEEActionControl__PRIMITIVE_TIPFLEX = 4
};

/// Constant 'PRIMITIVE_FINGFLEX'.
enum
{
  rosee_msg__msg__ROSEEActionControl__PRIMITIVE_FINGFLEX = 5
};

/// Constant 'PRIMITIVE_SINGLEJOINTMULTIPLETIPS'.
enum
{
  rosee_msg__msg__ROSEEActionControl__PRIMITIVE_SINGLEJOINTMULTIPLETIPS = 6
};

/// Constant 'PRIMITIVE_NONE'.
enum
{
  rosee_msg__msg__ROSEEActionControl__PRIMITIVE_NONE = 7
};

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"
// Member 'action_name'
// Member 'selectable_items'
// Member 'optional_motors_names'
#include "rosidl_runtime_c/string.h"
// Member 'optional_motors_commands'
#include "rosidl_runtime_c/primitives_sequence.h"

// Struct defined in msg/ROSEEActionControl in the package rosee_msg.
typedef struct rosee_msg__msg__ROSEEActionControl
{
  uint32_t seq;
  builtin_interfaces__msg__Time stamp;
  rosidl_runtime_c__String action_name;
  uint8_t action_type;
  uint8_t action_primitive_type;
  rosidl_runtime_c__String__Sequence selectable_items;
  double percentage;
  double error_norm;
  rosidl_runtime_c__String__Sequence optional_motors_names;
  rosidl_runtime_c__double__Sequence optional_motors_commands;
} rosee_msg__msg__ROSEEActionControl;

// Struct for a sequence of rosee_msg__msg__ROSEEActionControl.
typedef struct rosee_msg__msg__ROSEEActionControl__Sequence
{
  rosee_msg__msg__ROSEEActionControl * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rosee_msg__msg__ROSEEActionControl__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ROSEE_MSG__MSG__DETAIL__ROSEE_ACTION_CONTROL__STRUCT_H_
