// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rosee_msg:msg/ROSEEActionControl.idl
// generated code does not contain a copyright notice

#ifndef ROSEE_MSG__MSG__DETAIL__ROSEE_ACTION_CONTROL__STRUCT_HPP_
#define ROSEE_MSG__MSG__DETAIL__ROSEE_ACTION_CONTROL__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rosee_msg__msg__ROSEEActionControl __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__msg__ROSEEActionControl __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ROSEEActionControl_
{
  using Type = ROSEEActionControl_<ContainerAllocator>;

  explicit ROSEEActionControl_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->seq = 0ul;
      this->action_name = "";
      this->action_type = 0;
      this->action_primitive_type = 0;
      this->percentage = 0.0;
      this->error_norm = 0.0;
    }
  }

  explicit ROSEEActionControl_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init),
    action_name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->seq = 0ul;
      this->action_name = "";
      this->action_type = 0;
      this->action_primitive_type = 0;
      this->percentage = 0.0;
      this->error_norm = 0.0;
    }
  }

  // field types and members
  using _seq_type =
    uint32_t;
  _seq_type seq;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;
  using _action_name_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _action_name_type action_name;
  using _action_type_type =
    uint8_t;
  _action_type_type action_type;
  using _action_primitive_type_type =
    uint8_t;
  _action_primitive_type_type action_primitive_type;
  using _selectable_items_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _selectable_items_type selectable_items;
  using _percentage_type =
    double;
  _percentage_type percentage;
  using _error_norm_type =
    double;
  _error_norm_type error_norm;
  using _optional_motors_names_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _optional_motors_names_type optional_motors_names;
  using _optional_motors_commands_type =
    std::vector<double, typename ContainerAllocator::template rebind<double>::other>;
  _optional_motors_commands_type optional_motors_commands;

  // setters for named parameter idiom
  Type & set__seq(
    const uint32_t & _arg)
  {
    this->seq = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }
  Type & set__action_name(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->action_name = _arg;
    return *this;
  }
  Type & set__action_type(
    const uint8_t & _arg)
  {
    this->action_type = _arg;
    return *this;
  }
  Type & set__action_primitive_type(
    const uint8_t & _arg)
  {
    this->action_primitive_type = _arg;
    return *this;
  }
  Type & set__selectable_items(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->selectable_items = _arg;
    return *this;
  }
  Type & set__percentage(
    const double & _arg)
  {
    this->percentage = _arg;
    return *this;
  }
  Type & set__error_norm(
    const double & _arg)
  {
    this->error_norm = _arg;
    return *this;
  }
  Type & set__optional_motors_names(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->optional_motors_names = _arg;
    return *this;
  }
  Type & set__optional_motors_commands(
    const std::vector<double, typename ContainerAllocator::template rebind<double>::other> & _arg)
  {
    this->optional_motors_commands = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t PRIMITIVE =
    0u;
  static constexpr uint8_t GENERIC =
    1u;
  static constexpr uint8_t COMPOSED =
    2u;
  static constexpr uint8_t TIMED =
    3u;
  static constexpr uint8_t NONE =
    4u;
  static constexpr uint8_t PRIMITIVE_PINCHSTRONG =
    0u;
  static constexpr uint8_t PRIMITIVE_PINCHWEAK =
    1u;
  static constexpr uint8_t PRIMITIVE_MULTIPLEPINCHSTRONG =
    2u;
  static constexpr uint8_t PRIMITIVE_TRIG =
    3u;
  static constexpr uint8_t PRIMITIVE_TIPFLEX =
    4u;
  static constexpr uint8_t PRIMITIVE_FINGFLEX =
    5u;
  static constexpr uint8_t PRIMITIVE_SINGLEJOINTMULTIPLETIPS =
    6u;
  static constexpr uint8_t PRIMITIVE_NONE =
    7u;

  // pointer types
  using RawPtr =
    rosee_msg::msg::ROSEEActionControl_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::msg::ROSEEActionControl_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::msg::ROSEEActionControl_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::msg::ROSEEActionControl_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::msg::ROSEEActionControl_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::msg::ROSEEActionControl_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::msg::ROSEEActionControl_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::msg::ROSEEActionControl_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::msg::ROSEEActionControl_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::msg::ROSEEActionControl_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__msg__ROSEEActionControl
    std::shared_ptr<rosee_msg::msg::ROSEEActionControl_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__msg__ROSEEActionControl
    std::shared_ptr<rosee_msg::msg::ROSEEActionControl_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ROSEEActionControl_ & other) const
  {
    if (this->seq != other.seq) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    if (this->action_name != other.action_name) {
      return false;
    }
    if (this->action_type != other.action_type) {
      return false;
    }
    if (this->action_primitive_type != other.action_primitive_type) {
      return false;
    }
    if (this->selectable_items != other.selectable_items) {
      return false;
    }
    if (this->percentage != other.percentage) {
      return false;
    }
    if (this->error_norm != other.error_norm) {
      return false;
    }
    if (this->optional_motors_names != other.optional_motors_names) {
      return false;
    }
    if (this->optional_motors_commands != other.optional_motors_commands) {
      return false;
    }
    return true;
  }
  bool operator!=(const ROSEEActionControl_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ROSEEActionControl_

// alias to use template instance with default allocator
using ROSEEActionControl =
  rosee_msg::msg::ROSEEActionControl_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t ROSEEActionControl_<ContainerAllocator>::PRIMITIVE;
template<typename ContainerAllocator>
constexpr uint8_t ROSEEActionControl_<ContainerAllocator>::GENERIC;
template<typename ContainerAllocator>
constexpr uint8_t ROSEEActionControl_<ContainerAllocator>::COMPOSED;
template<typename ContainerAllocator>
constexpr uint8_t ROSEEActionControl_<ContainerAllocator>::TIMED;
template<typename ContainerAllocator>
constexpr uint8_t ROSEEActionControl_<ContainerAllocator>::NONE;
template<typename ContainerAllocator>
constexpr uint8_t ROSEEActionControl_<ContainerAllocator>::PRIMITIVE_PINCHSTRONG;
template<typename ContainerAllocator>
constexpr uint8_t ROSEEActionControl_<ContainerAllocator>::PRIMITIVE_PINCHWEAK;
template<typename ContainerAllocator>
constexpr uint8_t ROSEEActionControl_<ContainerAllocator>::PRIMITIVE_MULTIPLEPINCHSTRONG;
template<typename ContainerAllocator>
constexpr uint8_t ROSEEActionControl_<ContainerAllocator>::PRIMITIVE_TRIG;
template<typename ContainerAllocator>
constexpr uint8_t ROSEEActionControl_<ContainerAllocator>::PRIMITIVE_TIPFLEX;
template<typename ContainerAllocator>
constexpr uint8_t ROSEEActionControl_<ContainerAllocator>::PRIMITIVE_FINGFLEX;
template<typename ContainerAllocator>
constexpr uint8_t ROSEEActionControl_<ContainerAllocator>::PRIMITIVE_SINGLEJOINTMULTIPLETIPS;
template<typename ContainerAllocator>
constexpr uint8_t ROSEEActionControl_<ContainerAllocator>::PRIMITIVE_NONE;

}  // namespace msg

}  // namespace rosee_msg

#endif  // ROSEE_MSG__MSG__DETAIL__ROSEE_ACTION_CONTROL__STRUCT_HPP_
