// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rosee_msg:srv/GraspingActionsAvailable.idl
// generated code does not contain a copyright notice

#ifndef ROSEE_MSG__SRV__DETAIL__GRASPING_ACTIONS_AVAILABLE__STRUCT_HPP_
#define ROSEE_MSG__SRV__DETAIL__GRASPING_ACTIONS_AVAILABLE__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__rosee_msg__srv__GraspingActionsAvailable_Request __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__srv__GraspingActionsAvailable_Request __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GraspingActionsAvailable_Request_
{
  using Type = GraspingActionsAvailable_Request_<ContainerAllocator>;

  explicit GraspingActionsAvailable_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->action_type = 0;
      this->primitive_type = 0;
      this->action_name = "";
    }
  }

  explicit GraspingActionsAvailable_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : action_name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->action_type = 0;
      this->primitive_type = 0;
      this->action_name = "";
    }
  }

  // field types and members
  using _action_type_type =
    uint8_t;
  _action_type_type action_type;
  using _primitive_type_type =
    uint8_t;
  _primitive_type_type primitive_type;
  using _action_name_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _action_name_type action_name;
  using _elements_involved_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _elements_involved_type elements_involved;

  // setters for named parameter idiom
  Type & set__action_type(
    const uint8_t & _arg)
  {
    this->action_type = _arg;
    return *this;
  }
  Type & set__primitive_type(
    const uint8_t & _arg)
  {
    this->primitive_type = _arg;
    return *this;
  }
  Type & set__action_name(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->action_name = _arg;
    return *this;
  }
  Type & set__elements_involved(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->elements_involved = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t PRIMITIVE =
    0u;
  static constexpr uint8_t GENERIC_AND_COMPOSED =
    1u;
  static constexpr uint8_t TIMED =
    2u;
  static constexpr uint8_t PRIMITIVE_ALL =
    0u;
  static constexpr uint8_t PRIMITIVE_PINCHSTRONG =
    1u;
  static constexpr uint8_t PRIMITIVE_PINCHWEAK =
    2u;
  static constexpr uint8_t PRIMITIVE_MULTIPLEPINCHSTRONG =
    3u;
  static constexpr uint8_t PRIMITIVE_TRIG =
    4u;
  static constexpr uint8_t PRIMITIVE_TIPFLEX =
    5u;
  static constexpr uint8_t PRIMITIVE_FINGFLEX =
    6u;
  static constexpr uint8_t PRIMITIVE_SINGLEJOINTMULTIPLETIPS =
    7u;
  static constexpr uint8_t PRIMITIVE_NONE =
    8u;

  // pointer types
  using RawPtr =
    rosee_msg::srv::GraspingActionsAvailable_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::srv::GraspingActionsAvailable_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::srv::GraspingActionsAvailable_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::srv::GraspingActionsAvailable_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::srv::GraspingActionsAvailable_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::srv::GraspingActionsAvailable_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::srv::GraspingActionsAvailable_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::srv::GraspingActionsAvailable_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::srv::GraspingActionsAvailable_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::srv::GraspingActionsAvailable_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__srv__GraspingActionsAvailable_Request
    std::shared_ptr<rosee_msg::srv::GraspingActionsAvailable_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__srv__GraspingActionsAvailable_Request
    std::shared_ptr<rosee_msg::srv::GraspingActionsAvailable_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GraspingActionsAvailable_Request_ & other) const
  {
    if (this->action_type != other.action_type) {
      return false;
    }
    if (this->primitive_type != other.primitive_type) {
      return false;
    }
    if (this->action_name != other.action_name) {
      return false;
    }
    if (this->elements_involved != other.elements_involved) {
      return false;
    }
    return true;
  }
  bool operator!=(const GraspingActionsAvailable_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GraspingActionsAvailable_Request_

// alias to use template instance with default allocator
using GraspingActionsAvailable_Request =
  rosee_msg::srv::GraspingActionsAvailable_Request_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t GraspingActionsAvailable_Request_<ContainerAllocator>::PRIMITIVE;
template<typename ContainerAllocator>
constexpr uint8_t GraspingActionsAvailable_Request_<ContainerAllocator>::GENERIC_AND_COMPOSED;
template<typename ContainerAllocator>
constexpr uint8_t GraspingActionsAvailable_Request_<ContainerAllocator>::TIMED;
template<typename ContainerAllocator>
constexpr uint8_t GraspingActionsAvailable_Request_<ContainerAllocator>::PRIMITIVE_ALL;
template<typename ContainerAllocator>
constexpr uint8_t GraspingActionsAvailable_Request_<ContainerAllocator>::PRIMITIVE_PINCHSTRONG;
template<typename ContainerAllocator>
constexpr uint8_t GraspingActionsAvailable_Request_<ContainerAllocator>::PRIMITIVE_PINCHWEAK;
template<typename ContainerAllocator>
constexpr uint8_t GraspingActionsAvailable_Request_<ContainerAllocator>::PRIMITIVE_MULTIPLEPINCHSTRONG;
template<typename ContainerAllocator>
constexpr uint8_t GraspingActionsAvailable_Request_<ContainerAllocator>::PRIMITIVE_TRIG;
template<typename ContainerAllocator>
constexpr uint8_t GraspingActionsAvailable_Request_<ContainerAllocator>::PRIMITIVE_TIPFLEX;
template<typename ContainerAllocator>
constexpr uint8_t GraspingActionsAvailable_Request_<ContainerAllocator>::PRIMITIVE_FINGFLEX;
template<typename ContainerAllocator>
constexpr uint8_t GraspingActionsAvailable_Request_<ContainerAllocator>::PRIMITIVE_SINGLEJOINTMULTIPLETIPS;
template<typename ContainerAllocator>
constexpr uint8_t GraspingActionsAvailable_Request_<ContainerAllocator>::PRIMITIVE_NONE;

}  // namespace srv

}  // namespace rosee_msg


// Include directives for member types
// Member 'grasping_actions'
#include "rosee_msg/msg/detail/grasping_action__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rosee_msg__srv__GraspingActionsAvailable_Response __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__srv__GraspingActionsAvailable_Response __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GraspingActionsAvailable_Response_
{
  using Type = GraspingActionsAvailable_Response_<ContainerAllocator>;

  explicit GraspingActionsAvailable_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit GraspingActionsAvailable_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _grasping_actions_type =
    std::vector<rosee_msg::msg::GraspingAction_<ContainerAllocator>, typename ContainerAllocator::template rebind<rosee_msg::msg::GraspingAction_<ContainerAllocator>>::other>;
  _grasping_actions_type grasping_actions;

  // setters for named parameter idiom
  Type & set__grasping_actions(
    const std::vector<rosee_msg::msg::GraspingAction_<ContainerAllocator>, typename ContainerAllocator::template rebind<rosee_msg::msg::GraspingAction_<ContainerAllocator>>::other> & _arg)
  {
    this->grasping_actions = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosee_msg::srv::GraspingActionsAvailable_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::srv::GraspingActionsAvailable_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::srv::GraspingActionsAvailable_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::srv::GraspingActionsAvailable_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::srv::GraspingActionsAvailable_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::srv::GraspingActionsAvailable_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::srv::GraspingActionsAvailable_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::srv::GraspingActionsAvailable_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::srv::GraspingActionsAvailable_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::srv::GraspingActionsAvailable_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__srv__GraspingActionsAvailable_Response
    std::shared_ptr<rosee_msg::srv::GraspingActionsAvailable_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__srv__GraspingActionsAvailable_Response
    std::shared_ptr<rosee_msg::srv::GraspingActionsAvailable_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GraspingActionsAvailable_Response_ & other) const
  {
    if (this->grasping_actions != other.grasping_actions) {
      return false;
    }
    return true;
  }
  bool operator!=(const GraspingActionsAvailable_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GraspingActionsAvailable_Response_

// alias to use template instance with default allocator
using GraspingActionsAvailable_Response =
  rosee_msg::srv::GraspingActionsAvailable_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rosee_msg

namespace rosee_msg
{

namespace srv
{

struct GraspingActionsAvailable
{
  using Request = rosee_msg::srv::GraspingActionsAvailable_Request;
  using Response = rosee_msg::srv::GraspingActionsAvailable_Response;
};

}  // namespace srv

}  // namespace rosee_msg

#endif  // ROSEE_MSG__SRV__DETAIL__GRASPING_ACTIONS_AVAILABLE__STRUCT_HPP_
