// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from rosee_msg:srv/GraspingPrimitiveAggregatedAvailable.idl
// generated code does not contain a copyright notice

#ifndef ROSEE_MSG__SRV__DETAIL__GRASPING_PRIMITIVE_AGGREGATED_AVAILABLE__FUNCTIONS_H_
#define ROSEE_MSG__SRV__DETAIL__GRASPING_PRIMITIVE_AGGREGATED_AVAILABLE__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "rosee_msg/msg/rosidl_generator_c__visibility_control.h"

#include "rosee_msg/srv/detail/grasping_primitive_aggregated_available__struct.h"

/// Initialize srv/GraspingPrimitiveAggregatedAvailable message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request
 * )) before or use
 * rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
bool
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__init(rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request * msg);

/// Finalize srv/GraspingPrimitiveAggregatedAvailable message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
void
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__fini(rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request * msg);

/// Create srv/GraspingPrimitiveAggregatedAvailable message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request *
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__create();

/// Destroy srv/GraspingPrimitiveAggregatedAvailable message.
/**
 * It calls
 * rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
void
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__destroy(rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request * msg);

/// Check for srv/GraspingPrimitiveAggregatedAvailable message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
bool
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__are_equal(const rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request * lhs, const rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request * rhs);

/// Copy a srv/GraspingPrimitiveAggregatedAvailable message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
bool
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__copy(
  const rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request * input,
  rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request * output);

/// Initialize array of srv/GraspingPrimitiveAggregatedAvailable messages.
/**
 * It allocates the memory for the number of elements and calls
 * rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
bool
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__Sequence__init(rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__Sequence * array, size_t size);

/// Finalize array of srv/GraspingPrimitiveAggregatedAvailable messages.
/**
 * It calls
 * rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
void
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__Sequence__fini(rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__Sequence * array);

/// Create array of srv/GraspingPrimitiveAggregatedAvailable messages.
/**
 * It allocates the memory for the array and calls
 * rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__Sequence *
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__Sequence__create(size_t size);

/// Destroy array of srv/GraspingPrimitiveAggregatedAvailable messages.
/**
 * It calls
 * rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
void
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__Sequence__destroy(rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__Sequence * array);

/// Check for srv/GraspingPrimitiveAggregatedAvailable message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
bool
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__Sequence__are_equal(const rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__Sequence * lhs, const rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__Sequence * rhs);

/// Copy an array of srv/GraspingPrimitiveAggregatedAvailable messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
bool
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__Sequence__copy(
  const rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__Sequence * input,
  rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Request__Sequence * output);

/// Initialize srv/GraspingPrimitiveAggregatedAvailable message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response
 * )) before or use
 * rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
bool
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__init(rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response * msg);

/// Finalize srv/GraspingPrimitiveAggregatedAvailable message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
void
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__fini(rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response * msg);

/// Create srv/GraspingPrimitiveAggregatedAvailable message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response *
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__create();

/// Destroy srv/GraspingPrimitiveAggregatedAvailable message.
/**
 * It calls
 * rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
void
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__destroy(rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response * msg);

/// Check for srv/GraspingPrimitiveAggregatedAvailable message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
bool
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__are_equal(const rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response * lhs, const rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response * rhs);

/// Copy a srv/GraspingPrimitiveAggregatedAvailable message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
bool
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__copy(
  const rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response * input,
  rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response * output);

/// Initialize array of srv/GraspingPrimitiveAggregatedAvailable messages.
/**
 * It allocates the memory for the number of elements and calls
 * rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
bool
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__Sequence__init(rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__Sequence * array, size_t size);

/// Finalize array of srv/GraspingPrimitiveAggregatedAvailable messages.
/**
 * It calls
 * rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
void
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__Sequence__fini(rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__Sequence * array);

/// Create array of srv/GraspingPrimitiveAggregatedAvailable messages.
/**
 * It allocates the memory for the array and calls
 * rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__Sequence *
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__Sequence__create(size_t size);

/// Destroy array of srv/GraspingPrimitiveAggregatedAvailable messages.
/**
 * It calls
 * rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
void
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__Sequence__destroy(rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__Sequence * array);

/// Check for srv/GraspingPrimitiveAggregatedAvailable message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
bool
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__Sequence__are_equal(const rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__Sequence * lhs, const rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__Sequence * rhs);

/// Copy an array of srv/GraspingPrimitiveAggregatedAvailable messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rosee_msg
bool
rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__Sequence__copy(
  const rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__Sequence * input,
  rosee_msg__srv__GraspingPrimitiveAggregatedAvailable_Response__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // ROSEE_MSG__SRV__DETAIL__GRASPING_PRIMITIVE_AGGREGATED_AVAILABLE__FUNCTIONS_H_
