// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from rosee_msg:srv/HandInfo.idl
// generated code does not contain a copyright notice

#ifndef ROSEE_MSG__SRV__DETAIL__HAND_INFO__BUILDER_HPP_
#define ROSEE_MSG__SRV__DETAIL__HAND_INFO__BUILDER_HPP_

#include "rosee_msg/srv/detail/hand_info__struct.hpp"
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <utility>


namespace rosee_msg
{

namespace srv
{

namespace builder
{

class Init_HandInfo_Request_finger_joint_positions
{
public:
  explicit Init_HandInfo_Request_finger_joint_positions(::rosee_msg::srv::HandInfo_Request & msg)
  : msg_(msg)
  {}
  ::rosee_msg::srv::HandInfo_Request finger_joint_positions(::rosee_msg::srv::HandInfo_Request::_finger_joint_positions_type arg)
  {
    msg_.finger_joint_positions = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rosee_msg::srv::HandInfo_Request msg_;
};

class Init_HandInfo_Request_motor_positions_reference
{
public:
  explicit Init_HandInfo_Request_motor_positions_reference(::rosee_msg::srv::HandInfo_Request & msg)
  : msg_(msg)
  {}
  Init_HandInfo_Request_finger_joint_positions motor_positions_reference(::rosee_msg::srv::HandInfo_Request::_motor_positions_reference_type arg)
  {
    msg_.motor_positions_reference = std::move(arg);
    return Init_HandInfo_Request_finger_joint_positions(msg_);
  }

private:
  ::rosee_msg::srv::HandInfo_Request msg_;
};

class Init_HandInfo_Request_motor_positions
{
public:
  Init_HandInfo_Request_motor_positions()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_HandInfo_Request_motor_positions_reference motor_positions(::rosee_msg::srv::HandInfo_Request::_motor_positions_type arg)
  {
    msg_.motor_positions = std::move(arg);
    return Init_HandInfo_Request_motor_positions_reference(msg_);
  }

private:
  ::rosee_msg::srv::HandInfo_Request msg_;
};

}  // namespace builder

}  // namespace srv

template<typename MessageType>
auto build();

template<>
inline
auto build<::rosee_msg::srv::HandInfo_Request>()
{
  return rosee_msg::srv::builder::Init_HandInfo_Request_motor_positions();
}

}  // namespace rosee_msg


namespace rosee_msg
{

namespace srv
{

namespace builder
{

class Init_HandInfo_Response_motors_torque_limits
{
public:
  explicit Init_HandInfo_Response_motors_torque_limits(::rosee_msg::srv::HandInfo_Response & msg)
  : msg_(msg)
  {}
  ::rosee_msg::srv::HandInfo_Response motors_torque_limits(::rosee_msg::srv::HandInfo_Response::_motors_torque_limits_type arg)
  {
    msg_.motors_torque_limits = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rosee_msg::srv::HandInfo_Response msg_;
};

class Init_HandInfo_Response_tips_frictions
{
public:
  explicit Init_HandInfo_Response_tips_frictions(::rosee_msg::srv::HandInfo_Response & msg)
  : msg_(msg)
  {}
  Init_HandInfo_Response_motors_torque_limits tips_frictions(::rosee_msg::srv::HandInfo_Response::_tips_frictions_type arg)
  {
    msg_.tips_frictions = std::move(arg);
    return Init_HandInfo_Response_motors_torque_limits(msg_);
  }

private:
  ::rosee_msg::srv::HandInfo_Response msg_;
};

class Init_HandInfo_Response_motors_stiffness
{
public:
  explicit Init_HandInfo_Response_motors_stiffness(::rosee_msg::srv::HandInfo_Response & msg)
  : msg_(msg)
  {}
  Init_HandInfo_Response_tips_frictions motors_stiffness(::rosee_msg::srv::HandInfo_Response::_motors_stiffness_type arg)
  {
    msg_.motors_stiffness = std::move(arg);
    return Init_HandInfo_Response_tips_frictions(msg_);
  }

private:
  ::rosee_msg::srv::HandInfo_Response msg_;
};

class Init_HandInfo_Response_tips_forces_friction
{
public:
  explicit Init_HandInfo_Response_tips_forces_friction(::rosee_msg::srv::HandInfo_Response & msg)
  : msg_(msg)
  {}
  Init_HandInfo_Response_motors_stiffness tips_forces_friction(::rosee_msg::srv::HandInfo_Response::_tips_forces_friction_type arg)
  {
    msg_.tips_forces_friction = std::move(arg);
    return Init_HandInfo_Response_motors_stiffness(msg_);
  }

private:
  ::rosee_msg::srv::HandInfo_Response msg_;
};

class Init_HandInfo_Response_tips_forces_normal
{
public:
  explicit Init_HandInfo_Response_tips_forces_normal(::rosee_msg::srv::HandInfo_Response & msg)
  : msg_(msg)
  {}
  Init_HandInfo_Response_tips_forces_friction tips_forces_normal(::rosee_msg::srv::HandInfo_Response::_tips_forces_normal_type arg)
  {
    msg_.tips_forces_normal = std::move(arg);
    return Init_HandInfo_Response_tips_forces_friction(msg_);
  }

private:
  ::rosee_msg::srv::HandInfo_Response msg_;
};

class Init_HandInfo_Response_tips_jacobians_friction
{
public:
  explicit Init_HandInfo_Response_tips_jacobians_friction(::rosee_msg::srv::HandInfo_Response & msg)
  : msg_(msg)
  {}
  Init_HandInfo_Response_tips_forces_normal tips_jacobians_friction(::rosee_msg::srv::HandInfo_Response::_tips_jacobians_friction_type arg)
  {
    msg_.tips_jacobians_friction = std::move(arg);
    return Init_HandInfo_Response_tips_forces_normal(msg_);
  }

private:
  ::rosee_msg::srv::HandInfo_Response msg_;
};

class Init_HandInfo_Response_tips_jacobians_normal
{
public:
  explicit Init_HandInfo_Response_tips_jacobians_normal(::rosee_msg::srv::HandInfo_Response & msg)
  : msg_(msg)
  {}
  Init_HandInfo_Response_tips_jacobians_friction tips_jacobians_normal(::rosee_msg::srv::HandInfo_Response::_tips_jacobians_normal_type arg)
  {
    msg_.tips_jacobians_normal = std::move(arg);
    return Init_HandInfo_Response_tips_jacobians_friction(msg_);
  }

private:
  ::rosee_msg::srv::HandInfo_Response msg_;
};

class Init_HandInfo_Response_transmission_augmented_matrices
{
public:
  explicit Init_HandInfo_Response_transmission_augmented_matrices(::rosee_msg::srv::HandInfo_Response & msg)
  : msg_(msg)
  {}
  Init_HandInfo_Response_tips_jacobians_normal transmission_augmented_matrices(::rosee_msg::srv::HandInfo_Response::_transmission_augmented_matrices_type arg)
  {
    msg_.transmission_augmented_matrices = std::move(arg);
    return Init_HandInfo_Response_tips_jacobians_normal(msg_);
  }

private:
  ::rosee_msg::srv::HandInfo_Response msg_;
};

class Init_HandInfo_Response_transmission_square_matrices
{
public:
  explicit Init_HandInfo_Response_transmission_square_matrices(::rosee_msg::srv::HandInfo_Response & msg)
  : msg_(msg)
  {}
  Init_HandInfo_Response_transmission_augmented_matrices transmission_square_matrices(::rosee_msg::srv::HandInfo_Response::_transmission_square_matrices_type arg)
  {
    msg_.transmission_square_matrices = std::move(arg);
    return Init_HandInfo_Response_transmission_augmented_matrices(msg_);
  }

private:
  ::rosee_msg::srv::HandInfo_Response msg_;
};

class Init_HandInfo_Response_transmission_matrix
{
public:
  explicit Init_HandInfo_Response_transmission_matrix(::rosee_msg::srv::HandInfo_Response & msg)
  : msg_(msg)
  {}
  Init_HandInfo_Response_transmission_square_matrices transmission_matrix(::rosee_msg::srv::HandInfo_Response::_transmission_matrix_type arg)
  {
    msg_.transmission_matrix = std::move(arg);
    return Init_HandInfo_Response_transmission_square_matrices(msg_);
  }

private:
  ::rosee_msg::srv::HandInfo_Response msg_;
};

class Init_HandInfo_Response_motors_names
{
public:
  explicit Init_HandInfo_Response_motors_names(::rosee_msg::srv::HandInfo_Response & msg)
  : msg_(msg)
  {}
  Init_HandInfo_Response_transmission_matrix motors_names(::rosee_msg::srv::HandInfo_Response::_motors_names_type arg)
  {
    msg_.motors_names = std::move(arg);
    return Init_HandInfo_Response_transmission_matrix(msg_);
  }

private:
  ::rosee_msg::srv::HandInfo_Response msg_;
};

class Init_HandInfo_Response_fingers_names
{
public:
  Init_HandInfo_Response_fingers_names()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_HandInfo_Response_motors_names fingers_names(::rosee_msg::srv::HandInfo_Response::_fingers_names_type arg)
  {
    msg_.fingers_names = std::move(arg);
    return Init_HandInfo_Response_motors_names(msg_);
  }

private:
  ::rosee_msg::srv::HandInfo_Response msg_;
};

}  // namespace builder

}  // namespace srv

template<typename MessageType>
auto build();

template<>
inline
auto build<::rosee_msg::srv::HandInfo_Response>()
{
  return rosee_msg::srv::builder::Init_HandInfo_Response_fingers_names();
}

}  // namespace rosee_msg

#endif  // ROSEE_MSG__SRV__DETAIL__HAND_INFO__BUILDER_HPP_
