// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rosee_msg:srv/HandInfo.idl
// generated code does not contain a copyright notice
#include "rosee_msg/srv/detail/hand_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `motor_positions`
// Member `motor_positions_reference`
#include "rosidl_runtime_c/primitives_sequence_functions.h"
// Member `finger_joint_positions`
#include "example_interfaces/msg/detail/float32_multi_array__functions.h"

bool
rosee_msg__srv__HandInfo_Request__init(rosee_msg__srv__HandInfo_Request * msg)
{
  if (!msg) {
    return false;
  }
  // motor_positions
  if (!rosidl_runtime_c__float__Sequence__init(&msg->motor_positions, 0)) {
    rosee_msg__srv__HandInfo_Request__fini(msg);
    return false;
  }
  // motor_positions_reference
  if (!rosidl_runtime_c__float__Sequence__init(&msg->motor_positions_reference, 0)) {
    rosee_msg__srv__HandInfo_Request__fini(msg);
    return false;
  }
  // finger_joint_positions
  if (!example_interfaces__msg__Float32MultiArray__init(&msg->finger_joint_positions)) {
    rosee_msg__srv__HandInfo_Request__fini(msg);
    return false;
  }
  return true;
}

void
rosee_msg__srv__HandInfo_Request__fini(rosee_msg__srv__HandInfo_Request * msg)
{
  if (!msg) {
    return;
  }
  // motor_positions
  rosidl_runtime_c__float__Sequence__fini(&msg->motor_positions);
  // motor_positions_reference
  rosidl_runtime_c__float__Sequence__fini(&msg->motor_positions_reference);
  // finger_joint_positions
  example_interfaces__msg__Float32MultiArray__fini(&msg->finger_joint_positions);
}

bool
rosee_msg__srv__HandInfo_Request__are_equal(const rosee_msg__srv__HandInfo_Request * lhs, const rosee_msg__srv__HandInfo_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // motor_positions
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->motor_positions), &(rhs->motor_positions)))
  {
    return false;
  }
  // motor_positions_reference
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->motor_positions_reference), &(rhs->motor_positions_reference)))
  {
    return false;
  }
  // finger_joint_positions
  if (!example_interfaces__msg__Float32MultiArray__are_equal(
      &(lhs->finger_joint_positions), &(rhs->finger_joint_positions)))
  {
    return false;
  }
  return true;
}

bool
rosee_msg__srv__HandInfo_Request__copy(
  const rosee_msg__srv__HandInfo_Request * input,
  rosee_msg__srv__HandInfo_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // motor_positions
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->motor_positions), &(output->motor_positions)))
  {
    return false;
  }
  // motor_positions_reference
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->motor_positions_reference), &(output->motor_positions_reference)))
  {
    return false;
  }
  // finger_joint_positions
  if (!example_interfaces__msg__Float32MultiArray__copy(
      &(input->finger_joint_positions), &(output->finger_joint_positions)))
  {
    return false;
  }
  return true;
}

rosee_msg__srv__HandInfo_Request *
rosee_msg__srv__HandInfo_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__srv__HandInfo_Request * msg = (rosee_msg__srv__HandInfo_Request *)allocator.allocate(sizeof(rosee_msg__srv__HandInfo_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosee_msg__srv__HandInfo_Request));
  bool success = rosee_msg__srv__HandInfo_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosee_msg__srv__HandInfo_Request__destroy(rosee_msg__srv__HandInfo_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosee_msg__srv__HandInfo_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosee_msg__srv__HandInfo_Request__Sequence__init(rosee_msg__srv__HandInfo_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__srv__HandInfo_Request * data = NULL;

  if (size) {
    data = (rosee_msg__srv__HandInfo_Request *)allocator.zero_allocate(size, sizeof(rosee_msg__srv__HandInfo_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosee_msg__srv__HandInfo_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosee_msg__srv__HandInfo_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosee_msg__srv__HandInfo_Request__Sequence__fini(rosee_msg__srv__HandInfo_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosee_msg__srv__HandInfo_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosee_msg__srv__HandInfo_Request__Sequence *
rosee_msg__srv__HandInfo_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__srv__HandInfo_Request__Sequence * array = (rosee_msg__srv__HandInfo_Request__Sequence *)allocator.allocate(sizeof(rosee_msg__srv__HandInfo_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosee_msg__srv__HandInfo_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosee_msg__srv__HandInfo_Request__Sequence__destroy(rosee_msg__srv__HandInfo_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosee_msg__srv__HandInfo_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosee_msg__srv__HandInfo_Request__Sequence__are_equal(const rosee_msg__srv__HandInfo_Request__Sequence * lhs, const rosee_msg__srv__HandInfo_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosee_msg__srv__HandInfo_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosee_msg__srv__HandInfo_Request__Sequence__copy(
  const rosee_msg__srv__HandInfo_Request__Sequence * input,
  rosee_msg__srv__HandInfo_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosee_msg__srv__HandInfo_Request);
    rosee_msg__srv__HandInfo_Request * data =
      (rosee_msg__srv__HandInfo_Request *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosee_msg__srv__HandInfo_Request__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosee_msg__srv__HandInfo_Request__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosee_msg__srv__HandInfo_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `fingers_names`
// Member `motors_names`
#include "rosidl_runtime_c/string_functions.h"
// Member `transmission_matrix`
// Member `transmission_square_matrices`
// Member `transmission_augmented_matrices`
// Member `tips_jacobians_normal`
// Member `tips_jacobians_friction`
// already included above
// #include "example_interfaces/msg/detail/float32_multi_array__functions.h"
// Member `tips_forces_normal`
// Member `tips_forces_friction`
// Member `motors_stiffness`
// Member `tips_frictions`
// Member `motors_torque_limits`
// already included above
// #include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
rosee_msg__srv__HandInfo_Response__init(rosee_msg__srv__HandInfo_Response * msg)
{
  if (!msg) {
    return false;
  }
  // fingers_names
  if (!rosidl_runtime_c__String__Sequence__init(&msg->fingers_names, 0)) {
    rosee_msg__srv__HandInfo_Response__fini(msg);
    return false;
  }
  // motors_names
  if (!rosidl_runtime_c__String__Sequence__init(&msg->motors_names, 0)) {
    rosee_msg__srv__HandInfo_Response__fini(msg);
    return false;
  }
  // transmission_matrix
  if (!example_interfaces__msg__Float32MultiArray__init(&msg->transmission_matrix)) {
    rosee_msg__srv__HandInfo_Response__fini(msg);
    return false;
  }
  // transmission_square_matrices
  if (!example_interfaces__msg__Float32MultiArray__Sequence__init(&msg->transmission_square_matrices, 0)) {
    rosee_msg__srv__HandInfo_Response__fini(msg);
    return false;
  }
  // transmission_augmented_matrices
  if (!example_interfaces__msg__Float32MultiArray__Sequence__init(&msg->transmission_augmented_matrices, 0)) {
    rosee_msg__srv__HandInfo_Response__fini(msg);
    return false;
  }
  // tips_jacobians_normal
  if (!example_interfaces__msg__Float32MultiArray__Sequence__init(&msg->tips_jacobians_normal, 0)) {
    rosee_msg__srv__HandInfo_Response__fini(msg);
    return false;
  }
  // tips_jacobians_friction
  if (!example_interfaces__msg__Float32MultiArray__Sequence__init(&msg->tips_jacobians_friction, 0)) {
    rosee_msg__srv__HandInfo_Response__fini(msg);
    return false;
  }
  // tips_forces_normal
  if (!rosidl_runtime_c__float__Sequence__init(&msg->tips_forces_normal, 0)) {
    rosee_msg__srv__HandInfo_Response__fini(msg);
    return false;
  }
  // tips_forces_friction
  if (!rosidl_runtime_c__float__Sequence__init(&msg->tips_forces_friction, 0)) {
    rosee_msg__srv__HandInfo_Response__fini(msg);
    return false;
  }
  // motors_stiffness
  if (!rosidl_runtime_c__float__Sequence__init(&msg->motors_stiffness, 0)) {
    rosee_msg__srv__HandInfo_Response__fini(msg);
    return false;
  }
  // tips_frictions
  if (!rosidl_runtime_c__float__Sequence__init(&msg->tips_frictions, 0)) {
    rosee_msg__srv__HandInfo_Response__fini(msg);
    return false;
  }
  // motors_torque_limits
  if (!rosidl_runtime_c__float__Sequence__init(&msg->motors_torque_limits, 0)) {
    rosee_msg__srv__HandInfo_Response__fini(msg);
    return false;
  }
  return true;
}

void
rosee_msg__srv__HandInfo_Response__fini(rosee_msg__srv__HandInfo_Response * msg)
{
  if (!msg) {
    return;
  }
  // fingers_names
  rosidl_runtime_c__String__Sequence__fini(&msg->fingers_names);
  // motors_names
  rosidl_runtime_c__String__Sequence__fini(&msg->motors_names);
  // transmission_matrix
  example_interfaces__msg__Float32MultiArray__fini(&msg->transmission_matrix);
  // transmission_square_matrices
  example_interfaces__msg__Float32MultiArray__Sequence__fini(&msg->transmission_square_matrices);
  // transmission_augmented_matrices
  example_interfaces__msg__Float32MultiArray__Sequence__fini(&msg->transmission_augmented_matrices);
  // tips_jacobians_normal
  example_interfaces__msg__Float32MultiArray__Sequence__fini(&msg->tips_jacobians_normal);
  // tips_jacobians_friction
  example_interfaces__msg__Float32MultiArray__Sequence__fini(&msg->tips_jacobians_friction);
  // tips_forces_normal
  rosidl_runtime_c__float__Sequence__fini(&msg->tips_forces_normal);
  // tips_forces_friction
  rosidl_runtime_c__float__Sequence__fini(&msg->tips_forces_friction);
  // motors_stiffness
  rosidl_runtime_c__float__Sequence__fini(&msg->motors_stiffness);
  // tips_frictions
  rosidl_runtime_c__float__Sequence__fini(&msg->tips_frictions);
  // motors_torque_limits
  rosidl_runtime_c__float__Sequence__fini(&msg->motors_torque_limits);
}

bool
rosee_msg__srv__HandInfo_Response__are_equal(const rosee_msg__srv__HandInfo_Response * lhs, const rosee_msg__srv__HandInfo_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // fingers_names
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->fingers_names), &(rhs->fingers_names)))
  {
    return false;
  }
  // motors_names
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->motors_names), &(rhs->motors_names)))
  {
    return false;
  }
  // transmission_matrix
  if (!example_interfaces__msg__Float32MultiArray__are_equal(
      &(lhs->transmission_matrix), &(rhs->transmission_matrix)))
  {
    return false;
  }
  // transmission_square_matrices
  if (!example_interfaces__msg__Float32MultiArray__Sequence__are_equal(
      &(lhs->transmission_square_matrices), &(rhs->transmission_square_matrices)))
  {
    return false;
  }
  // transmission_augmented_matrices
  if (!example_interfaces__msg__Float32MultiArray__Sequence__are_equal(
      &(lhs->transmission_augmented_matrices), &(rhs->transmission_augmented_matrices)))
  {
    return false;
  }
  // tips_jacobians_normal
  if (!example_interfaces__msg__Float32MultiArray__Sequence__are_equal(
      &(lhs->tips_jacobians_normal), &(rhs->tips_jacobians_normal)))
  {
    return false;
  }
  // tips_jacobians_friction
  if (!example_interfaces__msg__Float32MultiArray__Sequence__are_equal(
      &(lhs->tips_jacobians_friction), &(rhs->tips_jacobians_friction)))
  {
    return false;
  }
  // tips_forces_normal
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->tips_forces_normal), &(rhs->tips_forces_normal)))
  {
    return false;
  }
  // tips_forces_friction
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->tips_forces_friction), &(rhs->tips_forces_friction)))
  {
    return false;
  }
  // motors_stiffness
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->motors_stiffness), &(rhs->motors_stiffness)))
  {
    return false;
  }
  // tips_frictions
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->tips_frictions), &(rhs->tips_frictions)))
  {
    return false;
  }
  // motors_torque_limits
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->motors_torque_limits), &(rhs->motors_torque_limits)))
  {
    return false;
  }
  return true;
}

bool
rosee_msg__srv__HandInfo_Response__copy(
  const rosee_msg__srv__HandInfo_Response * input,
  rosee_msg__srv__HandInfo_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // fingers_names
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->fingers_names), &(output->fingers_names)))
  {
    return false;
  }
  // motors_names
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->motors_names), &(output->motors_names)))
  {
    return false;
  }
  // transmission_matrix
  if (!example_interfaces__msg__Float32MultiArray__copy(
      &(input->transmission_matrix), &(output->transmission_matrix)))
  {
    return false;
  }
  // transmission_square_matrices
  if (!example_interfaces__msg__Float32MultiArray__Sequence__copy(
      &(input->transmission_square_matrices), &(output->transmission_square_matrices)))
  {
    return false;
  }
  // transmission_augmented_matrices
  if (!example_interfaces__msg__Float32MultiArray__Sequence__copy(
      &(input->transmission_augmented_matrices), &(output->transmission_augmented_matrices)))
  {
    return false;
  }
  // tips_jacobians_normal
  if (!example_interfaces__msg__Float32MultiArray__Sequence__copy(
      &(input->tips_jacobians_normal), &(output->tips_jacobians_normal)))
  {
    return false;
  }
  // tips_jacobians_friction
  if (!example_interfaces__msg__Float32MultiArray__Sequence__copy(
      &(input->tips_jacobians_friction), &(output->tips_jacobians_friction)))
  {
    return false;
  }
  // tips_forces_normal
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->tips_forces_normal), &(output->tips_forces_normal)))
  {
    return false;
  }
  // tips_forces_friction
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->tips_forces_friction), &(output->tips_forces_friction)))
  {
    return false;
  }
  // motors_stiffness
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->motors_stiffness), &(output->motors_stiffness)))
  {
    return false;
  }
  // tips_frictions
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->tips_frictions), &(output->tips_frictions)))
  {
    return false;
  }
  // motors_torque_limits
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->motors_torque_limits), &(output->motors_torque_limits)))
  {
    return false;
  }
  return true;
}

rosee_msg__srv__HandInfo_Response *
rosee_msg__srv__HandInfo_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__srv__HandInfo_Response * msg = (rosee_msg__srv__HandInfo_Response *)allocator.allocate(sizeof(rosee_msg__srv__HandInfo_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosee_msg__srv__HandInfo_Response));
  bool success = rosee_msg__srv__HandInfo_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosee_msg__srv__HandInfo_Response__destroy(rosee_msg__srv__HandInfo_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosee_msg__srv__HandInfo_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosee_msg__srv__HandInfo_Response__Sequence__init(rosee_msg__srv__HandInfo_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__srv__HandInfo_Response * data = NULL;

  if (size) {
    data = (rosee_msg__srv__HandInfo_Response *)allocator.zero_allocate(size, sizeof(rosee_msg__srv__HandInfo_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosee_msg__srv__HandInfo_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosee_msg__srv__HandInfo_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosee_msg__srv__HandInfo_Response__Sequence__fini(rosee_msg__srv__HandInfo_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosee_msg__srv__HandInfo_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosee_msg__srv__HandInfo_Response__Sequence *
rosee_msg__srv__HandInfo_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__srv__HandInfo_Response__Sequence * array = (rosee_msg__srv__HandInfo_Response__Sequence *)allocator.allocate(sizeof(rosee_msg__srv__HandInfo_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosee_msg__srv__HandInfo_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosee_msg__srv__HandInfo_Response__Sequence__destroy(rosee_msg__srv__HandInfo_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosee_msg__srv__HandInfo_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosee_msg__srv__HandInfo_Response__Sequence__are_equal(const rosee_msg__srv__HandInfo_Response__Sequence * lhs, const rosee_msg__srv__HandInfo_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosee_msg__srv__HandInfo_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosee_msg__srv__HandInfo_Response__Sequence__copy(
  const rosee_msg__srv__HandInfo_Response__Sequence * input,
  rosee_msg__srv__HandInfo_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosee_msg__srv__HandInfo_Response);
    rosee_msg__srv__HandInfo_Response * data =
      (rosee_msg__srv__HandInfo_Response *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosee_msg__srv__HandInfo_Response__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosee_msg__srv__HandInfo_Response__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosee_msg__srv__HandInfo_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
