// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rosee_msg:srv/HandInfo.idl
// generated code does not contain a copyright notice

#ifndef ROSEE_MSG__SRV__DETAIL__HAND_INFO__STRUCT_H_
#define ROSEE_MSG__SRV__DETAIL__HAND_INFO__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'motor_positions'
// Member 'motor_positions_reference'
#include "rosidl_runtime_c/primitives_sequence.h"
// Member 'finger_joint_positions'
#include "example_interfaces/msg/detail/float32_multi_array__struct.h"

// Struct defined in srv/HandInfo in the package rosee_msg.
typedef struct rosee_msg__srv__HandInfo_Request
{
  rosidl_runtime_c__float__Sequence motor_positions;
  rosidl_runtime_c__float__Sequence motor_positions_reference;
  example_interfaces__msg__Float32MultiArray finger_joint_positions;
} rosee_msg__srv__HandInfo_Request;

// Struct for a sequence of rosee_msg__srv__HandInfo_Request.
typedef struct rosee_msg__srv__HandInfo_Request__Sequence
{
  rosee_msg__srv__HandInfo_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rosee_msg__srv__HandInfo_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'fingers_names'
// Member 'motors_names'
#include "rosidl_runtime_c/string.h"
// Member 'transmission_matrix'
// Member 'transmission_square_matrices'
// Member 'transmission_augmented_matrices'
// Member 'tips_jacobians_normal'
// Member 'tips_jacobians_friction'
// already included above
// #include "example_interfaces/msg/detail/float32_multi_array__struct.h"
// Member 'tips_forces_normal'
// Member 'tips_forces_friction'
// Member 'motors_stiffness'
// Member 'tips_frictions'
// Member 'motors_torque_limits'
// already included above
// #include "rosidl_runtime_c/primitives_sequence.h"

// Struct defined in srv/HandInfo in the package rosee_msg.
typedef struct rosee_msg__srv__HandInfo_Response
{
  rosidl_runtime_c__String__Sequence fingers_names;
  rosidl_runtime_c__String__Sequence motors_names;
  example_interfaces__msg__Float32MultiArray transmission_matrix;
  example_interfaces__msg__Float32MultiArray__Sequence transmission_square_matrices;
  example_interfaces__msg__Float32MultiArray__Sequence transmission_augmented_matrices;
  example_interfaces__msg__Float32MultiArray__Sequence tips_jacobians_normal;
  example_interfaces__msg__Float32MultiArray__Sequence tips_jacobians_friction;
  rosidl_runtime_c__float__Sequence tips_forces_normal;
  rosidl_runtime_c__float__Sequence tips_forces_friction;
  rosidl_runtime_c__float__Sequence motors_stiffness;
  rosidl_runtime_c__float__Sequence tips_frictions;
  rosidl_runtime_c__float__Sequence motors_torque_limits;
} rosee_msg__srv__HandInfo_Response;

// Struct for a sequence of rosee_msg__srv__HandInfo_Response.
typedef struct rosee_msg__srv__HandInfo_Response__Sequence
{
  rosee_msg__srv__HandInfo_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rosee_msg__srv__HandInfo_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ROSEE_MSG__SRV__DETAIL__HAND_INFO__STRUCT_H_
