// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rosee_msg:srv/HandInfo.idl
// generated code does not contain a copyright notice

#ifndef ROSEE_MSG__SRV__DETAIL__HAND_INFO__STRUCT_HPP_
#define ROSEE_MSG__SRV__DETAIL__HAND_INFO__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'finger_joint_positions'
#include "example_interfaces/msg/detail/float32_multi_array__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rosee_msg__srv__HandInfo_Request __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__srv__HandInfo_Request __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct HandInfo_Request_
{
  using Type = HandInfo_Request_<ContainerAllocator>;

  explicit HandInfo_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : finger_joint_positions(_init)
  {
    (void)_init;
  }

  explicit HandInfo_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : finger_joint_positions(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _motor_positions_type =
    std::vector<float, typename ContainerAllocator::template rebind<float>::other>;
  _motor_positions_type motor_positions;
  using _motor_positions_reference_type =
    std::vector<float, typename ContainerAllocator::template rebind<float>::other>;
  _motor_positions_reference_type motor_positions_reference;
  using _finger_joint_positions_type =
    example_interfaces::msg::Float32MultiArray_<ContainerAllocator>;
  _finger_joint_positions_type finger_joint_positions;

  // setters for named parameter idiom
  Type & set__motor_positions(
    const std::vector<float, typename ContainerAllocator::template rebind<float>::other> & _arg)
  {
    this->motor_positions = _arg;
    return *this;
  }
  Type & set__motor_positions_reference(
    const std::vector<float, typename ContainerAllocator::template rebind<float>::other> & _arg)
  {
    this->motor_positions_reference = _arg;
    return *this;
  }
  Type & set__finger_joint_positions(
    const example_interfaces::msg::Float32MultiArray_<ContainerAllocator> & _arg)
  {
    this->finger_joint_positions = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosee_msg::srv::HandInfo_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::srv::HandInfo_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::srv::HandInfo_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::srv::HandInfo_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::srv::HandInfo_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::srv::HandInfo_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::srv::HandInfo_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::srv::HandInfo_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::srv::HandInfo_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::srv::HandInfo_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__srv__HandInfo_Request
    std::shared_ptr<rosee_msg::srv::HandInfo_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__srv__HandInfo_Request
    std::shared_ptr<rosee_msg::srv::HandInfo_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const HandInfo_Request_ & other) const
  {
    if (this->motor_positions != other.motor_positions) {
      return false;
    }
    if (this->motor_positions_reference != other.motor_positions_reference) {
      return false;
    }
    if (this->finger_joint_positions != other.finger_joint_positions) {
      return false;
    }
    return true;
  }
  bool operator!=(const HandInfo_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct HandInfo_Request_

// alias to use template instance with default allocator
using HandInfo_Request =
  rosee_msg::srv::HandInfo_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rosee_msg


// Include directives for member types
// Member 'transmission_matrix'
// Member 'transmission_square_matrices'
// Member 'transmission_augmented_matrices'
// Member 'tips_jacobians_normal'
// Member 'tips_jacobians_friction'
// already included above
// #include "example_interfaces/msg/detail/float32_multi_array__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rosee_msg__srv__HandInfo_Response __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__srv__HandInfo_Response __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct HandInfo_Response_
{
  using Type = HandInfo_Response_<ContainerAllocator>;

  explicit HandInfo_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : transmission_matrix(_init)
  {
    (void)_init;
  }

  explicit HandInfo_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : transmission_matrix(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _fingers_names_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _fingers_names_type fingers_names;
  using _motors_names_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _motors_names_type motors_names;
  using _transmission_matrix_type =
    example_interfaces::msg::Float32MultiArray_<ContainerAllocator>;
  _transmission_matrix_type transmission_matrix;
  using _transmission_square_matrices_type =
    std::vector<example_interfaces::msg::Float32MultiArray_<ContainerAllocator>, typename ContainerAllocator::template rebind<example_interfaces::msg::Float32MultiArray_<ContainerAllocator>>::other>;
  _transmission_square_matrices_type transmission_square_matrices;
  using _transmission_augmented_matrices_type =
    std::vector<example_interfaces::msg::Float32MultiArray_<ContainerAllocator>, typename ContainerAllocator::template rebind<example_interfaces::msg::Float32MultiArray_<ContainerAllocator>>::other>;
  _transmission_augmented_matrices_type transmission_augmented_matrices;
  using _tips_jacobians_normal_type =
    std::vector<example_interfaces::msg::Float32MultiArray_<ContainerAllocator>, typename ContainerAllocator::template rebind<example_interfaces::msg::Float32MultiArray_<ContainerAllocator>>::other>;
  _tips_jacobians_normal_type tips_jacobians_normal;
  using _tips_jacobians_friction_type =
    std::vector<example_interfaces::msg::Float32MultiArray_<ContainerAllocator>, typename ContainerAllocator::template rebind<example_interfaces::msg::Float32MultiArray_<ContainerAllocator>>::other>;
  _tips_jacobians_friction_type tips_jacobians_friction;
  using _tips_forces_normal_type =
    std::vector<float, typename ContainerAllocator::template rebind<float>::other>;
  _tips_forces_normal_type tips_forces_normal;
  using _tips_forces_friction_type =
    std::vector<float, typename ContainerAllocator::template rebind<float>::other>;
  _tips_forces_friction_type tips_forces_friction;
  using _motors_stiffness_type =
    std::vector<float, typename ContainerAllocator::template rebind<float>::other>;
  _motors_stiffness_type motors_stiffness;
  using _tips_frictions_type =
    std::vector<float, typename ContainerAllocator::template rebind<float>::other>;
  _tips_frictions_type tips_frictions;
  using _motors_torque_limits_type =
    std::vector<float, typename ContainerAllocator::template rebind<float>::other>;
  _motors_torque_limits_type motors_torque_limits;

  // setters for named parameter idiom
  Type & set__fingers_names(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->fingers_names = _arg;
    return *this;
  }
  Type & set__motors_names(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->motors_names = _arg;
    return *this;
  }
  Type & set__transmission_matrix(
    const example_interfaces::msg::Float32MultiArray_<ContainerAllocator> & _arg)
  {
    this->transmission_matrix = _arg;
    return *this;
  }
  Type & set__transmission_square_matrices(
    const std::vector<example_interfaces::msg::Float32MultiArray_<ContainerAllocator>, typename ContainerAllocator::template rebind<example_interfaces::msg::Float32MultiArray_<ContainerAllocator>>::other> & _arg)
  {
    this->transmission_square_matrices = _arg;
    return *this;
  }
  Type & set__transmission_augmented_matrices(
    const std::vector<example_interfaces::msg::Float32MultiArray_<ContainerAllocator>, typename ContainerAllocator::template rebind<example_interfaces::msg::Float32MultiArray_<ContainerAllocator>>::other> & _arg)
  {
    this->transmission_augmented_matrices = _arg;
    return *this;
  }
  Type & set__tips_jacobians_normal(
    const std::vector<example_interfaces::msg::Float32MultiArray_<ContainerAllocator>, typename ContainerAllocator::template rebind<example_interfaces::msg::Float32MultiArray_<ContainerAllocator>>::other> & _arg)
  {
    this->tips_jacobians_normal = _arg;
    return *this;
  }
  Type & set__tips_jacobians_friction(
    const std::vector<example_interfaces::msg::Float32MultiArray_<ContainerAllocator>, typename ContainerAllocator::template rebind<example_interfaces::msg::Float32MultiArray_<ContainerAllocator>>::other> & _arg)
  {
    this->tips_jacobians_friction = _arg;
    return *this;
  }
  Type & set__tips_forces_normal(
    const std::vector<float, typename ContainerAllocator::template rebind<float>::other> & _arg)
  {
    this->tips_forces_normal = _arg;
    return *this;
  }
  Type & set__tips_forces_friction(
    const std::vector<float, typename ContainerAllocator::template rebind<float>::other> & _arg)
  {
    this->tips_forces_friction = _arg;
    return *this;
  }
  Type & set__motors_stiffness(
    const std::vector<float, typename ContainerAllocator::template rebind<float>::other> & _arg)
  {
    this->motors_stiffness = _arg;
    return *this;
  }
  Type & set__tips_frictions(
    const std::vector<float, typename ContainerAllocator::template rebind<float>::other> & _arg)
  {
    this->tips_frictions = _arg;
    return *this;
  }
  Type & set__motors_torque_limits(
    const std::vector<float, typename ContainerAllocator::template rebind<float>::other> & _arg)
  {
    this->motors_torque_limits = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosee_msg::srv::HandInfo_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::srv::HandInfo_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::srv::HandInfo_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::srv::HandInfo_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::srv::HandInfo_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::srv::HandInfo_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::srv::HandInfo_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::srv::HandInfo_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::srv::HandInfo_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::srv::HandInfo_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__srv__HandInfo_Response
    std::shared_ptr<rosee_msg::srv::HandInfo_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__srv__HandInfo_Response
    std::shared_ptr<rosee_msg::srv::HandInfo_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const HandInfo_Response_ & other) const
  {
    if (this->fingers_names != other.fingers_names) {
      return false;
    }
    if (this->motors_names != other.motors_names) {
      return false;
    }
    if (this->transmission_matrix != other.transmission_matrix) {
      return false;
    }
    if (this->transmission_square_matrices != other.transmission_square_matrices) {
      return false;
    }
    if (this->transmission_augmented_matrices != other.transmission_augmented_matrices) {
      return false;
    }
    if (this->tips_jacobians_normal != other.tips_jacobians_normal) {
      return false;
    }
    if (this->tips_jacobians_friction != other.tips_jacobians_friction) {
      return false;
    }
    if (this->tips_forces_normal != other.tips_forces_normal) {
      return false;
    }
    if (this->tips_forces_friction != other.tips_forces_friction) {
      return false;
    }
    if (this->motors_stiffness != other.motors_stiffness) {
      return false;
    }
    if (this->tips_frictions != other.tips_frictions) {
      return false;
    }
    if (this->motors_torque_limits != other.motors_torque_limits) {
      return false;
    }
    return true;
  }
  bool operator!=(const HandInfo_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct HandInfo_Response_

// alias to use template instance with default allocator
using HandInfo_Response =
  rosee_msg::srv::HandInfo_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rosee_msg

namespace rosee_msg
{

namespace srv
{

struct HandInfo
{
  using Request = rosee_msg::srv::HandInfo_Request;
  using Response = rosee_msg::srv::HandInfo_Response;
};

}  // namespace srv

}  // namespace rosee_msg

#endif  // ROSEE_MSG__SRV__DETAIL__HAND_INFO__STRUCT_HPP_
