// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rosee_msg:action/ROSEECommand.idl
// generated code does not contain a copyright notice
#include "rosee_msg/action/detail/rosee_command__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `goal_action`
#include "rosee_msg/msg/detail/rosee_action_control__functions.h"

bool
rosee_msg__action__ROSEECommand_Goal__init(rosee_msg__action__ROSEECommand_Goal * msg)
{
  if (!msg) {
    return false;
  }
  // goal_action
  if (!rosee_msg__msg__ROSEEActionControl__init(&msg->goal_action)) {
    rosee_msg__action__ROSEECommand_Goal__fini(msg);
    return false;
  }
  return true;
}

void
rosee_msg__action__ROSEECommand_Goal__fini(rosee_msg__action__ROSEECommand_Goal * msg)
{
  if (!msg) {
    return;
  }
  // goal_action
  rosee_msg__msg__ROSEEActionControl__fini(&msg->goal_action);
}

bool
rosee_msg__action__ROSEECommand_Goal__are_equal(const rosee_msg__action__ROSEECommand_Goal * lhs, const rosee_msg__action__ROSEECommand_Goal * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_action
  if (!rosee_msg__msg__ROSEEActionControl__are_equal(
      &(lhs->goal_action), &(rhs->goal_action)))
  {
    return false;
  }
  return true;
}

bool
rosee_msg__action__ROSEECommand_Goal__copy(
  const rosee_msg__action__ROSEECommand_Goal * input,
  rosee_msg__action__ROSEECommand_Goal * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_action
  if (!rosee_msg__msg__ROSEEActionControl__copy(
      &(input->goal_action), &(output->goal_action)))
  {
    return false;
  }
  return true;
}

rosee_msg__action__ROSEECommand_Goal *
rosee_msg__action__ROSEECommand_Goal__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_Goal * msg = (rosee_msg__action__ROSEECommand_Goal *)allocator.allocate(sizeof(rosee_msg__action__ROSEECommand_Goal), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosee_msg__action__ROSEECommand_Goal));
  bool success = rosee_msg__action__ROSEECommand_Goal__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosee_msg__action__ROSEECommand_Goal__destroy(rosee_msg__action__ROSEECommand_Goal * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosee_msg__action__ROSEECommand_Goal__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosee_msg__action__ROSEECommand_Goal__Sequence__init(rosee_msg__action__ROSEECommand_Goal__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_Goal * data = NULL;

  if (size) {
    data = (rosee_msg__action__ROSEECommand_Goal *)allocator.zero_allocate(size, sizeof(rosee_msg__action__ROSEECommand_Goal), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosee_msg__action__ROSEECommand_Goal__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosee_msg__action__ROSEECommand_Goal__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosee_msg__action__ROSEECommand_Goal__Sequence__fini(rosee_msg__action__ROSEECommand_Goal__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosee_msg__action__ROSEECommand_Goal__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosee_msg__action__ROSEECommand_Goal__Sequence *
rosee_msg__action__ROSEECommand_Goal__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_Goal__Sequence * array = (rosee_msg__action__ROSEECommand_Goal__Sequence *)allocator.allocate(sizeof(rosee_msg__action__ROSEECommand_Goal__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosee_msg__action__ROSEECommand_Goal__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosee_msg__action__ROSEECommand_Goal__Sequence__destroy(rosee_msg__action__ROSEECommand_Goal__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosee_msg__action__ROSEECommand_Goal__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosee_msg__action__ROSEECommand_Goal__Sequence__are_equal(const rosee_msg__action__ROSEECommand_Goal__Sequence * lhs, const rosee_msg__action__ROSEECommand_Goal__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosee_msg__action__ROSEECommand_Goal__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosee_msg__action__ROSEECommand_Goal__Sequence__copy(
  const rosee_msg__action__ROSEECommand_Goal__Sequence * input,
  rosee_msg__action__ROSEECommand_Goal__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosee_msg__action__ROSEECommand_Goal);
    rosee_msg__action__ROSEECommand_Goal * data =
      (rosee_msg__action__ROSEECommand_Goal *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosee_msg__action__ROSEECommand_Goal__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosee_msg__action__ROSEECommand_Goal__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosee_msg__action__ROSEECommand_Goal__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `completed_action`
// already included above
// #include "rosee_msg/msg/detail/rosee_action_control__functions.h"

bool
rosee_msg__action__ROSEECommand_Result__init(rosee_msg__action__ROSEECommand_Result * msg)
{
  if (!msg) {
    return false;
  }
  // completed_action
  if (!rosee_msg__msg__ROSEEActionControl__init(&msg->completed_action)) {
    rosee_msg__action__ROSEECommand_Result__fini(msg);
    return false;
  }
  return true;
}

void
rosee_msg__action__ROSEECommand_Result__fini(rosee_msg__action__ROSEECommand_Result * msg)
{
  if (!msg) {
    return;
  }
  // completed_action
  rosee_msg__msg__ROSEEActionControl__fini(&msg->completed_action);
}

bool
rosee_msg__action__ROSEECommand_Result__are_equal(const rosee_msg__action__ROSEECommand_Result * lhs, const rosee_msg__action__ROSEECommand_Result * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // completed_action
  if (!rosee_msg__msg__ROSEEActionControl__are_equal(
      &(lhs->completed_action), &(rhs->completed_action)))
  {
    return false;
  }
  return true;
}

bool
rosee_msg__action__ROSEECommand_Result__copy(
  const rosee_msg__action__ROSEECommand_Result * input,
  rosee_msg__action__ROSEECommand_Result * output)
{
  if (!input || !output) {
    return false;
  }
  // completed_action
  if (!rosee_msg__msg__ROSEEActionControl__copy(
      &(input->completed_action), &(output->completed_action)))
  {
    return false;
  }
  return true;
}

rosee_msg__action__ROSEECommand_Result *
rosee_msg__action__ROSEECommand_Result__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_Result * msg = (rosee_msg__action__ROSEECommand_Result *)allocator.allocate(sizeof(rosee_msg__action__ROSEECommand_Result), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosee_msg__action__ROSEECommand_Result));
  bool success = rosee_msg__action__ROSEECommand_Result__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosee_msg__action__ROSEECommand_Result__destroy(rosee_msg__action__ROSEECommand_Result * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosee_msg__action__ROSEECommand_Result__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosee_msg__action__ROSEECommand_Result__Sequence__init(rosee_msg__action__ROSEECommand_Result__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_Result * data = NULL;

  if (size) {
    data = (rosee_msg__action__ROSEECommand_Result *)allocator.zero_allocate(size, sizeof(rosee_msg__action__ROSEECommand_Result), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosee_msg__action__ROSEECommand_Result__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosee_msg__action__ROSEECommand_Result__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosee_msg__action__ROSEECommand_Result__Sequence__fini(rosee_msg__action__ROSEECommand_Result__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosee_msg__action__ROSEECommand_Result__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosee_msg__action__ROSEECommand_Result__Sequence *
rosee_msg__action__ROSEECommand_Result__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_Result__Sequence * array = (rosee_msg__action__ROSEECommand_Result__Sequence *)allocator.allocate(sizeof(rosee_msg__action__ROSEECommand_Result__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosee_msg__action__ROSEECommand_Result__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosee_msg__action__ROSEECommand_Result__Sequence__destroy(rosee_msg__action__ROSEECommand_Result__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosee_msg__action__ROSEECommand_Result__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosee_msg__action__ROSEECommand_Result__Sequence__are_equal(const rosee_msg__action__ROSEECommand_Result__Sequence * lhs, const rosee_msg__action__ROSEECommand_Result__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosee_msg__action__ROSEECommand_Result__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosee_msg__action__ROSEECommand_Result__Sequence__copy(
  const rosee_msg__action__ROSEECommand_Result__Sequence * input,
  rosee_msg__action__ROSEECommand_Result__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosee_msg__action__ROSEECommand_Result);
    rosee_msg__action__ROSEECommand_Result * data =
      (rosee_msg__action__ROSEECommand_Result *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosee_msg__action__ROSEECommand_Result__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosee_msg__action__ROSEECommand_Result__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosee_msg__action__ROSEECommand_Result__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `action_name_current`
#include "rosidl_runtime_c/string_functions.h"

bool
rosee_msg__action__ROSEECommand_Feedback__init(rosee_msg__action__ROSEECommand_Feedback * msg)
{
  if (!msg) {
    return false;
  }
  // completation_percentage
  // action_name_current
  if (!rosidl_runtime_c__String__init(&msg->action_name_current)) {
    rosee_msg__action__ROSEECommand_Feedback__fini(msg);
    return false;
  }
  return true;
}

void
rosee_msg__action__ROSEECommand_Feedback__fini(rosee_msg__action__ROSEECommand_Feedback * msg)
{
  if (!msg) {
    return;
  }
  // completation_percentage
  // action_name_current
  rosidl_runtime_c__String__fini(&msg->action_name_current);
}

bool
rosee_msg__action__ROSEECommand_Feedback__are_equal(const rosee_msg__action__ROSEECommand_Feedback * lhs, const rosee_msg__action__ROSEECommand_Feedback * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // completation_percentage
  if (lhs->completation_percentage != rhs->completation_percentage) {
    return false;
  }
  // action_name_current
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->action_name_current), &(rhs->action_name_current)))
  {
    return false;
  }
  return true;
}

bool
rosee_msg__action__ROSEECommand_Feedback__copy(
  const rosee_msg__action__ROSEECommand_Feedback * input,
  rosee_msg__action__ROSEECommand_Feedback * output)
{
  if (!input || !output) {
    return false;
  }
  // completation_percentage
  output->completation_percentage = input->completation_percentage;
  // action_name_current
  if (!rosidl_runtime_c__String__copy(
      &(input->action_name_current), &(output->action_name_current)))
  {
    return false;
  }
  return true;
}

rosee_msg__action__ROSEECommand_Feedback *
rosee_msg__action__ROSEECommand_Feedback__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_Feedback * msg = (rosee_msg__action__ROSEECommand_Feedback *)allocator.allocate(sizeof(rosee_msg__action__ROSEECommand_Feedback), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosee_msg__action__ROSEECommand_Feedback));
  bool success = rosee_msg__action__ROSEECommand_Feedback__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosee_msg__action__ROSEECommand_Feedback__destroy(rosee_msg__action__ROSEECommand_Feedback * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosee_msg__action__ROSEECommand_Feedback__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosee_msg__action__ROSEECommand_Feedback__Sequence__init(rosee_msg__action__ROSEECommand_Feedback__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_Feedback * data = NULL;

  if (size) {
    data = (rosee_msg__action__ROSEECommand_Feedback *)allocator.zero_allocate(size, sizeof(rosee_msg__action__ROSEECommand_Feedback), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosee_msg__action__ROSEECommand_Feedback__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosee_msg__action__ROSEECommand_Feedback__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosee_msg__action__ROSEECommand_Feedback__Sequence__fini(rosee_msg__action__ROSEECommand_Feedback__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosee_msg__action__ROSEECommand_Feedback__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosee_msg__action__ROSEECommand_Feedback__Sequence *
rosee_msg__action__ROSEECommand_Feedback__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_Feedback__Sequence * array = (rosee_msg__action__ROSEECommand_Feedback__Sequence *)allocator.allocate(sizeof(rosee_msg__action__ROSEECommand_Feedback__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosee_msg__action__ROSEECommand_Feedback__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosee_msg__action__ROSEECommand_Feedback__Sequence__destroy(rosee_msg__action__ROSEECommand_Feedback__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosee_msg__action__ROSEECommand_Feedback__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosee_msg__action__ROSEECommand_Feedback__Sequence__are_equal(const rosee_msg__action__ROSEECommand_Feedback__Sequence * lhs, const rosee_msg__action__ROSEECommand_Feedback__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosee_msg__action__ROSEECommand_Feedback__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosee_msg__action__ROSEECommand_Feedback__Sequence__copy(
  const rosee_msg__action__ROSEECommand_Feedback__Sequence * input,
  rosee_msg__action__ROSEECommand_Feedback__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosee_msg__action__ROSEECommand_Feedback);
    rosee_msg__action__ROSEECommand_Feedback * data =
      (rosee_msg__action__ROSEECommand_Feedback *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosee_msg__action__ROSEECommand_Feedback__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosee_msg__action__ROSEECommand_Feedback__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosee_msg__action__ROSEECommand_Feedback__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
#include "unique_identifier_msgs/msg/detail/uuid__functions.h"
// Member `goal`
// already included above
// #include "rosee_msg/action/detail/rosee_command__functions.h"

bool
rosee_msg__action__ROSEECommand_SendGoal_Request__init(rosee_msg__action__ROSEECommand_SendGoal_Request * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    rosee_msg__action__ROSEECommand_SendGoal_Request__fini(msg);
    return false;
  }
  // goal
  if (!rosee_msg__action__ROSEECommand_Goal__init(&msg->goal)) {
    rosee_msg__action__ROSEECommand_SendGoal_Request__fini(msg);
    return false;
  }
  return true;
}

void
rosee_msg__action__ROSEECommand_SendGoal_Request__fini(rosee_msg__action__ROSEECommand_SendGoal_Request * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
  // goal
  rosee_msg__action__ROSEECommand_Goal__fini(&msg->goal);
}

bool
rosee_msg__action__ROSEECommand_SendGoal_Request__are_equal(const rosee_msg__action__ROSEECommand_SendGoal_Request * lhs, const rosee_msg__action__ROSEECommand_SendGoal_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  // goal
  if (!rosee_msg__action__ROSEECommand_Goal__are_equal(
      &(lhs->goal), &(rhs->goal)))
  {
    return false;
  }
  return true;
}

bool
rosee_msg__action__ROSEECommand_SendGoal_Request__copy(
  const rosee_msg__action__ROSEECommand_SendGoal_Request * input,
  rosee_msg__action__ROSEECommand_SendGoal_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  // goal
  if (!rosee_msg__action__ROSEECommand_Goal__copy(
      &(input->goal), &(output->goal)))
  {
    return false;
  }
  return true;
}

rosee_msg__action__ROSEECommand_SendGoal_Request *
rosee_msg__action__ROSEECommand_SendGoal_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_SendGoal_Request * msg = (rosee_msg__action__ROSEECommand_SendGoal_Request *)allocator.allocate(sizeof(rosee_msg__action__ROSEECommand_SendGoal_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosee_msg__action__ROSEECommand_SendGoal_Request));
  bool success = rosee_msg__action__ROSEECommand_SendGoal_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosee_msg__action__ROSEECommand_SendGoal_Request__destroy(rosee_msg__action__ROSEECommand_SendGoal_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosee_msg__action__ROSEECommand_SendGoal_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence__init(rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_SendGoal_Request * data = NULL;

  if (size) {
    data = (rosee_msg__action__ROSEECommand_SendGoal_Request *)allocator.zero_allocate(size, sizeof(rosee_msg__action__ROSEECommand_SendGoal_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosee_msg__action__ROSEECommand_SendGoal_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosee_msg__action__ROSEECommand_SendGoal_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence__fini(rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosee_msg__action__ROSEECommand_SendGoal_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence *
rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence * array = (rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence *)allocator.allocate(sizeof(rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence__destroy(rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence__are_equal(const rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence * lhs, const rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosee_msg__action__ROSEECommand_SendGoal_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence__copy(
  const rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence * input,
  rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosee_msg__action__ROSEECommand_SendGoal_Request);
    rosee_msg__action__ROSEECommand_SendGoal_Request * data =
      (rosee_msg__action__ROSEECommand_SendGoal_Request *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosee_msg__action__ROSEECommand_SendGoal_Request__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosee_msg__action__ROSEECommand_SendGoal_Request__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosee_msg__action__ROSEECommand_SendGoal_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
rosee_msg__action__ROSEECommand_SendGoal_Response__init(rosee_msg__action__ROSEECommand_SendGoal_Response * msg)
{
  if (!msg) {
    return false;
  }
  // accepted
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    rosee_msg__action__ROSEECommand_SendGoal_Response__fini(msg);
    return false;
  }
  return true;
}

void
rosee_msg__action__ROSEECommand_SendGoal_Response__fini(rosee_msg__action__ROSEECommand_SendGoal_Response * msg)
{
  if (!msg) {
    return;
  }
  // accepted
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
}

bool
rosee_msg__action__ROSEECommand_SendGoal_Response__are_equal(const rosee_msg__action__ROSEECommand_SendGoal_Response * lhs, const rosee_msg__action__ROSEECommand_SendGoal_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // accepted
  if (lhs->accepted != rhs->accepted) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  return true;
}

bool
rosee_msg__action__ROSEECommand_SendGoal_Response__copy(
  const rosee_msg__action__ROSEECommand_SendGoal_Response * input,
  rosee_msg__action__ROSEECommand_SendGoal_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // accepted
  output->accepted = input->accepted;
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  return true;
}

rosee_msg__action__ROSEECommand_SendGoal_Response *
rosee_msg__action__ROSEECommand_SendGoal_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_SendGoal_Response * msg = (rosee_msg__action__ROSEECommand_SendGoal_Response *)allocator.allocate(sizeof(rosee_msg__action__ROSEECommand_SendGoal_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosee_msg__action__ROSEECommand_SendGoal_Response));
  bool success = rosee_msg__action__ROSEECommand_SendGoal_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosee_msg__action__ROSEECommand_SendGoal_Response__destroy(rosee_msg__action__ROSEECommand_SendGoal_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosee_msg__action__ROSEECommand_SendGoal_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence__init(rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_SendGoal_Response * data = NULL;

  if (size) {
    data = (rosee_msg__action__ROSEECommand_SendGoal_Response *)allocator.zero_allocate(size, sizeof(rosee_msg__action__ROSEECommand_SendGoal_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosee_msg__action__ROSEECommand_SendGoal_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosee_msg__action__ROSEECommand_SendGoal_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence__fini(rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosee_msg__action__ROSEECommand_SendGoal_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence *
rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence * array = (rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence *)allocator.allocate(sizeof(rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence__destroy(rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence__are_equal(const rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence * lhs, const rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosee_msg__action__ROSEECommand_SendGoal_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence__copy(
  const rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence * input,
  rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosee_msg__action__ROSEECommand_SendGoal_Response);
    rosee_msg__action__ROSEECommand_SendGoal_Response * data =
      (rosee_msg__action__ROSEECommand_SendGoal_Response *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosee_msg__action__ROSEECommand_SendGoal_Response__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosee_msg__action__ROSEECommand_SendGoal_Response__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosee_msg__action__ROSEECommand_SendGoal_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__functions.h"

bool
rosee_msg__action__ROSEECommand_GetResult_Request__init(rosee_msg__action__ROSEECommand_GetResult_Request * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    rosee_msg__action__ROSEECommand_GetResult_Request__fini(msg);
    return false;
  }
  return true;
}

void
rosee_msg__action__ROSEECommand_GetResult_Request__fini(rosee_msg__action__ROSEECommand_GetResult_Request * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
}

bool
rosee_msg__action__ROSEECommand_GetResult_Request__are_equal(const rosee_msg__action__ROSEECommand_GetResult_Request * lhs, const rosee_msg__action__ROSEECommand_GetResult_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  return true;
}

bool
rosee_msg__action__ROSEECommand_GetResult_Request__copy(
  const rosee_msg__action__ROSEECommand_GetResult_Request * input,
  rosee_msg__action__ROSEECommand_GetResult_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  return true;
}

rosee_msg__action__ROSEECommand_GetResult_Request *
rosee_msg__action__ROSEECommand_GetResult_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_GetResult_Request * msg = (rosee_msg__action__ROSEECommand_GetResult_Request *)allocator.allocate(sizeof(rosee_msg__action__ROSEECommand_GetResult_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosee_msg__action__ROSEECommand_GetResult_Request));
  bool success = rosee_msg__action__ROSEECommand_GetResult_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosee_msg__action__ROSEECommand_GetResult_Request__destroy(rosee_msg__action__ROSEECommand_GetResult_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosee_msg__action__ROSEECommand_GetResult_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosee_msg__action__ROSEECommand_GetResult_Request__Sequence__init(rosee_msg__action__ROSEECommand_GetResult_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_GetResult_Request * data = NULL;

  if (size) {
    data = (rosee_msg__action__ROSEECommand_GetResult_Request *)allocator.zero_allocate(size, sizeof(rosee_msg__action__ROSEECommand_GetResult_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosee_msg__action__ROSEECommand_GetResult_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosee_msg__action__ROSEECommand_GetResult_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosee_msg__action__ROSEECommand_GetResult_Request__Sequence__fini(rosee_msg__action__ROSEECommand_GetResult_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosee_msg__action__ROSEECommand_GetResult_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosee_msg__action__ROSEECommand_GetResult_Request__Sequence *
rosee_msg__action__ROSEECommand_GetResult_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_GetResult_Request__Sequence * array = (rosee_msg__action__ROSEECommand_GetResult_Request__Sequence *)allocator.allocate(sizeof(rosee_msg__action__ROSEECommand_GetResult_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosee_msg__action__ROSEECommand_GetResult_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosee_msg__action__ROSEECommand_GetResult_Request__Sequence__destroy(rosee_msg__action__ROSEECommand_GetResult_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosee_msg__action__ROSEECommand_GetResult_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosee_msg__action__ROSEECommand_GetResult_Request__Sequence__are_equal(const rosee_msg__action__ROSEECommand_GetResult_Request__Sequence * lhs, const rosee_msg__action__ROSEECommand_GetResult_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosee_msg__action__ROSEECommand_GetResult_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosee_msg__action__ROSEECommand_GetResult_Request__Sequence__copy(
  const rosee_msg__action__ROSEECommand_GetResult_Request__Sequence * input,
  rosee_msg__action__ROSEECommand_GetResult_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosee_msg__action__ROSEECommand_GetResult_Request);
    rosee_msg__action__ROSEECommand_GetResult_Request * data =
      (rosee_msg__action__ROSEECommand_GetResult_Request *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosee_msg__action__ROSEECommand_GetResult_Request__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosee_msg__action__ROSEECommand_GetResult_Request__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosee_msg__action__ROSEECommand_GetResult_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `result`
// already included above
// #include "rosee_msg/action/detail/rosee_command__functions.h"

bool
rosee_msg__action__ROSEECommand_GetResult_Response__init(rosee_msg__action__ROSEECommand_GetResult_Response * msg)
{
  if (!msg) {
    return false;
  }
  // status
  // result
  if (!rosee_msg__action__ROSEECommand_Result__init(&msg->result)) {
    rosee_msg__action__ROSEECommand_GetResult_Response__fini(msg);
    return false;
  }
  return true;
}

void
rosee_msg__action__ROSEECommand_GetResult_Response__fini(rosee_msg__action__ROSEECommand_GetResult_Response * msg)
{
  if (!msg) {
    return;
  }
  // status
  // result
  rosee_msg__action__ROSEECommand_Result__fini(&msg->result);
}

bool
rosee_msg__action__ROSEECommand_GetResult_Response__are_equal(const rosee_msg__action__ROSEECommand_GetResult_Response * lhs, const rosee_msg__action__ROSEECommand_GetResult_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // status
  if (lhs->status != rhs->status) {
    return false;
  }
  // result
  if (!rosee_msg__action__ROSEECommand_Result__are_equal(
      &(lhs->result), &(rhs->result)))
  {
    return false;
  }
  return true;
}

bool
rosee_msg__action__ROSEECommand_GetResult_Response__copy(
  const rosee_msg__action__ROSEECommand_GetResult_Response * input,
  rosee_msg__action__ROSEECommand_GetResult_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // status
  output->status = input->status;
  // result
  if (!rosee_msg__action__ROSEECommand_Result__copy(
      &(input->result), &(output->result)))
  {
    return false;
  }
  return true;
}

rosee_msg__action__ROSEECommand_GetResult_Response *
rosee_msg__action__ROSEECommand_GetResult_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_GetResult_Response * msg = (rosee_msg__action__ROSEECommand_GetResult_Response *)allocator.allocate(sizeof(rosee_msg__action__ROSEECommand_GetResult_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosee_msg__action__ROSEECommand_GetResult_Response));
  bool success = rosee_msg__action__ROSEECommand_GetResult_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosee_msg__action__ROSEECommand_GetResult_Response__destroy(rosee_msg__action__ROSEECommand_GetResult_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosee_msg__action__ROSEECommand_GetResult_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosee_msg__action__ROSEECommand_GetResult_Response__Sequence__init(rosee_msg__action__ROSEECommand_GetResult_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_GetResult_Response * data = NULL;

  if (size) {
    data = (rosee_msg__action__ROSEECommand_GetResult_Response *)allocator.zero_allocate(size, sizeof(rosee_msg__action__ROSEECommand_GetResult_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosee_msg__action__ROSEECommand_GetResult_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosee_msg__action__ROSEECommand_GetResult_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosee_msg__action__ROSEECommand_GetResult_Response__Sequence__fini(rosee_msg__action__ROSEECommand_GetResult_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosee_msg__action__ROSEECommand_GetResult_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosee_msg__action__ROSEECommand_GetResult_Response__Sequence *
rosee_msg__action__ROSEECommand_GetResult_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_GetResult_Response__Sequence * array = (rosee_msg__action__ROSEECommand_GetResult_Response__Sequence *)allocator.allocate(sizeof(rosee_msg__action__ROSEECommand_GetResult_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosee_msg__action__ROSEECommand_GetResult_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosee_msg__action__ROSEECommand_GetResult_Response__Sequence__destroy(rosee_msg__action__ROSEECommand_GetResult_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosee_msg__action__ROSEECommand_GetResult_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosee_msg__action__ROSEECommand_GetResult_Response__Sequence__are_equal(const rosee_msg__action__ROSEECommand_GetResult_Response__Sequence * lhs, const rosee_msg__action__ROSEECommand_GetResult_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosee_msg__action__ROSEECommand_GetResult_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosee_msg__action__ROSEECommand_GetResult_Response__Sequence__copy(
  const rosee_msg__action__ROSEECommand_GetResult_Response__Sequence * input,
  rosee_msg__action__ROSEECommand_GetResult_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosee_msg__action__ROSEECommand_GetResult_Response);
    rosee_msg__action__ROSEECommand_GetResult_Response * data =
      (rosee_msg__action__ROSEECommand_GetResult_Response *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosee_msg__action__ROSEECommand_GetResult_Response__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosee_msg__action__ROSEECommand_GetResult_Response__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosee_msg__action__ROSEECommand_GetResult_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__functions.h"
// Member `feedback`
// already included above
// #include "rosee_msg/action/detail/rosee_command__functions.h"

bool
rosee_msg__action__ROSEECommand_FeedbackMessage__init(rosee_msg__action__ROSEECommand_FeedbackMessage * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    rosee_msg__action__ROSEECommand_FeedbackMessage__fini(msg);
    return false;
  }
  // feedback
  if (!rosee_msg__action__ROSEECommand_Feedback__init(&msg->feedback)) {
    rosee_msg__action__ROSEECommand_FeedbackMessage__fini(msg);
    return false;
  }
  return true;
}

void
rosee_msg__action__ROSEECommand_FeedbackMessage__fini(rosee_msg__action__ROSEECommand_FeedbackMessage * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
  // feedback
  rosee_msg__action__ROSEECommand_Feedback__fini(&msg->feedback);
}

bool
rosee_msg__action__ROSEECommand_FeedbackMessage__are_equal(const rosee_msg__action__ROSEECommand_FeedbackMessage * lhs, const rosee_msg__action__ROSEECommand_FeedbackMessage * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  // feedback
  if (!rosee_msg__action__ROSEECommand_Feedback__are_equal(
      &(lhs->feedback), &(rhs->feedback)))
  {
    return false;
  }
  return true;
}

bool
rosee_msg__action__ROSEECommand_FeedbackMessage__copy(
  const rosee_msg__action__ROSEECommand_FeedbackMessage * input,
  rosee_msg__action__ROSEECommand_FeedbackMessage * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  // feedback
  if (!rosee_msg__action__ROSEECommand_Feedback__copy(
      &(input->feedback), &(output->feedback)))
  {
    return false;
  }
  return true;
}

rosee_msg__action__ROSEECommand_FeedbackMessage *
rosee_msg__action__ROSEECommand_FeedbackMessage__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_FeedbackMessage * msg = (rosee_msg__action__ROSEECommand_FeedbackMessage *)allocator.allocate(sizeof(rosee_msg__action__ROSEECommand_FeedbackMessage), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosee_msg__action__ROSEECommand_FeedbackMessage));
  bool success = rosee_msg__action__ROSEECommand_FeedbackMessage__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosee_msg__action__ROSEECommand_FeedbackMessage__destroy(rosee_msg__action__ROSEECommand_FeedbackMessage * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosee_msg__action__ROSEECommand_FeedbackMessage__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence__init(rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_FeedbackMessage * data = NULL;

  if (size) {
    data = (rosee_msg__action__ROSEECommand_FeedbackMessage *)allocator.zero_allocate(size, sizeof(rosee_msg__action__ROSEECommand_FeedbackMessage), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosee_msg__action__ROSEECommand_FeedbackMessage__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosee_msg__action__ROSEECommand_FeedbackMessage__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence__fini(rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosee_msg__action__ROSEECommand_FeedbackMessage__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence *
rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence * array = (rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence *)allocator.allocate(sizeof(rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence__destroy(rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence__are_equal(const rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence * lhs, const rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosee_msg__action__ROSEECommand_FeedbackMessage__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence__copy(
  const rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence * input,
  rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosee_msg__action__ROSEECommand_FeedbackMessage);
    rosee_msg__action__ROSEECommand_FeedbackMessage * data =
      (rosee_msg__action__ROSEECommand_FeedbackMessage *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosee_msg__action__ROSEECommand_FeedbackMessage__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosee_msg__action__ROSEECommand_FeedbackMessage__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosee_msg__action__ROSEECommand_FeedbackMessage__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
