// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rosee_msg:action/ROSEECommand.idl
// generated code does not contain a copyright notice

#ifndef ROSEE_MSG__ACTION__DETAIL__ROSEE_COMMAND__STRUCT_H_
#define ROSEE_MSG__ACTION__DETAIL__ROSEE_COMMAND__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'goal_action'
#include "rosee_msg/msg/detail/rosee_action_control__struct.h"

// Struct defined in action/ROSEECommand in the package rosee_msg.
typedef struct rosee_msg__action__ROSEECommand_Goal
{
  rosee_msg__msg__ROSEEActionControl goal_action;
} rosee_msg__action__ROSEECommand_Goal;

// Struct for a sequence of rosee_msg__action__ROSEECommand_Goal.
typedef struct rosee_msg__action__ROSEECommand_Goal__Sequence
{
  rosee_msg__action__ROSEECommand_Goal * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rosee_msg__action__ROSEECommand_Goal__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'completed_action'
// already included above
// #include "rosee_msg/msg/detail/rosee_action_control__struct.h"

// Struct defined in action/ROSEECommand in the package rosee_msg.
typedef struct rosee_msg__action__ROSEECommand_Result
{
  rosee_msg__msg__ROSEEActionControl completed_action;
} rosee_msg__action__ROSEECommand_Result;

// Struct for a sequence of rosee_msg__action__ROSEECommand_Result.
typedef struct rosee_msg__action__ROSEECommand_Result__Sequence
{
  rosee_msg__action__ROSEECommand_Result * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rosee_msg__action__ROSEECommand_Result__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'action_name_current'
#include "rosidl_runtime_c/string.h"

// Struct defined in action/ROSEECommand in the package rosee_msg.
typedef struct rosee_msg__action__ROSEECommand_Feedback
{
  double completation_percentage;
  rosidl_runtime_c__String action_name_current;
} rosee_msg__action__ROSEECommand_Feedback;

// Struct for a sequence of rosee_msg__action__ROSEECommand_Feedback.
typedef struct rosee_msg__action__ROSEECommand_Feedback__Sequence
{
  rosee_msg__action__ROSEECommand_Feedback * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rosee_msg__action__ROSEECommand_Feedback__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'goal'
#include "rosee_msg/action/detail/rosee_command__struct.h"

// Struct defined in action/ROSEECommand in the package rosee_msg.
typedef struct rosee_msg__action__ROSEECommand_SendGoal_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
  rosee_msg__action__ROSEECommand_Goal goal;
} rosee_msg__action__ROSEECommand_SendGoal_Request;

// Struct for a sequence of rosee_msg__action__ROSEECommand_SendGoal_Request.
typedef struct rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence
{
  rosee_msg__action__ROSEECommand_SendGoal_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rosee_msg__action__ROSEECommand_SendGoal_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"

// Struct defined in action/ROSEECommand in the package rosee_msg.
typedef struct rosee_msg__action__ROSEECommand_SendGoal_Response
{
  bool accepted;
  builtin_interfaces__msg__Time stamp;
} rosee_msg__action__ROSEECommand_SendGoal_Response;

// Struct for a sequence of rosee_msg__action__ROSEECommand_SendGoal_Response.
typedef struct rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence
{
  rosee_msg__action__ROSEECommand_SendGoal_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rosee_msg__action__ROSEECommand_SendGoal_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"

// Struct defined in action/ROSEECommand in the package rosee_msg.
typedef struct rosee_msg__action__ROSEECommand_GetResult_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
} rosee_msg__action__ROSEECommand_GetResult_Request;

// Struct for a sequence of rosee_msg__action__ROSEECommand_GetResult_Request.
typedef struct rosee_msg__action__ROSEECommand_GetResult_Request__Sequence
{
  rosee_msg__action__ROSEECommand_GetResult_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rosee_msg__action__ROSEECommand_GetResult_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'result'
// already included above
// #include "rosee_msg/action/detail/rosee_command__struct.h"

// Struct defined in action/ROSEECommand in the package rosee_msg.
typedef struct rosee_msg__action__ROSEECommand_GetResult_Response
{
  int8_t status;
  rosee_msg__action__ROSEECommand_Result result;
} rosee_msg__action__ROSEECommand_GetResult_Response;

// Struct for a sequence of rosee_msg__action__ROSEECommand_GetResult_Response.
typedef struct rosee_msg__action__ROSEECommand_GetResult_Response__Sequence
{
  rosee_msg__action__ROSEECommand_GetResult_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rosee_msg__action__ROSEECommand_GetResult_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'feedback'
// already included above
// #include "rosee_msg/action/detail/rosee_command__struct.h"

// Struct defined in action/ROSEECommand in the package rosee_msg.
typedef struct rosee_msg__action__ROSEECommand_FeedbackMessage
{
  unique_identifier_msgs__msg__UUID goal_id;
  rosee_msg__action__ROSEECommand_Feedback feedback;
} rosee_msg__action__ROSEECommand_FeedbackMessage;

// Struct for a sequence of rosee_msg__action__ROSEECommand_FeedbackMessage.
typedef struct rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence
{
  rosee_msg__action__ROSEECommand_FeedbackMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rosee_msg__action__ROSEECommand_FeedbackMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ROSEE_MSG__ACTION__DETAIL__ROSEE_COMMAND__STRUCT_H_
