// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rosee_msg:action/ROSEECommand.idl
// generated code does not contain a copyright notice

#ifndef ROSEE_MSG__ACTION__DETAIL__ROSEE_COMMAND__STRUCT_HPP_
#define ROSEE_MSG__ACTION__DETAIL__ROSEE_COMMAND__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'goal_action'
#include "rosee_msg/msg/detail/rosee_action_control__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rosee_msg__action__ROSEECommand_Goal __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__action__ROSEECommand_Goal __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ROSEECommand_Goal_
{
  using Type = ROSEECommand_Goal_<ContainerAllocator>;

  explicit ROSEECommand_Goal_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_action(_init)
  {
    (void)_init;
  }

  explicit ROSEECommand_Goal_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_action(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_action_type =
    rosee_msg::msg::ROSEEActionControl_<ContainerAllocator>;
  _goal_action_type goal_action;

  // setters for named parameter idiom
  Type & set__goal_action(
    const rosee_msg::msg::ROSEEActionControl_<ContainerAllocator> & _arg)
  {
    this->goal_action = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosee_msg::action::ROSEECommand_Goal_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::action::ROSEECommand_Goal_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::action::ROSEECommand_Goal_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::action::ROSEECommand_Goal_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::action::ROSEECommand_Goal_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::action::ROSEECommand_Goal_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::action::ROSEECommand_Goal_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::action::ROSEECommand_Goal_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::action::ROSEECommand_Goal_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::action::ROSEECommand_Goal_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__action__ROSEECommand_Goal
    std::shared_ptr<rosee_msg::action::ROSEECommand_Goal_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__action__ROSEECommand_Goal
    std::shared_ptr<rosee_msg::action::ROSEECommand_Goal_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ROSEECommand_Goal_ & other) const
  {
    if (this->goal_action != other.goal_action) {
      return false;
    }
    return true;
  }
  bool operator!=(const ROSEECommand_Goal_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ROSEECommand_Goal_

// alias to use template instance with default allocator
using ROSEECommand_Goal =
  rosee_msg::action::ROSEECommand_Goal_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace rosee_msg


// Include directives for member types
// Member 'completed_action'
// already included above
// #include "rosee_msg/msg/detail/rosee_action_control__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rosee_msg__action__ROSEECommand_Result __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__action__ROSEECommand_Result __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ROSEECommand_Result_
{
  using Type = ROSEECommand_Result_<ContainerAllocator>;

  explicit ROSEECommand_Result_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : completed_action(_init)
  {
    (void)_init;
  }

  explicit ROSEECommand_Result_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : completed_action(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _completed_action_type =
    rosee_msg::msg::ROSEEActionControl_<ContainerAllocator>;
  _completed_action_type completed_action;

  // setters for named parameter idiom
  Type & set__completed_action(
    const rosee_msg::msg::ROSEEActionControl_<ContainerAllocator> & _arg)
  {
    this->completed_action = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosee_msg::action::ROSEECommand_Result_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::action::ROSEECommand_Result_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::action::ROSEECommand_Result_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::action::ROSEECommand_Result_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::action::ROSEECommand_Result_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::action::ROSEECommand_Result_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::action::ROSEECommand_Result_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::action::ROSEECommand_Result_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::action::ROSEECommand_Result_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::action::ROSEECommand_Result_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__action__ROSEECommand_Result
    std::shared_ptr<rosee_msg::action::ROSEECommand_Result_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__action__ROSEECommand_Result
    std::shared_ptr<rosee_msg::action::ROSEECommand_Result_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ROSEECommand_Result_ & other) const
  {
    if (this->completed_action != other.completed_action) {
      return false;
    }
    return true;
  }
  bool operator!=(const ROSEECommand_Result_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ROSEECommand_Result_

// alias to use template instance with default allocator
using ROSEECommand_Result =
  rosee_msg::action::ROSEECommand_Result_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace rosee_msg


#ifndef _WIN32
# define DEPRECATED__rosee_msg__action__ROSEECommand_Feedback __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__action__ROSEECommand_Feedback __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ROSEECommand_Feedback_
{
  using Type = ROSEECommand_Feedback_<ContainerAllocator>;

  explicit ROSEECommand_Feedback_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->completation_percentage = 0.0;
      this->action_name_current = "";
    }
  }

  explicit ROSEECommand_Feedback_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : action_name_current(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->completation_percentage = 0.0;
      this->action_name_current = "";
    }
  }

  // field types and members
  using _completation_percentage_type =
    double;
  _completation_percentage_type completation_percentage;
  using _action_name_current_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _action_name_current_type action_name_current;

  // setters for named parameter idiom
  Type & set__completation_percentage(
    const double & _arg)
  {
    this->completation_percentage = _arg;
    return *this;
  }
  Type & set__action_name_current(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->action_name_current = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosee_msg::action::ROSEECommand_Feedback_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::action::ROSEECommand_Feedback_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::action::ROSEECommand_Feedback_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::action::ROSEECommand_Feedback_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::action::ROSEECommand_Feedback_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::action::ROSEECommand_Feedback_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::action::ROSEECommand_Feedback_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::action::ROSEECommand_Feedback_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::action::ROSEECommand_Feedback_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::action::ROSEECommand_Feedback_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__action__ROSEECommand_Feedback
    std::shared_ptr<rosee_msg::action::ROSEECommand_Feedback_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__action__ROSEECommand_Feedback
    std::shared_ptr<rosee_msg::action::ROSEECommand_Feedback_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ROSEECommand_Feedback_ & other) const
  {
    if (this->completation_percentage != other.completation_percentage) {
      return false;
    }
    if (this->action_name_current != other.action_name_current) {
      return false;
    }
    return true;
  }
  bool operator!=(const ROSEECommand_Feedback_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ROSEECommand_Feedback_

// alias to use template instance with default allocator
using ROSEECommand_Feedback =
  rosee_msg::action::ROSEECommand_Feedback_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace rosee_msg


// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'goal'
#include "rosee_msg/action/detail/rosee_command__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rosee_msg__action__ROSEECommand_SendGoal_Request __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__action__ROSEECommand_SendGoal_Request __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ROSEECommand_SendGoal_Request_
{
  using Type = ROSEECommand_SendGoal_Request_<ContainerAllocator>;

  explicit ROSEECommand_SendGoal_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    goal(_init)
  {
    (void)_init;
  }

  explicit ROSEECommand_SendGoal_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    goal(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _goal_type =
    rosee_msg::action::ROSEECommand_Goal_<ContainerAllocator>;
  _goal_type goal;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__goal(
    const rosee_msg::action::ROSEECommand_Goal_<ContainerAllocator> & _arg)
  {
    this->goal = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosee_msg::action::ROSEECommand_SendGoal_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::action::ROSEECommand_SendGoal_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::action::ROSEECommand_SendGoal_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::action::ROSEECommand_SendGoal_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::action::ROSEECommand_SendGoal_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::action::ROSEECommand_SendGoal_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::action::ROSEECommand_SendGoal_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::action::ROSEECommand_SendGoal_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::action::ROSEECommand_SendGoal_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::action::ROSEECommand_SendGoal_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__action__ROSEECommand_SendGoal_Request
    std::shared_ptr<rosee_msg::action::ROSEECommand_SendGoal_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__action__ROSEECommand_SendGoal_Request
    std::shared_ptr<rosee_msg::action::ROSEECommand_SendGoal_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ROSEECommand_SendGoal_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->goal != other.goal) {
      return false;
    }
    return true;
  }
  bool operator!=(const ROSEECommand_SendGoal_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ROSEECommand_SendGoal_Request_

// alias to use template instance with default allocator
using ROSEECommand_SendGoal_Request =
  rosee_msg::action::ROSEECommand_SendGoal_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace rosee_msg


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rosee_msg__action__ROSEECommand_SendGoal_Response __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__action__ROSEECommand_SendGoal_Response __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ROSEECommand_SendGoal_Response_
{
  using Type = ROSEECommand_SendGoal_Response_<ContainerAllocator>;

  explicit ROSEECommand_SendGoal_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  explicit ROSEECommand_SendGoal_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  // field types and members
  using _accepted_type =
    bool;
  _accepted_type accepted;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;

  // setters for named parameter idiom
  Type & set__accepted(
    const bool & _arg)
  {
    this->accepted = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosee_msg::action::ROSEECommand_SendGoal_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::action::ROSEECommand_SendGoal_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::action::ROSEECommand_SendGoal_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::action::ROSEECommand_SendGoal_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::action::ROSEECommand_SendGoal_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::action::ROSEECommand_SendGoal_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::action::ROSEECommand_SendGoal_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::action::ROSEECommand_SendGoal_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::action::ROSEECommand_SendGoal_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::action::ROSEECommand_SendGoal_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__action__ROSEECommand_SendGoal_Response
    std::shared_ptr<rosee_msg::action::ROSEECommand_SendGoal_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__action__ROSEECommand_SendGoal_Response
    std::shared_ptr<rosee_msg::action::ROSEECommand_SendGoal_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ROSEECommand_SendGoal_Response_ & other) const
  {
    if (this->accepted != other.accepted) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    return true;
  }
  bool operator!=(const ROSEECommand_SendGoal_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ROSEECommand_SendGoal_Response_

// alias to use template instance with default allocator
using ROSEECommand_SendGoal_Response =
  rosee_msg::action::ROSEECommand_SendGoal_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace rosee_msg

namespace rosee_msg
{

namespace action
{

struct ROSEECommand_SendGoal
{
  using Request = rosee_msg::action::ROSEECommand_SendGoal_Request;
  using Response = rosee_msg::action::ROSEECommand_SendGoal_Response;
};

}  // namespace action

}  // namespace rosee_msg


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rosee_msg__action__ROSEECommand_GetResult_Request __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__action__ROSEECommand_GetResult_Request __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ROSEECommand_GetResult_Request_
{
  using Type = ROSEECommand_GetResult_Request_<ContainerAllocator>;

  explicit ROSEECommand_GetResult_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init)
  {
    (void)_init;
  }

  explicit ROSEECommand_GetResult_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosee_msg::action::ROSEECommand_GetResult_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::action::ROSEECommand_GetResult_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::action::ROSEECommand_GetResult_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::action::ROSEECommand_GetResult_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::action::ROSEECommand_GetResult_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::action::ROSEECommand_GetResult_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::action::ROSEECommand_GetResult_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::action::ROSEECommand_GetResult_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::action::ROSEECommand_GetResult_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::action::ROSEECommand_GetResult_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__action__ROSEECommand_GetResult_Request
    std::shared_ptr<rosee_msg::action::ROSEECommand_GetResult_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__action__ROSEECommand_GetResult_Request
    std::shared_ptr<rosee_msg::action::ROSEECommand_GetResult_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ROSEECommand_GetResult_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const ROSEECommand_GetResult_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ROSEECommand_GetResult_Request_

// alias to use template instance with default allocator
using ROSEECommand_GetResult_Request =
  rosee_msg::action::ROSEECommand_GetResult_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace rosee_msg


// Include directives for member types
// Member 'result'
// already included above
// #include "rosee_msg/action/detail/rosee_command__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rosee_msg__action__ROSEECommand_GetResult_Response __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__action__ROSEECommand_GetResult_Response __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ROSEECommand_GetResult_Response_
{
  using Type = ROSEECommand_GetResult_Response_<ContainerAllocator>;

  explicit ROSEECommand_GetResult_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  explicit ROSEECommand_GetResult_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  // field types and members
  using _status_type =
    int8_t;
  _status_type status;
  using _result_type =
    rosee_msg::action::ROSEECommand_Result_<ContainerAllocator>;
  _result_type result;

  // setters for named parameter idiom
  Type & set__status(
    const int8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__result(
    const rosee_msg::action::ROSEECommand_Result_<ContainerAllocator> & _arg)
  {
    this->result = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosee_msg::action::ROSEECommand_GetResult_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::action::ROSEECommand_GetResult_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::action::ROSEECommand_GetResult_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::action::ROSEECommand_GetResult_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::action::ROSEECommand_GetResult_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::action::ROSEECommand_GetResult_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::action::ROSEECommand_GetResult_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::action::ROSEECommand_GetResult_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::action::ROSEECommand_GetResult_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::action::ROSEECommand_GetResult_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__action__ROSEECommand_GetResult_Response
    std::shared_ptr<rosee_msg::action::ROSEECommand_GetResult_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__action__ROSEECommand_GetResult_Response
    std::shared_ptr<rosee_msg::action::ROSEECommand_GetResult_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ROSEECommand_GetResult_Response_ & other) const
  {
    if (this->status != other.status) {
      return false;
    }
    if (this->result != other.result) {
      return false;
    }
    return true;
  }
  bool operator!=(const ROSEECommand_GetResult_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ROSEECommand_GetResult_Response_

// alias to use template instance with default allocator
using ROSEECommand_GetResult_Response =
  rosee_msg::action::ROSEECommand_GetResult_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace rosee_msg

namespace rosee_msg
{

namespace action
{

struct ROSEECommand_GetResult
{
  using Request = rosee_msg::action::ROSEECommand_GetResult_Request;
  using Response = rosee_msg::action::ROSEECommand_GetResult_Response;
};

}  // namespace action

}  // namespace rosee_msg


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'feedback'
// already included above
// #include "rosee_msg/action/detail/rosee_command__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rosee_msg__action__ROSEECommand_FeedbackMessage __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__action__ROSEECommand_FeedbackMessage __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ROSEECommand_FeedbackMessage_
{
  using Type = ROSEECommand_FeedbackMessage_<ContainerAllocator>;

  explicit ROSEECommand_FeedbackMessage_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    feedback(_init)
  {
    (void)_init;
  }

  explicit ROSEECommand_FeedbackMessage_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    feedback(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _feedback_type =
    rosee_msg::action::ROSEECommand_Feedback_<ContainerAllocator>;
  _feedback_type feedback;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__feedback(
    const rosee_msg::action::ROSEECommand_Feedback_<ContainerAllocator> & _arg)
  {
    this->feedback = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosee_msg::action::ROSEECommand_FeedbackMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::action::ROSEECommand_FeedbackMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::action::ROSEECommand_FeedbackMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::action::ROSEECommand_FeedbackMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::action::ROSEECommand_FeedbackMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::action::ROSEECommand_FeedbackMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::action::ROSEECommand_FeedbackMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::action::ROSEECommand_FeedbackMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::action::ROSEECommand_FeedbackMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::action::ROSEECommand_FeedbackMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__action__ROSEECommand_FeedbackMessage
    std::shared_ptr<rosee_msg::action::ROSEECommand_FeedbackMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__action__ROSEECommand_FeedbackMessage
    std::shared_ptr<rosee_msg::action::ROSEECommand_FeedbackMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ROSEECommand_FeedbackMessage_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->feedback != other.feedback) {
      return false;
    }
    return true;
  }
  bool operator!=(const ROSEECommand_FeedbackMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ROSEECommand_FeedbackMessage_

// alias to use template instance with default allocator
using ROSEECommand_FeedbackMessage =
  rosee_msg::action::ROSEECommand_FeedbackMessage_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace rosee_msg

#include "action_msgs/srv/cancel_goal.hpp"
#include "action_msgs/msg/goal_info.hpp"
#include "action_msgs/msg/goal_status_array.hpp"

namespace rosee_msg
{

namespace action
{

struct ROSEECommand
{
  /// The goal message defined in the action definition.
  using Goal = rosee_msg::action::ROSEECommand_Goal;
  /// The result message defined in the action definition.
  using Result = rosee_msg::action::ROSEECommand_Result;
  /// The feedback message defined in the action definition.
  using Feedback = rosee_msg::action::ROSEECommand_Feedback;

  struct Impl
  {
    /// The send_goal service using a wrapped version of the goal message as a request.
    using SendGoalService = rosee_msg::action::ROSEECommand_SendGoal;
    /// The get_result service using a wrapped version of the result message as a response.
    using GetResultService = rosee_msg::action::ROSEECommand_GetResult;
    /// The feedback message with generic fields which wraps the feedback message.
    using FeedbackMessage = rosee_msg::action::ROSEECommand_FeedbackMessage;

    /// The generic service to cancel a goal.
    using CancelGoalService = action_msgs::srv::CancelGoal;
    /// The generic message for the status of a goal.
    using GoalStatusMessage = action_msgs::msg::GoalStatusArray;
  };
};

typedef struct ROSEECommand ROSEECommand;

}  // namespace action

}  // namespace rosee_msg

#endif  // ROSEE_MSG__ACTION__DETAIL__ROSEE_COMMAND__STRUCT_HPP_
