// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rosee_msg:msg/EEPinchControl.idl
// generated code does not contain a copyright notice

#ifndef ROSEE_MSG__MSG__DETAIL__EE_PINCH_CONTROL__STRUCT_HPP_
#define ROSEE_MSG__MSG__DETAIL__EE_PINCH_CONTROL__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rosee_msg__msg__EEPinchControl __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__msg__EEPinchControl __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct EEPinchControl_
{
  using Type = EEPinchControl_<ContainerAllocator>;

  explicit EEPinchControl_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->seq = 0ul;
      this->finger_pinch_1 = "";
      this->finger_pinch_2 = "";
      this->percentage = 0.0;
    }
  }

  explicit EEPinchControl_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init),
    finger_pinch_1(_alloc),
    finger_pinch_2(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->seq = 0ul;
      this->finger_pinch_1 = "";
      this->finger_pinch_2 = "";
      this->percentage = 0.0;
    }
  }

  // field types and members
  using _seq_type =
    uint32_t;
  _seq_type seq;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;
  using _finger_pinch_1_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _finger_pinch_1_type finger_pinch_1;
  using _finger_pinch_2_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _finger_pinch_2_type finger_pinch_2;
  using _percentage_type =
    double;
  _percentage_type percentage;

  // setters for named parameter idiom
  Type & set__seq(
    const uint32_t & _arg)
  {
    this->seq = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }
  Type & set__finger_pinch_1(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->finger_pinch_1 = _arg;
    return *this;
  }
  Type & set__finger_pinch_2(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->finger_pinch_2 = _arg;
    return *this;
  }
  Type & set__percentage(
    const double & _arg)
  {
    this->percentage = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosee_msg::msg::EEPinchControl_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::msg::EEPinchControl_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::msg::EEPinchControl_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::msg::EEPinchControl_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::msg::EEPinchControl_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::msg::EEPinchControl_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::msg::EEPinchControl_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::msg::EEPinchControl_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::msg::EEPinchControl_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::msg::EEPinchControl_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__msg__EEPinchControl
    std::shared_ptr<rosee_msg::msg::EEPinchControl_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__msg__EEPinchControl
    std::shared_ptr<rosee_msg::msg::EEPinchControl_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EEPinchControl_ & other) const
  {
    if (this->seq != other.seq) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    if (this->finger_pinch_1 != other.finger_pinch_1) {
      return false;
    }
    if (this->finger_pinch_2 != other.finger_pinch_2) {
      return false;
    }
    if (this->percentage != other.percentage) {
      return false;
    }
    return true;
  }
  bool operator!=(const EEPinchControl_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EEPinchControl_

// alias to use template instance with default allocator
using EEPinchControl =
  rosee_msg::msg::EEPinchControl_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rosee_msg

#endif  // ROSEE_MSG__MSG__DETAIL__EE_PINCH_CONTROL__STRUCT_HPP_
