// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rosee_msg:msg/EETriggerControl.idl
// generated code does not contain a copyright notice
#include "rosee_msg/msg/detail/ee_trigger_control__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `finger_trigger`
#include "rosidl_runtime_c/string_functions.h"

bool
rosee_msg__msg__EETriggerControl__init(rosee_msg__msg__EETriggerControl * msg)
{
  if (!msg) {
    return false;
  }
  // seq
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    rosee_msg__msg__EETriggerControl__fini(msg);
    return false;
  }
  // finger_trigger
  if (!rosidl_runtime_c__String__init(&msg->finger_trigger)) {
    rosee_msg__msg__EETriggerControl__fini(msg);
    return false;
  }
  // percentage
  return true;
}

void
rosee_msg__msg__EETriggerControl__fini(rosee_msg__msg__EETriggerControl * msg)
{
  if (!msg) {
    return;
  }
  // seq
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
  // finger_trigger
  rosidl_runtime_c__String__fini(&msg->finger_trigger);
  // percentage
}

bool
rosee_msg__msg__EETriggerControl__are_equal(const rosee_msg__msg__EETriggerControl * lhs, const rosee_msg__msg__EETriggerControl * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // seq
  if (lhs->seq != rhs->seq) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  // finger_trigger
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->finger_trigger), &(rhs->finger_trigger)))
  {
    return false;
  }
  // percentage
  if (lhs->percentage != rhs->percentage) {
    return false;
  }
  return true;
}

bool
rosee_msg__msg__EETriggerControl__copy(
  const rosee_msg__msg__EETriggerControl * input,
  rosee_msg__msg__EETriggerControl * output)
{
  if (!input || !output) {
    return false;
  }
  // seq
  output->seq = input->seq;
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  // finger_trigger
  if (!rosidl_runtime_c__String__copy(
      &(input->finger_trigger), &(output->finger_trigger)))
  {
    return false;
  }
  // percentage
  output->percentage = input->percentage;
  return true;
}

rosee_msg__msg__EETriggerControl *
rosee_msg__msg__EETriggerControl__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__msg__EETriggerControl * msg = (rosee_msg__msg__EETriggerControl *)allocator.allocate(sizeof(rosee_msg__msg__EETriggerControl), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosee_msg__msg__EETriggerControl));
  bool success = rosee_msg__msg__EETriggerControl__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosee_msg__msg__EETriggerControl__destroy(rosee_msg__msg__EETriggerControl * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosee_msg__msg__EETriggerControl__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosee_msg__msg__EETriggerControl__Sequence__init(rosee_msg__msg__EETriggerControl__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__msg__EETriggerControl * data = NULL;

  if (size) {
    data = (rosee_msg__msg__EETriggerControl *)allocator.zero_allocate(size, sizeof(rosee_msg__msg__EETriggerControl), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosee_msg__msg__EETriggerControl__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosee_msg__msg__EETriggerControl__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosee_msg__msg__EETriggerControl__Sequence__fini(rosee_msg__msg__EETriggerControl__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosee_msg__msg__EETriggerControl__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosee_msg__msg__EETriggerControl__Sequence *
rosee_msg__msg__EETriggerControl__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__msg__EETriggerControl__Sequence * array = (rosee_msg__msg__EETriggerControl__Sequence *)allocator.allocate(sizeof(rosee_msg__msg__EETriggerControl__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosee_msg__msg__EETriggerControl__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosee_msg__msg__EETriggerControl__Sequence__destroy(rosee_msg__msg__EETriggerControl__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosee_msg__msg__EETriggerControl__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosee_msg__msg__EETriggerControl__Sequence__are_equal(const rosee_msg__msg__EETriggerControl__Sequence * lhs, const rosee_msg__msg__EETriggerControl__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosee_msg__msg__EETriggerControl__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosee_msg__msg__EETriggerControl__Sequence__copy(
  const rosee_msg__msg__EETriggerControl__Sequence * input,
  rosee_msg__msg__EETriggerControl__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosee_msg__msg__EETriggerControl);
    rosee_msg__msg__EETriggerControl * data =
      (rosee_msg__msg__EETriggerControl *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosee_msg__msg__EETriggerControl__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosee_msg__msg__EETriggerControl__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosee_msg__msg__EETriggerControl__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
