// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rosee_msg:msg/GraspingAction.idl
// generated code does not contain a copyright notice

#ifndef ROSEE_MSG__MSG__DETAIL__GRASPING_ACTION__STRUCT_H_
#define ROSEE_MSG__MSG__DETAIL__GRASPING_ACTION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'PRIMITIVE'.
enum
{
  rosee_msg__msg__GraspingAction__PRIMITIVE = 0
};

/// Constant 'GENERIC'.
enum
{
  rosee_msg__msg__GraspingAction__GENERIC = 1
};

/// Constant 'COMPOSED'.
enum
{
  rosee_msg__msg__GraspingAction__COMPOSED = 2
};

/// Constant 'TIMED'.
enum
{
  rosee_msg__msg__GraspingAction__TIMED = 3
};

/// Constant 'NONE'.
enum
{
  rosee_msg__msg__GraspingAction__NONE = 4
};

/// Constant 'PRIMITIVE_PINCHTIGHT'.
enum
{
  rosee_msg__msg__GraspingAction__PRIMITIVE_PINCHTIGHT = 0
};

/// Constant 'PRIMITIVE_PINCHLOOSE'.
enum
{
  rosee_msg__msg__GraspingAction__PRIMITIVE_PINCHLOOSE = 1
};

/// Constant 'PRIMITIVE_MULTIPLEPINCHTIGHT'.
enum
{
  rosee_msg__msg__GraspingAction__PRIMITIVE_MULTIPLEPINCHTIGHT = 2
};

/// Constant 'PRIMITIVE_TRIG'.
enum
{
  rosee_msg__msg__GraspingAction__PRIMITIVE_TRIG = 3
};

/// Constant 'PRIMITIVE_TIPFLEX'.
enum
{
  rosee_msg__msg__GraspingAction__PRIMITIVE_TIPFLEX = 4
};

/// Constant 'PRIMITIVE_FINGFLEX'.
enum
{
  rosee_msg__msg__GraspingAction__PRIMITIVE_FINGFLEX = 5
};

/// Constant 'PRIMITIVE_SINGLEJOINTMULTIPLETIPS'.
enum
{
  rosee_msg__msg__GraspingAction__PRIMITIVE_SINGLEJOINTMULTIPLETIPS = 6
};

/// Constant 'PRIMITIVE_NONE'.
enum
{
  rosee_msg__msg__GraspingAction__PRIMITIVE_NONE = 7
};

// Include directives for member types
// Member 'action_name'
// Member 'elements_involved'
// Member 'inner_actions'
#include "rosidl_runtime_c/string.h"
// Member 'action_motor_count'
#include "rosee_msg/msg/detail/joints_involved_count__struct.h"
// Member 'action_motor_positions'
#include "rosee_msg/msg/detail/motor_position__struct.h"
// Member 'before_time_margins'
// Member 'after_time_margins'
#include "rosidl_runtime_c/primitives_sequence.h"

// Struct defined in msg/GraspingAction in the package rosee_msg.
typedef struct rosee_msg__msg__GraspingAction
{
  uint8_t action_type;
  uint8_t primitive_type;
  rosidl_runtime_c__String action_name;
  rosidl_runtime_c__String__Sequence elements_involved;
  rosee_msg__msg__JointsInvolvedCount action_motor_count;
  rosee_msg__msg__MotorPosition__Sequence action_motor_positions;
  rosidl_runtime_c__String__Sequence inner_actions;
  rosidl_runtime_c__double__Sequence before_time_margins;
  rosidl_runtime_c__double__Sequence after_time_margins;
} rosee_msg__msg__GraspingAction;

// Struct for a sequence of rosee_msg__msg__GraspingAction.
typedef struct rosee_msg__msg__GraspingAction__Sequence
{
  rosee_msg__msg__GraspingAction * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rosee_msg__msg__GraspingAction__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ROSEE_MSG__MSG__DETAIL__GRASPING_ACTION__STRUCT_H_
