// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rosee_msg:msg/GraspingAction.idl
// generated code does not contain a copyright notice

#ifndef ROSEE_MSG__MSG__DETAIL__GRASPING_ACTION__STRUCT_HPP_
#define ROSEE_MSG__MSG__DETAIL__GRASPING_ACTION__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'action_motor_count'
#include "rosee_msg/msg/detail/joints_involved_count__struct.hpp"
// Member 'action_motor_positions'
#include "rosee_msg/msg/detail/motor_position__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rosee_msg__msg__GraspingAction __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__msg__GraspingAction __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GraspingAction_
{
  using Type = GraspingAction_<ContainerAllocator>;

  explicit GraspingAction_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : action_motor_count(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->action_type = 0;
      this->primitive_type = 0;
      this->action_name = "";
    }
  }

  explicit GraspingAction_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : action_name(_alloc),
    action_motor_count(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->action_type = 0;
      this->primitive_type = 0;
      this->action_name = "";
    }
  }

  // field types and members
  using _action_type_type =
    uint8_t;
  _action_type_type action_type;
  using _primitive_type_type =
    uint8_t;
  _primitive_type_type primitive_type;
  using _action_name_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _action_name_type action_name;
  using _elements_involved_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _elements_involved_type elements_involved;
  using _action_motor_count_type =
    rosee_msg::msg::JointsInvolvedCount_<ContainerAllocator>;
  _action_motor_count_type action_motor_count;
  using _action_motor_positions_type =
    std::vector<rosee_msg::msg::MotorPosition_<ContainerAllocator>, typename ContainerAllocator::template rebind<rosee_msg::msg::MotorPosition_<ContainerAllocator>>::other>;
  _action_motor_positions_type action_motor_positions;
  using _inner_actions_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _inner_actions_type inner_actions;
  using _before_time_margins_type =
    std::vector<double, typename ContainerAllocator::template rebind<double>::other>;
  _before_time_margins_type before_time_margins;
  using _after_time_margins_type =
    std::vector<double, typename ContainerAllocator::template rebind<double>::other>;
  _after_time_margins_type after_time_margins;

  // setters for named parameter idiom
  Type & set__action_type(
    const uint8_t & _arg)
  {
    this->action_type = _arg;
    return *this;
  }
  Type & set__primitive_type(
    const uint8_t & _arg)
  {
    this->primitive_type = _arg;
    return *this;
  }
  Type & set__action_name(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->action_name = _arg;
    return *this;
  }
  Type & set__elements_involved(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->elements_involved = _arg;
    return *this;
  }
  Type & set__action_motor_count(
    const rosee_msg::msg::JointsInvolvedCount_<ContainerAllocator> & _arg)
  {
    this->action_motor_count = _arg;
    return *this;
  }
  Type & set__action_motor_positions(
    const std::vector<rosee_msg::msg::MotorPosition_<ContainerAllocator>, typename ContainerAllocator::template rebind<rosee_msg::msg::MotorPosition_<ContainerAllocator>>::other> & _arg)
  {
    this->action_motor_positions = _arg;
    return *this;
  }
  Type & set__inner_actions(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->inner_actions = _arg;
    return *this;
  }
  Type & set__before_time_margins(
    const std::vector<double, typename ContainerAllocator::template rebind<double>::other> & _arg)
  {
    this->before_time_margins = _arg;
    return *this;
  }
  Type & set__after_time_margins(
    const std::vector<double, typename ContainerAllocator::template rebind<double>::other> & _arg)
  {
    this->after_time_margins = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t PRIMITIVE =
    0u;
  static constexpr uint8_t GENERIC =
    1u;
  static constexpr uint8_t COMPOSED =
    2u;
  static constexpr uint8_t TIMED =
    3u;
  static constexpr uint8_t NONE =
    4u;
  static constexpr uint8_t PRIMITIVE_PINCHTIGHT =
    0u;
  static constexpr uint8_t PRIMITIVE_PINCHLOOSE =
    1u;
  static constexpr uint8_t PRIMITIVE_MULTIPLEPINCHTIGHT =
    2u;
  static constexpr uint8_t PRIMITIVE_TRIG =
    3u;
  static constexpr uint8_t PRIMITIVE_TIPFLEX =
    4u;
  static constexpr uint8_t PRIMITIVE_FINGFLEX =
    5u;
  static constexpr uint8_t PRIMITIVE_SINGLEJOINTMULTIPLETIPS =
    6u;
  static constexpr uint8_t PRIMITIVE_NONE =
    7u;

  // pointer types
  using RawPtr =
    rosee_msg::msg::GraspingAction_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::msg::GraspingAction_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::msg::GraspingAction_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::msg::GraspingAction_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::msg::GraspingAction_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::msg::GraspingAction_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::msg::GraspingAction_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::msg::GraspingAction_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::msg::GraspingAction_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::msg::GraspingAction_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__msg__GraspingAction
    std::shared_ptr<rosee_msg::msg::GraspingAction_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__msg__GraspingAction
    std::shared_ptr<rosee_msg::msg::GraspingAction_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GraspingAction_ & other) const
  {
    if (this->action_type != other.action_type) {
      return false;
    }
    if (this->primitive_type != other.primitive_type) {
      return false;
    }
    if (this->action_name != other.action_name) {
      return false;
    }
    if (this->elements_involved != other.elements_involved) {
      return false;
    }
    if (this->action_motor_count != other.action_motor_count) {
      return false;
    }
    if (this->action_motor_positions != other.action_motor_positions) {
      return false;
    }
    if (this->inner_actions != other.inner_actions) {
      return false;
    }
    if (this->before_time_margins != other.before_time_margins) {
      return false;
    }
    if (this->after_time_margins != other.after_time_margins) {
      return false;
    }
    return true;
  }
  bool operator!=(const GraspingAction_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GraspingAction_

// alias to use template instance with default allocator
using GraspingAction =
  rosee_msg::msg::GraspingAction_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t GraspingAction_<ContainerAllocator>::PRIMITIVE;
template<typename ContainerAllocator>
constexpr uint8_t GraspingAction_<ContainerAllocator>::GENERIC;
template<typename ContainerAllocator>
constexpr uint8_t GraspingAction_<ContainerAllocator>::COMPOSED;
template<typename ContainerAllocator>
constexpr uint8_t GraspingAction_<ContainerAllocator>::TIMED;
template<typename ContainerAllocator>
constexpr uint8_t GraspingAction_<ContainerAllocator>::NONE;
template<typename ContainerAllocator>
constexpr uint8_t GraspingAction_<ContainerAllocator>::PRIMITIVE_PINCHTIGHT;
template<typename ContainerAllocator>
constexpr uint8_t GraspingAction_<ContainerAllocator>::PRIMITIVE_PINCHLOOSE;
template<typename ContainerAllocator>
constexpr uint8_t GraspingAction_<ContainerAllocator>::PRIMITIVE_MULTIPLEPINCHTIGHT;
template<typename ContainerAllocator>
constexpr uint8_t GraspingAction_<ContainerAllocator>::PRIMITIVE_TRIG;
template<typename ContainerAllocator>
constexpr uint8_t GraspingAction_<ContainerAllocator>::PRIMITIVE_TIPFLEX;
template<typename ContainerAllocator>
constexpr uint8_t GraspingAction_<ContainerAllocator>::PRIMITIVE_FINGFLEX;
template<typename ContainerAllocator>
constexpr uint8_t GraspingAction_<ContainerAllocator>::PRIMITIVE_SINGLEJOINTMULTIPLETIPS;
template<typename ContainerAllocator>
constexpr uint8_t GraspingAction_<ContainerAllocator>::PRIMITIVE_NONE;

}  // namespace msg

}  // namespace rosee_msg

#endif  // ROSEE_MSG__MSG__DETAIL__GRASPING_ACTION__STRUCT_HPP_
