// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rosee_msg:msg/NewGenericGraspingAction.idl
// generated code does not contain a copyright notice

#ifndef ROSEE_MSG__MSG__DETAIL__NEW_GENERIC_GRASPING_ACTION__STRUCT_HPP_
#define ROSEE_MSG__MSG__DETAIL__NEW_GENERIC_GRASPING_ACTION__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'action_motor_position'
#include "rosee_msg/msg/detail/motor_position__struct.hpp"
// Member 'action_motor_count'
#include "rosee_msg/msg/detail/joints_involved_count__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rosee_msg__msg__NewGenericGraspingAction __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__msg__NewGenericGraspingAction __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct NewGenericGraspingAction_
{
  using Type = NewGenericGraspingAction_<ContainerAllocator>;

  explicit NewGenericGraspingAction_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : action_motor_position(_init),
    action_motor_count(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->action_name = "";
    }
  }

  explicit NewGenericGraspingAction_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : action_name(_alloc),
    action_motor_position(_alloc, _init),
    action_motor_count(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->action_name = "";
    }
  }

  // field types and members
  using _action_name_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _action_name_type action_name;
  using _action_motor_position_type =
    rosee_msg::msg::MotorPosition_<ContainerAllocator>;
  _action_motor_position_type action_motor_position;
  using _action_motor_count_type =
    rosee_msg::msg::JointsInvolvedCount_<ContainerAllocator>;
  _action_motor_count_type action_motor_count;
  using _elements_involved_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _elements_involved_type elements_involved;

  // setters for named parameter idiom
  Type & set__action_name(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->action_name = _arg;
    return *this;
  }
  Type & set__action_motor_position(
    const rosee_msg::msg::MotorPosition_<ContainerAllocator> & _arg)
  {
    this->action_motor_position = _arg;
    return *this;
  }
  Type & set__action_motor_count(
    const rosee_msg::msg::JointsInvolvedCount_<ContainerAllocator> & _arg)
  {
    this->action_motor_count = _arg;
    return *this;
  }
  Type & set__elements_involved(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->elements_involved = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosee_msg::msg::NewGenericGraspingAction_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::msg::NewGenericGraspingAction_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::msg::NewGenericGraspingAction_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::msg::NewGenericGraspingAction_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::msg::NewGenericGraspingAction_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::msg::NewGenericGraspingAction_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::msg::NewGenericGraspingAction_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::msg::NewGenericGraspingAction_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::msg::NewGenericGraspingAction_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::msg::NewGenericGraspingAction_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__msg__NewGenericGraspingAction
    std::shared_ptr<rosee_msg::msg::NewGenericGraspingAction_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__msg__NewGenericGraspingAction
    std::shared_ptr<rosee_msg::msg::NewGenericGraspingAction_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const NewGenericGraspingAction_ & other) const
  {
    if (this->action_name != other.action_name) {
      return false;
    }
    if (this->action_motor_position != other.action_motor_position) {
      return false;
    }
    if (this->action_motor_count != other.action_motor_count) {
      return false;
    }
    if (this->elements_involved != other.elements_involved) {
      return false;
    }
    return true;
  }
  bool operator!=(const NewGenericGraspingAction_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct NewGenericGraspingAction_

// alias to use template instance with default allocator
using NewGenericGraspingAction =
  rosee_msg::msg::NewGenericGraspingAction_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rosee_msg

#endif  // ROSEE_MSG__MSG__DETAIL__NEW_GENERIC_GRASPING_ACTION__STRUCT_HPP_
