// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rosee_msg:msg/ObjectModelMsg.idl
// generated code does not contain a copyright notice

#ifndef ROSEE_MSG__MSG__DETAIL__OBJECT_MODEL_MSG__STRUCT_HPP_
#define ROSEE_MSG__MSG__DETAIL__OBJECT_MODEL_MSG__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__rosee_msg__msg__ObjectModelMsg __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__msg__ObjectModelMsg __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ObjectModelMsg_
{
  using Type = ObjectModelMsg_<ContainerAllocator>;

  explicit ObjectModelMsg_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->weight = 0.0;
    }
  }

  explicit ObjectModelMsg_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->weight = 0.0;
    }
  }

  // field types and members
  using _position_type =
    std::vector<double, typename ContainerAllocator::template rebind<double>::other>;
  _position_type position;
  using _orientation_type =
    std::vector<double, typename ContainerAllocator::template rebind<double>::other>;
  _orientation_type orientation;
  using _superquadric_parameters_type =
    std::vector<double, typename ContainerAllocator::template rebind<double>::other>;
  _superquadric_parameters_type superquadric_parameters;
  using _weight_type =
    double;
  _weight_type weight;

  // setters for named parameter idiom
  Type & set__position(
    const std::vector<double, typename ContainerAllocator::template rebind<double>::other> & _arg)
  {
    this->position = _arg;
    return *this;
  }
  Type & set__orientation(
    const std::vector<double, typename ContainerAllocator::template rebind<double>::other> & _arg)
  {
    this->orientation = _arg;
    return *this;
  }
  Type & set__superquadric_parameters(
    const std::vector<double, typename ContainerAllocator::template rebind<double>::other> & _arg)
  {
    this->superquadric_parameters = _arg;
    return *this;
  }
  Type & set__weight(
    const double & _arg)
  {
    this->weight = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosee_msg::msg::ObjectModelMsg_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::msg::ObjectModelMsg_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::msg::ObjectModelMsg_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::msg::ObjectModelMsg_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::msg::ObjectModelMsg_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::msg::ObjectModelMsg_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::msg::ObjectModelMsg_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::msg::ObjectModelMsg_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::msg::ObjectModelMsg_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::msg::ObjectModelMsg_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__msg__ObjectModelMsg
    std::shared_ptr<rosee_msg::msg::ObjectModelMsg_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__msg__ObjectModelMsg
    std::shared_ptr<rosee_msg::msg::ObjectModelMsg_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ObjectModelMsg_ & other) const
  {
    if (this->position != other.position) {
      return false;
    }
    if (this->orientation != other.orientation) {
      return false;
    }
    if (this->superquadric_parameters != other.superquadric_parameters) {
      return false;
    }
    if (this->weight != other.weight) {
      return false;
    }
    return true;
  }
  bool operator!=(const ObjectModelMsg_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ObjectModelMsg_

// alias to use template instance with default allocator
using ObjectModelMsg =
  rosee_msg::msg::ObjectModelMsg_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rosee_msg

#endif  // ROSEE_MSG__MSG__DETAIL__OBJECT_MODEL_MSG__STRUCT_HPP_
