// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from rosee_msg:msg/ObjectModelMsg.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "rosee_msg/msg/detail/object_model_msg__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace rosee_msg
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void ObjectModelMsg_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) rosee_msg::msg::ObjectModelMsg(_init);
}

void ObjectModelMsg_fini_function(void * message_memory)
{
  auto typed_message = static_cast<rosee_msg::msg::ObjectModelMsg *>(message_memory);
  typed_message->~ObjectModelMsg();
}

size_t size_function__ObjectModelMsg__position(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<double> *>(untyped_member);
  return member->size();
}

const void * get_const_function__ObjectModelMsg__position(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<double> *>(untyped_member);
  return &member[index];
}

void * get_function__ObjectModelMsg__position(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<double> *>(untyped_member);
  return &member[index];
}

void resize_function__ObjectModelMsg__position(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<double> *>(untyped_member);
  member->resize(size);
}

size_t size_function__ObjectModelMsg__orientation(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<double> *>(untyped_member);
  return member->size();
}

const void * get_const_function__ObjectModelMsg__orientation(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<double> *>(untyped_member);
  return &member[index];
}

void * get_function__ObjectModelMsg__orientation(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<double> *>(untyped_member);
  return &member[index];
}

void resize_function__ObjectModelMsg__orientation(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<double> *>(untyped_member);
  member->resize(size);
}

size_t size_function__ObjectModelMsg__superquadric_parameters(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<double> *>(untyped_member);
  return member->size();
}

const void * get_const_function__ObjectModelMsg__superquadric_parameters(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<double> *>(untyped_member);
  return &member[index];
}

void * get_function__ObjectModelMsg__superquadric_parameters(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<double> *>(untyped_member);
  return &member[index];
}

void resize_function__ObjectModelMsg__superquadric_parameters(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<double> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember ObjectModelMsg_message_member_array[4] = {
  {
    "position",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::msg::ObjectModelMsg, position),  // bytes offset in struct
    nullptr,  // default value
    size_function__ObjectModelMsg__position,  // size() function pointer
    get_const_function__ObjectModelMsg__position,  // get_const(index) function pointer
    get_function__ObjectModelMsg__position,  // get(index) function pointer
    resize_function__ObjectModelMsg__position  // resize(index) function pointer
  },
  {
    "orientation",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::msg::ObjectModelMsg, orientation),  // bytes offset in struct
    nullptr,  // default value
    size_function__ObjectModelMsg__orientation,  // size() function pointer
    get_const_function__ObjectModelMsg__orientation,  // get_const(index) function pointer
    get_function__ObjectModelMsg__orientation,  // get(index) function pointer
    resize_function__ObjectModelMsg__orientation  // resize(index) function pointer
  },
  {
    "superquadric_parameters",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::msg::ObjectModelMsg, superquadric_parameters),  // bytes offset in struct
    nullptr,  // default value
    size_function__ObjectModelMsg__superquadric_parameters,  // size() function pointer
    get_const_function__ObjectModelMsg__superquadric_parameters,  // get_const(index) function pointer
    get_function__ObjectModelMsg__superquadric_parameters,  // get(index) function pointer
    resize_function__ObjectModelMsg__superquadric_parameters  // resize(index) function pointer
  },
  {
    "weight",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::msg::ObjectModelMsg, weight),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers ObjectModelMsg_message_members = {
  "rosee_msg::msg",  // message namespace
  "ObjectModelMsg",  // message name
  4,  // number of fields
  sizeof(rosee_msg::msg::ObjectModelMsg),
  ObjectModelMsg_message_member_array,  // message members
  ObjectModelMsg_init_function,  // function to initialize message memory (memory has to be allocated)
  ObjectModelMsg_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t ObjectModelMsg_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &ObjectModelMsg_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace rosee_msg


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<rosee_msg::msg::ObjectModelMsg>()
{
  return &::rosee_msg::msg::rosidl_typesupport_introspection_cpp::ObjectModelMsg_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, rosee_msg, msg, ObjectModelMsg)() {
  return &::rosee_msg::msg::rosidl_typesupport_introspection_cpp::ObjectModelMsg_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
