// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rosee_msg:msg/ROSEEActionControl.idl
// generated code does not contain a copyright notice
#include "rosee_msg/msg/detail/rosee_action_control__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `action_name`
// Member `selectable_items`
// Member `optional_motors_names`
#include "rosidl_runtime_c/string_functions.h"
// Member `optional_motors_commands`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
rosee_msg__msg__ROSEEActionControl__init(rosee_msg__msg__ROSEEActionControl * msg)
{
  if (!msg) {
    return false;
  }
  // seq
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    rosee_msg__msg__ROSEEActionControl__fini(msg);
    return false;
  }
  // action_name
  if (!rosidl_runtime_c__String__init(&msg->action_name)) {
    rosee_msg__msg__ROSEEActionControl__fini(msg);
    return false;
  }
  // action_type
  // action_primitive_type
  // selectable_items
  if (!rosidl_runtime_c__String__Sequence__init(&msg->selectable_items, 0)) {
    rosee_msg__msg__ROSEEActionControl__fini(msg);
    return false;
  }
  // percentage
  // error_norm
  // optional_motors_names
  if (!rosidl_runtime_c__String__Sequence__init(&msg->optional_motors_names, 0)) {
    rosee_msg__msg__ROSEEActionControl__fini(msg);
    return false;
  }
  // optional_motors_commands
  if (!rosidl_runtime_c__double__Sequence__init(&msg->optional_motors_commands, 0)) {
    rosee_msg__msg__ROSEEActionControl__fini(msg);
    return false;
  }
  return true;
}

void
rosee_msg__msg__ROSEEActionControl__fini(rosee_msg__msg__ROSEEActionControl * msg)
{
  if (!msg) {
    return;
  }
  // seq
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
  // action_name
  rosidl_runtime_c__String__fini(&msg->action_name);
  // action_type
  // action_primitive_type
  // selectable_items
  rosidl_runtime_c__String__Sequence__fini(&msg->selectable_items);
  // percentage
  // error_norm
  // optional_motors_names
  rosidl_runtime_c__String__Sequence__fini(&msg->optional_motors_names);
  // optional_motors_commands
  rosidl_runtime_c__double__Sequence__fini(&msg->optional_motors_commands);
}

bool
rosee_msg__msg__ROSEEActionControl__are_equal(const rosee_msg__msg__ROSEEActionControl * lhs, const rosee_msg__msg__ROSEEActionControl * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // seq
  if (lhs->seq != rhs->seq) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  // action_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->action_name), &(rhs->action_name)))
  {
    return false;
  }
  // action_type
  if (lhs->action_type != rhs->action_type) {
    return false;
  }
  // action_primitive_type
  if (lhs->action_primitive_type != rhs->action_primitive_type) {
    return false;
  }
  // selectable_items
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->selectable_items), &(rhs->selectable_items)))
  {
    return false;
  }
  // percentage
  if (lhs->percentage != rhs->percentage) {
    return false;
  }
  // error_norm
  if (lhs->error_norm != rhs->error_norm) {
    return false;
  }
  // optional_motors_names
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->optional_motors_names), &(rhs->optional_motors_names)))
  {
    return false;
  }
  // optional_motors_commands
  if (!rosidl_runtime_c__double__Sequence__are_equal(
      &(lhs->optional_motors_commands), &(rhs->optional_motors_commands)))
  {
    return false;
  }
  return true;
}

bool
rosee_msg__msg__ROSEEActionControl__copy(
  const rosee_msg__msg__ROSEEActionControl * input,
  rosee_msg__msg__ROSEEActionControl * output)
{
  if (!input || !output) {
    return false;
  }
  // seq
  output->seq = input->seq;
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  // action_name
  if (!rosidl_runtime_c__String__copy(
      &(input->action_name), &(output->action_name)))
  {
    return false;
  }
  // action_type
  output->action_type = input->action_type;
  // action_primitive_type
  output->action_primitive_type = input->action_primitive_type;
  // selectable_items
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->selectable_items), &(output->selectable_items)))
  {
    return false;
  }
  // percentage
  output->percentage = input->percentage;
  // error_norm
  output->error_norm = input->error_norm;
  // optional_motors_names
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->optional_motors_names), &(output->optional_motors_names)))
  {
    return false;
  }
  // optional_motors_commands
  if (!rosidl_runtime_c__double__Sequence__copy(
      &(input->optional_motors_commands), &(output->optional_motors_commands)))
  {
    return false;
  }
  return true;
}

rosee_msg__msg__ROSEEActionControl *
rosee_msg__msg__ROSEEActionControl__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__msg__ROSEEActionControl * msg = (rosee_msg__msg__ROSEEActionControl *)allocator.allocate(sizeof(rosee_msg__msg__ROSEEActionControl), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosee_msg__msg__ROSEEActionControl));
  bool success = rosee_msg__msg__ROSEEActionControl__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosee_msg__msg__ROSEEActionControl__destroy(rosee_msg__msg__ROSEEActionControl * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosee_msg__msg__ROSEEActionControl__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosee_msg__msg__ROSEEActionControl__Sequence__init(rosee_msg__msg__ROSEEActionControl__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__msg__ROSEEActionControl * data = NULL;

  if (size) {
    data = (rosee_msg__msg__ROSEEActionControl *)allocator.zero_allocate(size, sizeof(rosee_msg__msg__ROSEEActionControl), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosee_msg__msg__ROSEEActionControl__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosee_msg__msg__ROSEEActionControl__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosee_msg__msg__ROSEEActionControl__Sequence__fini(rosee_msg__msg__ROSEEActionControl__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosee_msg__msg__ROSEEActionControl__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosee_msg__msg__ROSEEActionControl__Sequence *
rosee_msg__msg__ROSEEActionControl__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__msg__ROSEEActionControl__Sequence * array = (rosee_msg__msg__ROSEEActionControl__Sequence *)allocator.allocate(sizeof(rosee_msg__msg__ROSEEActionControl__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosee_msg__msg__ROSEEActionControl__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosee_msg__msg__ROSEEActionControl__Sequence__destroy(rosee_msg__msg__ROSEEActionControl__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosee_msg__msg__ROSEEActionControl__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosee_msg__msg__ROSEEActionControl__Sequence__are_equal(const rosee_msg__msg__ROSEEActionControl__Sequence * lhs, const rosee_msg__msg__ROSEEActionControl__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosee_msg__msg__ROSEEActionControl__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosee_msg__msg__ROSEEActionControl__Sequence__copy(
  const rosee_msg__msg__ROSEEActionControl__Sequence * input,
  rosee_msg__msg__ROSEEActionControl__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosee_msg__msg__ROSEEActionControl);
    rosee_msg__msg__ROSEEActionControl * data =
      (rosee_msg__msg__ROSEEActionControl *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosee_msg__msg__ROSEEActionControl__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosee_msg__msg__ROSEEActionControl__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosee_msg__msg__ROSEEActionControl__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
