// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from rosee_msg:srv/HandInfo.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "rosee_msg/srv/detail/hand_info__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace rosee_msg
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

void HandInfo_Request_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) rosee_msg::srv::HandInfo_Request(_init);
}

void HandInfo_Request_fini_function(void * message_memory)
{
  auto typed_message = static_cast<rosee_msg::srv::HandInfo_Request *>(message_memory);
  typed_message->~HandInfo_Request();
}

size_t size_function__HandInfo_Request__motor_positions(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<float> *>(untyped_member);
  return member->size();
}

const void * get_const_function__HandInfo_Request__motor_positions(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<float> *>(untyped_member);
  return &member[index];
}

void * get_function__HandInfo_Request__motor_positions(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<float> *>(untyped_member);
  return &member[index];
}

void resize_function__HandInfo_Request__motor_positions(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<float> *>(untyped_member);
  member->resize(size);
}

size_t size_function__HandInfo_Request__motor_positions_reference(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<float> *>(untyped_member);
  return member->size();
}

const void * get_const_function__HandInfo_Request__motor_positions_reference(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<float> *>(untyped_member);
  return &member[index];
}

void * get_function__HandInfo_Request__motor_positions_reference(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<float> *>(untyped_member);
  return &member[index];
}

void resize_function__HandInfo_Request__motor_positions_reference(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<float> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember HandInfo_Request_message_member_array[3] = {
  {
    "motor_positions",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::srv::HandInfo_Request, motor_positions),  // bytes offset in struct
    nullptr,  // default value
    size_function__HandInfo_Request__motor_positions,  // size() function pointer
    get_const_function__HandInfo_Request__motor_positions,  // get_const(index) function pointer
    get_function__HandInfo_Request__motor_positions,  // get(index) function pointer
    resize_function__HandInfo_Request__motor_positions  // resize(index) function pointer
  },
  {
    "motor_positions_reference",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::srv::HandInfo_Request, motor_positions_reference),  // bytes offset in struct
    nullptr,  // default value
    size_function__HandInfo_Request__motor_positions_reference,  // size() function pointer
    get_const_function__HandInfo_Request__motor_positions_reference,  // get_const(index) function pointer
    get_function__HandInfo_Request__motor_positions_reference,  // get(index) function pointer
    resize_function__HandInfo_Request__motor_positions_reference  // resize(index) function pointer
  },
  {
    "finger_joint_positions",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<example_interfaces::msg::Float32MultiArray>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::srv::HandInfo_Request, finger_joint_positions),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers HandInfo_Request_message_members = {
  "rosee_msg::srv",  // message namespace
  "HandInfo_Request",  // message name
  3,  // number of fields
  sizeof(rosee_msg::srv::HandInfo_Request),
  HandInfo_Request_message_member_array,  // message members
  HandInfo_Request_init_function,  // function to initialize message memory (memory has to be allocated)
  HandInfo_Request_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t HandInfo_Request_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &HandInfo_Request_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace rosee_msg


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<rosee_msg::srv::HandInfo_Request>()
{
  return &::rosee_msg::srv::rosidl_typesupport_introspection_cpp::HandInfo_Request_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, rosee_msg, srv, HandInfo_Request)() {
  return &::rosee_msg::srv::rosidl_typesupport_introspection_cpp::HandInfo_Request_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include "array"
// already included above
// #include "cstddef"
// already included above
// #include "string"
// already included above
// #include "vector"
// already included above
// #include "rosidl_runtime_c/message_type_support_struct.h"
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "rosee_msg/srv/detail/hand_info__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/field_types.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace rosee_msg
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

void HandInfo_Response_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) rosee_msg::srv::HandInfo_Response(_init);
}

void HandInfo_Response_fini_function(void * message_memory)
{
  auto typed_message = static_cast<rosee_msg::srv::HandInfo_Response *>(message_memory);
  typed_message->~HandInfo_Response();
}

size_t size_function__HandInfo_Response__fingers_names(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<std::string> *>(untyped_member);
  return member->size();
}

const void * get_const_function__HandInfo_Response__fingers_names(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<std::string> *>(untyped_member);
  return &member[index];
}

void * get_function__HandInfo_Response__fingers_names(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<std::string> *>(untyped_member);
  return &member[index];
}

void resize_function__HandInfo_Response__fingers_names(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<std::string> *>(untyped_member);
  member->resize(size);
}

size_t size_function__HandInfo_Response__motors_names(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<std::string> *>(untyped_member);
  return member->size();
}

const void * get_const_function__HandInfo_Response__motors_names(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<std::string> *>(untyped_member);
  return &member[index];
}

void * get_function__HandInfo_Response__motors_names(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<std::string> *>(untyped_member);
  return &member[index];
}

void resize_function__HandInfo_Response__motors_names(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<std::string> *>(untyped_member);
  member->resize(size);
}

size_t size_function__HandInfo_Response__transmission_square_matrices(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<example_interfaces::msg::Float32MultiArray> *>(untyped_member);
  return member->size();
}

const void * get_const_function__HandInfo_Response__transmission_square_matrices(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<example_interfaces::msg::Float32MultiArray> *>(untyped_member);
  return &member[index];
}

void * get_function__HandInfo_Response__transmission_square_matrices(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<example_interfaces::msg::Float32MultiArray> *>(untyped_member);
  return &member[index];
}

void resize_function__HandInfo_Response__transmission_square_matrices(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<example_interfaces::msg::Float32MultiArray> *>(untyped_member);
  member->resize(size);
}

size_t size_function__HandInfo_Response__transmission_augmented_matrices(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<example_interfaces::msg::Float32MultiArray> *>(untyped_member);
  return member->size();
}

const void * get_const_function__HandInfo_Response__transmission_augmented_matrices(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<example_interfaces::msg::Float32MultiArray> *>(untyped_member);
  return &member[index];
}

void * get_function__HandInfo_Response__transmission_augmented_matrices(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<example_interfaces::msg::Float32MultiArray> *>(untyped_member);
  return &member[index];
}

void resize_function__HandInfo_Response__transmission_augmented_matrices(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<example_interfaces::msg::Float32MultiArray> *>(untyped_member);
  member->resize(size);
}

size_t size_function__HandInfo_Response__tips_jacobians_normal(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<example_interfaces::msg::Float32MultiArray> *>(untyped_member);
  return member->size();
}

const void * get_const_function__HandInfo_Response__tips_jacobians_normal(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<example_interfaces::msg::Float32MultiArray> *>(untyped_member);
  return &member[index];
}

void * get_function__HandInfo_Response__tips_jacobians_normal(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<example_interfaces::msg::Float32MultiArray> *>(untyped_member);
  return &member[index];
}

void resize_function__HandInfo_Response__tips_jacobians_normal(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<example_interfaces::msg::Float32MultiArray> *>(untyped_member);
  member->resize(size);
}

size_t size_function__HandInfo_Response__tips_jacobians_friction(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<example_interfaces::msg::Float32MultiArray> *>(untyped_member);
  return member->size();
}

const void * get_const_function__HandInfo_Response__tips_jacobians_friction(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<example_interfaces::msg::Float32MultiArray> *>(untyped_member);
  return &member[index];
}

void * get_function__HandInfo_Response__tips_jacobians_friction(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<example_interfaces::msg::Float32MultiArray> *>(untyped_member);
  return &member[index];
}

void resize_function__HandInfo_Response__tips_jacobians_friction(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<example_interfaces::msg::Float32MultiArray> *>(untyped_member);
  member->resize(size);
}

size_t size_function__HandInfo_Response__tips_forces_normal(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<float> *>(untyped_member);
  return member->size();
}

const void * get_const_function__HandInfo_Response__tips_forces_normal(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<float> *>(untyped_member);
  return &member[index];
}

void * get_function__HandInfo_Response__tips_forces_normal(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<float> *>(untyped_member);
  return &member[index];
}

void resize_function__HandInfo_Response__tips_forces_normal(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<float> *>(untyped_member);
  member->resize(size);
}

size_t size_function__HandInfo_Response__tips_forces_friction(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<float> *>(untyped_member);
  return member->size();
}

const void * get_const_function__HandInfo_Response__tips_forces_friction(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<float> *>(untyped_member);
  return &member[index];
}

void * get_function__HandInfo_Response__tips_forces_friction(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<float> *>(untyped_member);
  return &member[index];
}

void resize_function__HandInfo_Response__tips_forces_friction(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<float> *>(untyped_member);
  member->resize(size);
}

size_t size_function__HandInfo_Response__motors_stiffness(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<float> *>(untyped_member);
  return member->size();
}

const void * get_const_function__HandInfo_Response__motors_stiffness(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<float> *>(untyped_member);
  return &member[index];
}

void * get_function__HandInfo_Response__motors_stiffness(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<float> *>(untyped_member);
  return &member[index];
}

void resize_function__HandInfo_Response__motors_stiffness(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<float> *>(untyped_member);
  member->resize(size);
}

size_t size_function__HandInfo_Response__tips_frictions(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<float> *>(untyped_member);
  return member->size();
}

const void * get_const_function__HandInfo_Response__tips_frictions(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<float> *>(untyped_member);
  return &member[index];
}

void * get_function__HandInfo_Response__tips_frictions(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<float> *>(untyped_member);
  return &member[index];
}

void resize_function__HandInfo_Response__tips_frictions(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<float> *>(untyped_member);
  member->resize(size);
}

size_t size_function__HandInfo_Response__motors_torque_limits(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<float> *>(untyped_member);
  return member->size();
}

const void * get_const_function__HandInfo_Response__motors_torque_limits(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<float> *>(untyped_member);
  return &member[index];
}

void * get_function__HandInfo_Response__motors_torque_limits(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<float> *>(untyped_member);
  return &member[index];
}

void resize_function__HandInfo_Response__motors_torque_limits(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<float> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember HandInfo_Response_message_member_array[12] = {
  {
    "fingers_names",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::srv::HandInfo_Response, fingers_names),  // bytes offset in struct
    nullptr,  // default value
    size_function__HandInfo_Response__fingers_names,  // size() function pointer
    get_const_function__HandInfo_Response__fingers_names,  // get_const(index) function pointer
    get_function__HandInfo_Response__fingers_names,  // get(index) function pointer
    resize_function__HandInfo_Response__fingers_names  // resize(index) function pointer
  },
  {
    "motors_names",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::srv::HandInfo_Response, motors_names),  // bytes offset in struct
    nullptr,  // default value
    size_function__HandInfo_Response__motors_names,  // size() function pointer
    get_const_function__HandInfo_Response__motors_names,  // get_const(index) function pointer
    get_function__HandInfo_Response__motors_names,  // get(index) function pointer
    resize_function__HandInfo_Response__motors_names  // resize(index) function pointer
  },
  {
    "transmission_matrix",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<example_interfaces::msg::Float32MultiArray>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::srv::HandInfo_Response, transmission_matrix),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "transmission_square_matrices",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<example_interfaces::msg::Float32MultiArray>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::srv::HandInfo_Response, transmission_square_matrices),  // bytes offset in struct
    nullptr,  // default value
    size_function__HandInfo_Response__transmission_square_matrices,  // size() function pointer
    get_const_function__HandInfo_Response__transmission_square_matrices,  // get_const(index) function pointer
    get_function__HandInfo_Response__transmission_square_matrices,  // get(index) function pointer
    resize_function__HandInfo_Response__transmission_square_matrices  // resize(index) function pointer
  },
  {
    "transmission_augmented_matrices",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<example_interfaces::msg::Float32MultiArray>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::srv::HandInfo_Response, transmission_augmented_matrices),  // bytes offset in struct
    nullptr,  // default value
    size_function__HandInfo_Response__transmission_augmented_matrices,  // size() function pointer
    get_const_function__HandInfo_Response__transmission_augmented_matrices,  // get_const(index) function pointer
    get_function__HandInfo_Response__transmission_augmented_matrices,  // get(index) function pointer
    resize_function__HandInfo_Response__transmission_augmented_matrices  // resize(index) function pointer
  },
  {
    "tips_jacobians_normal",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<example_interfaces::msg::Float32MultiArray>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::srv::HandInfo_Response, tips_jacobians_normal),  // bytes offset in struct
    nullptr,  // default value
    size_function__HandInfo_Response__tips_jacobians_normal,  // size() function pointer
    get_const_function__HandInfo_Response__tips_jacobians_normal,  // get_const(index) function pointer
    get_function__HandInfo_Response__tips_jacobians_normal,  // get(index) function pointer
    resize_function__HandInfo_Response__tips_jacobians_normal  // resize(index) function pointer
  },
  {
    "tips_jacobians_friction",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<example_interfaces::msg::Float32MultiArray>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::srv::HandInfo_Response, tips_jacobians_friction),  // bytes offset in struct
    nullptr,  // default value
    size_function__HandInfo_Response__tips_jacobians_friction,  // size() function pointer
    get_const_function__HandInfo_Response__tips_jacobians_friction,  // get_const(index) function pointer
    get_function__HandInfo_Response__tips_jacobians_friction,  // get(index) function pointer
    resize_function__HandInfo_Response__tips_jacobians_friction  // resize(index) function pointer
  },
  {
    "tips_forces_normal",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::srv::HandInfo_Response, tips_forces_normal),  // bytes offset in struct
    nullptr,  // default value
    size_function__HandInfo_Response__tips_forces_normal,  // size() function pointer
    get_const_function__HandInfo_Response__tips_forces_normal,  // get_const(index) function pointer
    get_function__HandInfo_Response__tips_forces_normal,  // get(index) function pointer
    resize_function__HandInfo_Response__tips_forces_normal  // resize(index) function pointer
  },
  {
    "tips_forces_friction",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::srv::HandInfo_Response, tips_forces_friction),  // bytes offset in struct
    nullptr,  // default value
    size_function__HandInfo_Response__tips_forces_friction,  // size() function pointer
    get_const_function__HandInfo_Response__tips_forces_friction,  // get_const(index) function pointer
    get_function__HandInfo_Response__tips_forces_friction,  // get(index) function pointer
    resize_function__HandInfo_Response__tips_forces_friction  // resize(index) function pointer
  },
  {
    "motors_stiffness",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::srv::HandInfo_Response, motors_stiffness),  // bytes offset in struct
    nullptr,  // default value
    size_function__HandInfo_Response__motors_stiffness,  // size() function pointer
    get_const_function__HandInfo_Response__motors_stiffness,  // get_const(index) function pointer
    get_function__HandInfo_Response__motors_stiffness,  // get(index) function pointer
    resize_function__HandInfo_Response__motors_stiffness  // resize(index) function pointer
  },
  {
    "tips_frictions",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::srv::HandInfo_Response, tips_frictions),  // bytes offset in struct
    nullptr,  // default value
    size_function__HandInfo_Response__tips_frictions,  // size() function pointer
    get_const_function__HandInfo_Response__tips_frictions,  // get_const(index) function pointer
    get_function__HandInfo_Response__tips_frictions,  // get(index) function pointer
    resize_function__HandInfo_Response__tips_frictions  // resize(index) function pointer
  },
  {
    "motors_torque_limits",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rosee_msg::srv::HandInfo_Response, motors_torque_limits),  // bytes offset in struct
    nullptr,  // default value
    size_function__HandInfo_Response__motors_torque_limits,  // size() function pointer
    get_const_function__HandInfo_Response__motors_torque_limits,  // get_const(index) function pointer
    get_function__HandInfo_Response__motors_torque_limits,  // get(index) function pointer
    resize_function__HandInfo_Response__motors_torque_limits  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers HandInfo_Response_message_members = {
  "rosee_msg::srv",  // message namespace
  "HandInfo_Response",  // message name
  12,  // number of fields
  sizeof(rosee_msg::srv::HandInfo_Response),
  HandInfo_Response_message_member_array,  // message members
  HandInfo_Response_init_function,  // function to initialize message memory (memory has to be allocated)
  HandInfo_Response_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t HandInfo_Response_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &HandInfo_Response_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace rosee_msg


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<rosee_msg::srv::HandInfo_Response>()
{
  return &::rosee_msg::srv::rosidl_typesupport_introspection_cpp::HandInfo_Response_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, rosee_msg, srv, HandInfo_Response)() {
  return &::rosee_msg::srv::rosidl_typesupport_introspection_cpp::HandInfo_Response_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

#include "rosidl_runtime_c/service_type_support_struct.h"
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_cpp/service_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"
// already included above
// #include "rosee_msg/srv/detail/hand_info__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/service_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/service_type_support_decl.hpp"

namespace rosee_msg
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

// this is intentionally not const to allow initialization later to prevent an initialization race
static ::rosidl_typesupport_introspection_cpp::ServiceMembers HandInfo_service_members = {
  "rosee_msg::srv",  // service namespace
  "HandInfo",  // service name
  // these two fields are initialized below on the first access
  // see get_service_type_support_handle<rosee_msg::srv::HandInfo>()
  nullptr,  // request message
  nullptr  // response message
};

static const rosidl_service_type_support_t HandInfo_service_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &HandInfo_service_members,
  get_service_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace rosee_msg


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_service_type_support_t *
get_service_type_support_handle<rosee_msg::srv::HandInfo>()
{
  // get a handle to the value to be returned
  auto service_type_support =
    &::rosee_msg::srv::rosidl_typesupport_introspection_cpp::HandInfo_service_type_support_handle;
  // get a non-const and properly typed version of the data void *
  auto service_members = const_cast<::rosidl_typesupport_introspection_cpp::ServiceMembers *>(
    static_cast<const ::rosidl_typesupport_introspection_cpp::ServiceMembers *>(
      service_type_support->data));
  // make sure that both the request_members_ and the response_members_ are initialized
  // if they are not, initialize them
  if (
    service_members->request_members_ == nullptr ||
    service_members->response_members_ == nullptr)
  {
    // initialize the request_members_ with the static function from the external library
    service_members->request_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::rosee_msg::srv::HandInfo_Request
      >()->data
      );
    // initialize the response_members_ with the static function from the external library
    service_members->response_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::rosee_msg::srv::HandInfo_Response
      >()->data
      );
  }
  // finally return the properly initialized service_type_support handle
  return service_type_support;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_service_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, rosee_msg, srv, HandInfo)() {
  return ::rosidl_typesupport_introspection_cpp::get_service_type_support_handle<rosee_msg::srv::HandInfo>();
}

#ifdef __cplusplus
}
#endif
