// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rosee_msg:srv/NewGenericGraspingActionSrv.idl
// generated code does not contain a copyright notice
#include "rosee_msg/srv/detail/new_generic_grasping_action_srv__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `new_action`
#include "rosee_msg/msg/detail/new_generic_grasping_action__functions.h"

bool
rosee_msg__srv__NewGenericGraspingActionSrv_Request__init(rosee_msg__srv__NewGenericGraspingActionSrv_Request * msg)
{
  if (!msg) {
    return false;
  }
  // new_action
  if (!rosee_msg__msg__NewGenericGraspingAction__init(&msg->new_action)) {
    rosee_msg__srv__NewGenericGraspingActionSrv_Request__fini(msg);
    return false;
  }
  // emit_yaml
  return true;
}

void
rosee_msg__srv__NewGenericGraspingActionSrv_Request__fini(rosee_msg__srv__NewGenericGraspingActionSrv_Request * msg)
{
  if (!msg) {
    return;
  }
  // new_action
  rosee_msg__msg__NewGenericGraspingAction__fini(&msg->new_action);
  // emit_yaml
}

bool
rosee_msg__srv__NewGenericGraspingActionSrv_Request__are_equal(const rosee_msg__srv__NewGenericGraspingActionSrv_Request * lhs, const rosee_msg__srv__NewGenericGraspingActionSrv_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // new_action
  if (!rosee_msg__msg__NewGenericGraspingAction__are_equal(
      &(lhs->new_action), &(rhs->new_action)))
  {
    return false;
  }
  // emit_yaml
  if (lhs->emit_yaml != rhs->emit_yaml) {
    return false;
  }
  return true;
}

bool
rosee_msg__srv__NewGenericGraspingActionSrv_Request__copy(
  const rosee_msg__srv__NewGenericGraspingActionSrv_Request * input,
  rosee_msg__srv__NewGenericGraspingActionSrv_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // new_action
  if (!rosee_msg__msg__NewGenericGraspingAction__copy(
      &(input->new_action), &(output->new_action)))
  {
    return false;
  }
  // emit_yaml
  output->emit_yaml = input->emit_yaml;
  return true;
}

rosee_msg__srv__NewGenericGraspingActionSrv_Request *
rosee_msg__srv__NewGenericGraspingActionSrv_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__srv__NewGenericGraspingActionSrv_Request * msg = (rosee_msg__srv__NewGenericGraspingActionSrv_Request *)allocator.allocate(sizeof(rosee_msg__srv__NewGenericGraspingActionSrv_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosee_msg__srv__NewGenericGraspingActionSrv_Request));
  bool success = rosee_msg__srv__NewGenericGraspingActionSrv_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosee_msg__srv__NewGenericGraspingActionSrv_Request__destroy(rosee_msg__srv__NewGenericGraspingActionSrv_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosee_msg__srv__NewGenericGraspingActionSrv_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence__init(rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__srv__NewGenericGraspingActionSrv_Request * data = NULL;

  if (size) {
    data = (rosee_msg__srv__NewGenericGraspingActionSrv_Request *)allocator.zero_allocate(size, sizeof(rosee_msg__srv__NewGenericGraspingActionSrv_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosee_msg__srv__NewGenericGraspingActionSrv_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosee_msg__srv__NewGenericGraspingActionSrv_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence__fini(rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosee_msg__srv__NewGenericGraspingActionSrv_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence *
rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence * array = (rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence *)allocator.allocate(sizeof(rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence__destroy(rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence__are_equal(const rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence * lhs, const rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosee_msg__srv__NewGenericGraspingActionSrv_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence__copy(
  const rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence * input,
  rosee_msg__srv__NewGenericGraspingActionSrv_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosee_msg__srv__NewGenericGraspingActionSrv_Request);
    rosee_msg__srv__NewGenericGraspingActionSrv_Request * data =
      (rosee_msg__srv__NewGenericGraspingActionSrv_Request *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosee_msg__srv__NewGenericGraspingActionSrv_Request__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosee_msg__srv__NewGenericGraspingActionSrv_Request__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosee_msg__srv__NewGenericGraspingActionSrv_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `error_msg`
#include "rosidl_runtime_c/string_functions.h"

bool
rosee_msg__srv__NewGenericGraspingActionSrv_Response__init(rosee_msg__srv__NewGenericGraspingActionSrv_Response * msg)
{
  if (!msg) {
    return false;
  }
  // accepted
  // emitted
  // error_msg
  if (!rosidl_runtime_c__String__init(&msg->error_msg)) {
    rosee_msg__srv__NewGenericGraspingActionSrv_Response__fini(msg);
    return false;
  }
  return true;
}

void
rosee_msg__srv__NewGenericGraspingActionSrv_Response__fini(rosee_msg__srv__NewGenericGraspingActionSrv_Response * msg)
{
  if (!msg) {
    return;
  }
  // accepted
  // emitted
  // error_msg
  rosidl_runtime_c__String__fini(&msg->error_msg);
}

bool
rosee_msg__srv__NewGenericGraspingActionSrv_Response__are_equal(const rosee_msg__srv__NewGenericGraspingActionSrv_Response * lhs, const rosee_msg__srv__NewGenericGraspingActionSrv_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // accepted
  if (lhs->accepted != rhs->accepted) {
    return false;
  }
  // emitted
  if (lhs->emitted != rhs->emitted) {
    return false;
  }
  // error_msg
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->error_msg), &(rhs->error_msg)))
  {
    return false;
  }
  return true;
}

bool
rosee_msg__srv__NewGenericGraspingActionSrv_Response__copy(
  const rosee_msg__srv__NewGenericGraspingActionSrv_Response * input,
  rosee_msg__srv__NewGenericGraspingActionSrv_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // accepted
  output->accepted = input->accepted;
  // emitted
  output->emitted = input->emitted;
  // error_msg
  if (!rosidl_runtime_c__String__copy(
      &(input->error_msg), &(output->error_msg)))
  {
    return false;
  }
  return true;
}

rosee_msg__srv__NewGenericGraspingActionSrv_Response *
rosee_msg__srv__NewGenericGraspingActionSrv_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__srv__NewGenericGraspingActionSrv_Response * msg = (rosee_msg__srv__NewGenericGraspingActionSrv_Response *)allocator.allocate(sizeof(rosee_msg__srv__NewGenericGraspingActionSrv_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosee_msg__srv__NewGenericGraspingActionSrv_Response));
  bool success = rosee_msg__srv__NewGenericGraspingActionSrv_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosee_msg__srv__NewGenericGraspingActionSrv_Response__destroy(rosee_msg__srv__NewGenericGraspingActionSrv_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosee_msg__srv__NewGenericGraspingActionSrv_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence__init(rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__srv__NewGenericGraspingActionSrv_Response * data = NULL;

  if (size) {
    data = (rosee_msg__srv__NewGenericGraspingActionSrv_Response *)allocator.zero_allocate(size, sizeof(rosee_msg__srv__NewGenericGraspingActionSrv_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosee_msg__srv__NewGenericGraspingActionSrv_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosee_msg__srv__NewGenericGraspingActionSrv_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence__fini(rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosee_msg__srv__NewGenericGraspingActionSrv_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence *
rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence * array = (rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence *)allocator.allocate(sizeof(rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence__destroy(rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence__are_equal(const rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence * lhs, const rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosee_msg__srv__NewGenericGraspingActionSrv_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence__copy(
  const rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence * input,
  rosee_msg__srv__NewGenericGraspingActionSrv_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosee_msg__srv__NewGenericGraspingActionSrv_Response);
    rosee_msg__srv__NewGenericGraspingActionSrv_Response * data =
      (rosee_msg__srv__NewGenericGraspingActionSrv_Response *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosee_msg__srv__NewGenericGraspingActionSrv_Response__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosee_msg__srv__NewGenericGraspingActionSrv_Response__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosee_msg__srv__NewGenericGraspingActionSrv_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
