// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rosee_msg:srv/SelectablePairInfo.idl
// generated code does not contain a copyright notice
#include "rosee_msg/srv/detail/selectable_pair_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `action_name`
// Member `element_name`
#include "rosidl_runtime_c/string_functions.h"

bool
rosee_msg__srv__SelectablePairInfo_Request__init(rosee_msg__srv__SelectablePairInfo_Request * msg)
{
  if (!msg) {
    return false;
  }
  // action_name
  if (!rosidl_runtime_c__String__init(&msg->action_name)) {
    rosee_msg__srv__SelectablePairInfo_Request__fini(msg);
    return false;
  }
  // element_name
  if (!rosidl_runtime_c__String__init(&msg->element_name)) {
    rosee_msg__srv__SelectablePairInfo_Request__fini(msg);
    return false;
  }
  return true;
}

void
rosee_msg__srv__SelectablePairInfo_Request__fini(rosee_msg__srv__SelectablePairInfo_Request * msg)
{
  if (!msg) {
    return;
  }
  // action_name
  rosidl_runtime_c__String__fini(&msg->action_name);
  // element_name
  rosidl_runtime_c__String__fini(&msg->element_name);
}

bool
rosee_msg__srv__SelectablePairInfo_Request__are_equal(const rosee_msg__srv__SelectablePairInfo_Request * lhs, const rosee_msg__srv__SelectablePairInfo_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // action_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->action_name), &(rhs->action_name)))
  {
    return false;
  }
  // element_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->element_name), &(rhs->element_name)))
  {
    return false;
  }
  return true;
}

bool
rosee_msg__srv__SelectablePairInfo_Request__copy(
  const rosee_msg__srv__SelectablePairInfo_Request * input,
  rosee_msg__srv__SelectablePairInfo_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // action_name
  if (!rosidl_runtime_c__String__copy(
      &(input->action_name), &(output->action_name)))
  {
    return false;
  }
  // element_name
  if (!rosidl_runtime_c__String__copy(
      &(input->element_name), &(output->element_name)))
  {
    return false;
  }
  return true;
}

rosee_msg__srv__SelectablePairInfo_Request *
rosee_msg__srv__SelectablePairInfo_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__srv__SelectablePairInfo_Request * msg = (rosee_msg__srv__SelectablePairInfo_Request *)allocator.allocate(sizeof(rosee_msg__srv__SelectablePairInfo_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosee_msg__srv__SelectablePairInfo_Request));
  bool success = rosee_msg__srv__SelectablePairInfo_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosee_msg__srv__SelectablePairInfo_Request__destroy(rosee_msg__srv__SelectablePairInfo_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosee_msg__srv__SelectablePairInfo_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosee_msg__srv__SelectablePairInfo_Request__Sequence__init(rosee_msg__srv__SelectablePairInfo_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__srv__SelectablePairInfo_Request * data = NULL;

  if (size) {
    data = (rosee_msg__srv__SelectablePairInfo_Request *)allocator.zero_allocate(size, sizeof(rosee_msg__srv__SelectablePairInfo_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosee_msg__srv__SelectablePairInfo_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosee_msg__srv__SelectablePairInfo_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosee_msg__srv__SelectablePairInfo_Request__Sequence__fini(rosee_msg__srv__SelectablePairInfo_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosee_msg__srv__SelectablePairInfo_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosee_msg__srv__SelectablePairInfo_Request__Sequence *
rosee_msg__srv__SelectablePairInfo_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__srv__SelectablePairInfo_Request__Sequence * array = (rosee_msg__srv__SelectablePairInfo_Request__Sequence *)allocator.allocate(sizeof(rosee_msg__srv__SelectablePairInfo_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosee_msg__srv__SelectablePairInfo_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosee_msg__srv__SelectablePairInfo_Request__Sequence__destroy(rosee_msg__srv__SelectablePairInfo_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosee_msg__srv__SelectablePairInfo_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosee_msg__srv__SelectablePairInfo_Request__Sequence__are_equal(const rosee_msg__srv__SelectablePairInfo_Request__Sequence * lhs, const rosee_msg__srv__SelectablePairInfo_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosee_msg__srv__SelectablePairInfo_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosee_msg__srv__SelectablePairInfo_Request__Sequence__copy(
  const rosee_msg__srv__SelectablePairInfo_Request__Sequence * input,
  rosee_msg__srv__SelectablePairInfo_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosee_msg__srv__SelectablePairInfo_Request);
    rosee_msg__srv__SelectablePairInfo_Request * data =
      (rosee_msg__srv__SelectablePairInfo_Request *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosee_msg__srv__SelectablePairInfo_Request__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosee_msg__srv__SelectablePairInfo_Request__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosee_msg__srv__SelectablePairInfo_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `pair_elements`
// already included above
// #include "rosidl_runtime_c/string_functions.h"

bool
rosee_msg__srv__SelectablePairInfo_Response__init(rosee_msg__srv__SelectablePairInfo_Response * msg)
{
  if (!msg) {
    return false;
  }
  // pair_elements
  if (!rosidl_runtime_c__String__Sequence__init(&msg->pair_elements, 0)) {
    rosee_msg__srv__SelectablePairInfo_Response__fini(msg);
    return false;
  }
  return true;
}

void
rosee_msg__srv__SelectablePairInfo_Response__fini(rosee_msg__srv__SelectablePairInfo_Response * msg)
{
  if (!msg) {
    return;
  }
  // pair_elements
  rosidl_runtime_c__String__Sequence__fini(&msg->pair_elements);
}

bool
rosee_msg__srv__SelectablePairInfo_Response__are_equal(const rosee_msg__srv__SelectablePairInfo_Response * lhs, const rosee_msg__srv__SelectablePairInfo_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // pair_elements
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->pair_elements), &(rhs->pair_elements)))
  {
    return false;
  }
  return true;
}

bool
rosee_msg__srv__SelectablePairInfo_Response__copy(
  const rosee_msg__srv__SelectablePairInfo_Response * input,
  rosee_msg__srv__SelectablePairInfo_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // pair_elements
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->pair_elements), &(output->pair_elements)))
  {
    return false;
  }
  return true;
}

rosee_msg__srv__SelectablePairInfo_Response *
rosee_msg__srv__SelectablePairInfo_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__srv__SelectablePairInfo_Response * msg = (rosee_msg__srv__SelectablePairInfo_Response *)allocator.allocate(sizeof(rosee_msg__srv__SelectablePairInfo_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosee_msg__srv__SelectablePairInfo_Response));
  bool success = rosee_msg__srv__SelectablePairInfo_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosee_msg__srv__SelectablePairInfo_Response__destroy(rosee_msg__srv__SelectablePairInfo_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosee_msg__srv__SelectablePairInfo_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosee_msg__srv__SelectablePairInfo_Response__Sequence__init(rosee_msg__srv__SelectablePairInfo_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__srv__SelectablePairInfo_Response * data = NULL;

  if (size) {
    data = (rosee_msg__srv__SelectablePairInfo_Response *)allocator.zero_allocate(size, sizeof(rosee_msg__srv__SelectablePairInfo_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosee_msg__srv__SelectablePairInfo_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosee_msg__srv__SelectablePairInfo_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosee_msg__srv__SelectablePairInfo_Response__Sequence__fini(rosee_msg__srv__SelectablePairInfo_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosee_msg__srv__SelectablePairInfo_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosee_msg__srv__SelectablePairInfo_Response__Sequence *
rosee_msg__srv__SelectablePairInfo_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosee_msg__srv__SelectablePairInfo_Response__Sequence * array = (rosee_msg__srv__SelectablePairInfo_Response__Sequence *)allocator.allocate(sizeof(rosee_msg__srv__SelectablePairInfo_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosee_msg__srv__SelectablePairInfo_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosee_msg__srv__SelectablePairInfo_Response__Sequence__destroy(rosee_msg__srv__SelectablePairInfo_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosee_msg__srv__SelectablePairInfo_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosee_msg__srv__SelectablePairInfo_Response__Sequence__are_equal(const rosee_msg__srv__SelectablePairInfo_Response__Sequence * lhs, const rosee_msg__srv__SelectablePairInfo_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosee_msg__srv__SelectablePairInfo_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosee_msg__srv__SelectablePairInfo_Response__Sequence__copy(
  const rosee_msg__srv__SelectablePairInfo_Response__Sequence * input,
  rosee_msg__srv__SelectablePairInfo_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosee_msg__srv__SelectablePairInfo_Response);
    rosee_msg__srv__SelectablePairInfo_Response * data =
      (rosee_msg__srv__SelectablePairInfo_Response *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosee_msg__srv__SelectablePairInfo_Response__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosee_msg__srv__SelectablePairInfo_Response__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosee_msg__srv__SelectablePairInfo_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
