// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rosee_msg:srv/SelectablePairInfo.idl
// generated code does not contain a copyright notice

#ifndef ROSEE_MSG__SRV__DETAIL__SELECTABLE_PAIR_INFO__STRUCT_HPP_
#define ROSEE_MSG__SRV__DETAIL__SELECTABLE_PAIR_INFO__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__rosee_msg__srv__SelectablePairInfo_Request __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__srv__SelectablePairInfo_Request __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SelectablePairInfo_Request_
{
  using Type = SelectablePairInfo_Request_<ContainerAllocator>;

  explicit SelectablePairInfo_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->action_name = "";
      this->element_name = "";
    }
  }

  explicit SelectablePairInfo_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : action_name(_alloc),
    element_name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->action_name = "";
      this->element_name = "";
    }
  }

  // field types and members
  using _action_name_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _action_name_type action_name;
  using _element_name_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _element_name_type element_name;

  // setters for named parameter idiom
  Type & set__action_name(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->action_name = _arg;
    return *this;
  }
  Type & set__element_name(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->element_name = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosee_msg::srv::SelectablePairInfo_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::srv::SelectablePairInfo_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::srv::SelectablePairInfo_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::srv::SelectablePairInfo_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::srv::SelectablePairInfo_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::srv::SelectablePairInfo_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::srv::SelectablePairInfo_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::srv::SelectablePairInfo_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::srv::SelectablePairInfo_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::srv::SelectablePairInfo_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__srv__SelectablePairInfo_Request
    std::shared_ptr<rosee_msg::srv::SelectablePairInfo_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__srv__SelectablePairInfo_Request
    std::shared_ptr<rosee_msg::srv::SelectablePairInfo_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SelectablePairInfo_Request_ & other) const
  {
    if (this->action_name != other.action_name) {
      return false;
    }
    if (this->element_name != other.element_name) {
      return false;
    }
    return true;
  }
  bool operator!=(const SelectablePairInfo_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SelectablePairInfo_Request_

// alias to use template instance with default allocator
using SelectablePairInfo_Request =
  rosee_msg::srv::SelectablePairInfo_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rosee_msg


#ifndef _WIN32
# define DEPRECATED__rosee_msg__srv__SelectablePairInfo_Response __attribute__((deprecated))
#else
# define DEPRECATED__rosee_msg__srv__SelectablePairInfo_Response __declspec(deprecated)
#endif

namespace rosee_msg
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SelectablePairInfo_Response_
{
  using Type = SelectablePairInfo_Response_<ContainerAllocator>;

  explicit SelectablePairInfo_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit SelectablePairInfo_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _pair_elements_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _pair_elements_type pair_elements;

  // setters for named parameter idiom
  Type & set__pair_elements(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->pair_elements = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosee_msg::srv::SelectablePairInfo_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosee_msg::srv::SelectablePairInfo_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosee_msg::srv::SelectablePairInfo_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosee_msg::srv::SelectablePairInfo_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosee_msg::srv::SelectablePairInfo_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::srv::SelectablePairInfo_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosee_msg::srv::SelectablePairInfo_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosee_msg::srv::SelectablePairInfo_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosee_msg::srv::SelectablePairInfo_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosee_msg::srv::SelectablePairInfo_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosee_msg__srv__SelectablePairInfo_Response
    std::shared_ptr<rosee_msg::srv::SelectablePairInfo_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosee_msg__srv__SelectablePairInfo_Response
    std::shared_ptr<rosee_msg::srv::SelectablePairInfo_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SelectablePairInfo_Response_ & other) const
  {
    if (this->pair_elements != other.pair_elements) {
      return false;
    }
    return true;
  }
  bool operator!=(const SelectablePairInfo_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SelectablePairInfo_Response_

// alias to use template instance with default allocator
using SelectablePairInfo_Response =
  rosee_msg::srv::SelectablePairInfo_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rosee_msg

namespace rosee_msg
{

namespace srv
{

struct SelectablePairInfo
{
  using Request = rosee_msg::srv::SelectablePairInfo_Request;
  using Response = rosee_msg::srv::SelectablePairInfo_Response;
};

}  // namespace srv

}  // namespace rosee_msg

#endif  // ROSEE_MSG__SRV__DETAIL__SELECTABLE_PAIR_INFO__STRUCT_HPP_
